<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Crud_model extends CI_Model {

    function __construct()
    {
        parent::__construct();
    }

    function clear_cache()
    {
        $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
        $this->output->set_header('Pragma: no-cache');
    }
    function get_type_name_by_id($type,$type_id='',$field='name')
    {
        return	$this->db->get_where($type,array($type.'_id'=>$type_id))->row()->$field;
    }


    /////////ADMIN/////////////
    function get_admin()
    {
        $query	=	$this->db->get('admin' );
        return $query->result_array();
    }
    function get_admin_info($admin_id)
    {
        $query	=	$this->db->get_where('admin' , array('admin_id' => $admin_id));
        return $query->result_array();
    }
    function get_name_by_admin($admin_id,$field='name')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$admin_id))->row()->$field;
    }
    function get_email_by_admin($admin_id,$field='email')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$admin_id))->row()->$field;
    }
    
        function count_client_ativo()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as clientes_ativos
          FROM
            client_status
          WHERE
          STATUS in ("ativo", "inadimplente")')->row()->clientes_ativos;
    }
        /*function count_client_fatorR()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as clientes_ativos
          FROM
            client_status
          WHERE
          STATUS in ("ativo", "inadimplente")')->row()->clientes_ativos;
    }     */

        function count_client_cancelados()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as clientes_cancelados
          FROM
            client_status
          WHERE
          STATUS = "cancelado"')->row()->clientes_cancelados;
    }
    
      function count_client_bloqueados()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as client_bloqueados
          FROM
            client_status
          WHERE
          STATUS = "bloqueado"')->row()->client_bloqueados;
    }
    
         function count_client_inadimplente()
    {
        return @$this->db->query('
          SELECT count(alterdata) FROM w_mensalidade_zoop WHERE cliente_status = "inadimplente"')->row()->client_inadimplente;
    }     
        
    
         function get_client_inadimplente()
    {
        return @$this->db->query('
          SELECT
            *
          FROM
            w_mensalidade_zoop
          WHERE
          cliente_status = "inadimplente"')->result_array();
    }      
    
       
    function get_client_ativo()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as clientes_ativos
          FROM
            client_status
          WHERE
          STATUS <> "cancelado"')->row()->clientes_ativos;
    }
    
        function get_client_cancelados()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as clientes_cancelados
          FROM
            client_status
          WHERE
          STATUS = "cancelado"')->row()->clientes_cancelados;
    }
    
      function get_client_bloqueados()
    {
        return @$this->db->query('
          SELECT
            COUNT("client_id") as client_bloqueados
          FROM
            client_status
          WHERE
          STATUS = "bloqueado"')->row()->client_bloqueados;
    }
    


          function count_client_retroativo()
    {
        return @$this->db->query('
          SELECT
          COUNT(*) as contabilidade_retroativo, 
            cg.*, cs.client_id, cs.alterdata, cs.email 
          FROM 
            client_config cg JOIN w_client_status cs ON cs.client_id = cg.client 
          WHERE 
            cg.permite_retroativo = "S"
          AND
            cs.status = "ativo" ')->row()->contabilidade_retroativo;
    }


          function get_client_retroativo()
    {
        return @$this->db->query('
          SELECT 
            cg.*, cs.client_id, cs.alterdata, cs.email, cs.name 
          FROM 
            client_config cg JOIN w_client_status cs ON cs.client_id = cg.client 
          WHERE 
            cg.permite_retroativo = "S" 
            AND
            cs.status ="ativo" ')->result_array();
    }



    ///////// DASHBOARD /////////////
    function get_count_message($client_id)
    {
        $this->db->count_all_results('message');  // Produces an integer, like 25
        $this->db->where('sender', $client_id);
        $this->db->from('message');

        return	$this->db->count_all_results();
    }
    function get_count_cobranca($client_id)
    {
        $contador = 0;
        $data_atual = date('Y-m-d');
        
        $this->db->count_all_results('files');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->where('product', '60'); 
        $this->db->where('ind_up', 'C');
        $this->db->where('status !=', 'pago');
        $this->db->where('status !=', 'cancelado');
        $this->db->where('status !=', 'pago + nf salva');
        $this->db->where('data_venc <=', $data_atual);
        $this->db->from('files');
        
        $contador =  @$this->db->count_all_results();
        
        $this->db->count_all_results('w_cliente_mensalidade_aviso');  // Produces an integer, like 25
        $this->db->where('cliente', $client_id);
        $this->db->where('status_boleto !=', 'pago');
        $this->db->where('status_boleto !=', 'cancelado');
        $this->db->where('status_boleto !=', 'pago + nf salva');
        $this->db->where('dias_vencido >=', 1);
        $this->db->from('w_cliente_mensalidade_aviso');
        
        $contador =  $contador +  @$this->db->count_all_results();
        

        return	$contador;
    }

    function get_boleto_aberto($client_id)
    {
        $contador = 0;
        $data_atual = date('Y-m-d');
        
        $this->db->count_all_results('files');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->where('product', '60'); 
        $this->db->where('ind_up', 'C');
        $this->db->where('status', 'a pagar');
        $this->db->where('data_venc >=', $data_atual);
        $this->db->from('files');
        
        $contador =  $contador +  @$this->db->count_all_results();
        

        return	$contador;
    }
    function get_count_notificacao_extra($client_id)
    {
        $contador = 0;
        //$data_atual = date('Y-m-d');
        $XQuery = "select count($client_id) as qtde from client_notificacao_extra where cliente='".$client_id."' and status in ('A','P')";
        $contador = @$this->db->query($XQuery)->row()->qtde;        

        //print $contador;
        return	$contador;
    }

    function get_mensagem_notificacao_extra($client_id,$field='mensagem')
    {
        $XQuery = "select mensagem from client_notificacao_extra where cliente='".$client_id."' and status = 'A' order by client_notificacao_extra_id limit 1";
        $mensagem = @$this->db->query($XQuery)->row()->$field;  
        
        //return	@$this->db->get_where('client_notificacao_extra',array('cliente'=>$client_id,'status'=>'A'))->row()->$field;
        return	$mensagem;
    }

    function get_mensagem_notificacao_extra_id($client_id,$field='client_notificacao_extra_id')
    {
        $XQuery = "select client_notificacao_extra_id from client_notificacao_extra where cliente='".$client_id."' and status = 'A' order by client_notificacao_extra_id limit 1";
        $mensagem = @$this->db->query($XQuery)->row()->$field;  
        
        //return	@$this->db->get_where('client_notificacao_extra',array('cliente'=>$client_id,'status'=>'A'))->row()->$field;
        return	$mensagem;
    }    

    /////////BULK_MAIL/////////////
    function get_bulk_mail()
    {
        $query	=	$this->db->get('bulk_mail' );
        return $query->result_array();
    }
    function get_bulk_mail_info($bulk_mail_id)
    {
        $query	=	$this->db->get_where('bulk_mail' , array('bulk_mail_id' => $bulk_mail_id));
        return $query->result_array();
    }

    /////////CATEGORY/////////////
    function get_category()
    {
        $query	=	$this->db->get('category' );
        return $query->result_array();
    }
    function get_category_info($category_id)
    {
        $query	=	$this->db->get_where('category' , array('category_id' => $category_id));
        return $query->result_array();
    }
    function get_category_name_by_id($category_id)
    {
        $query	=	$this->db->get_where('category' , array('category_id' => $category_id));
        return $query->result_array();
    }
    function get_category_ordenada($ind_client)
    {
        $this->db->order_by('ordem', 'ASC');
        $this->db->order_by('name', 'ASC');
        $query	=	$this->db->get_where('category',array('ind_client' => $ind_client));

        return $query->result_array();
    }
    
    /////////ENOTAS/////////////
    function get_empresa_info($client_id)
    {
        $query = $this->db->get_where('w_client_status' , array('client_id' => $client_id));
        return $query->row();
    }
    function is_client_enotas($client_id)
    {
        $query = $this->db->get_where('client_enotas', array('cliente' => $client_id));
        if(count($query->row()) != 0) {
            return true;
        }
    }
    function get_enotas_id_by_client($client_id)
    {
        $query = $this->db->get_where('client_enotas' , array('cliente' => $client_id));
        $empresa = $query->row();
        return $empresa->enotas_id;        
    }
    function get_cert_digital_by_client($client_id)
    {
        $query = $this->db->get_where('client_certificado' , array('cliente' => $client_id));
        return $query->row();        
    }
    
    function count_certificado_ativo()
    {
        $data = date('Y-m-d');
        $data_anterior = date('Y-m-d', strtotime("-1 year"));
        return @$this->db->query("
        SELECT  
          COUNT('a.certificado') as certificados  
        FROM 
          client_certificado a join client b on a.cliente=b.client_id 
        WHERE a.data_emissao > '" .$data_anterior."' 
        AND 
        a.data_venc > '".$data."'")->row()->certificados;
    }     
    
    function get_cnae_principal($cnpj)
    {
        $empresa_info = file_get_contents('https://www.receitaws.com.br/v1/cnpj/'.$cnpj);
        
        $obj = get_object_vars(json_decode($empresa_info));
        $cnae_principal = get_object_vars($obj['atividade_principal'][0]);
        return $cnae_principal;
    }
    
    function cidade_smu($cod_ibge) {
        $curl = curl_init();
        
        curl_setopt_array($curl, array(
          CURLOPT_URL => 'https://api.enotasgw.com.br/v1/servicos/cidades?pageNumber=0&pageSize=300',
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'GET',
          CURLOPT_HTTPHEADER => array(
            'Accept: application/json',
            'Authorization: Basic OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw'
          ),
        ));
        
        $response = json_decode(curl_exec($curl));
        
        curl_close($curl);
        
        $teste = get_object_vars($response);
        
        $data = $teste['data'];
        
        $lista_ibge = array();
        for($i = 0;$i < count($data);$i++) {
            $lista_ibge[] = $data[$i]->codigoIbge; 
        }
                
        foreach($lista_ibge as $row) {
            if($row == $cod_ibge) {
                return true;
            }
        }
        
        return false;        
    } 

    /////////CLIENT/////////////
    function get_client()
    {
        $query	=	$this->db->get('client');
        return $query->result_array();
    }
    function get_client_info($client_id)
    {
        $query	=	$this->db->get_where('client' , array('client_id' => $client_id));
        return $query->result_array();
    }  
    function get_status_client_id($client_id,$field='status')
    {
        return	$this->db->get_where('client_status',array('client'=>$client_id))->row()->$field;
    }  
    function get_name_by_client($client_id,$field='name')
    {
        return @$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function retira_acento($name) {
        $comAcentos = array('à', 'á', 'â', 'ã', 'ä', 'å', 'ç', 'è', 'é', 'ê', 'ë', 'ì', 'í', 'î', 'ï', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', 'ù', 'ü', 'ú', 'ÿ', 'À', 'Á', 'Â', 'Ã', 'Ä', 'Å', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í', 'Î', 'Ï', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', 'O', 'Ù', 'Ü', 'Ú');
        
        $semAcentos = array('a', 'a', 'a', 'a', 'a', 'a', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'i', 'n', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'y', 'A', 'A', 'A', 'A', 'A', 'A', 'C', 'E', 'E', 'E', 'E', 'I', 'I', 'I', 'I', 'N', 'O', 'O', 'O', 'O', 'O', '0', 'U', 'U', 'U');
    
        return $novo_nome = str_replace($comAcentos, $semAcentos, strtolower($name));
    }
    function get_client_pj_pf($client_id,$field='pj_pf')
    {
        return	@$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_cnpj_cpf_by_client($client_id,$field='cnpj_cpf')
    {
        return	@$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_usa_dp($client_id,$field='usa_dp')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_usa_nota_fiscal($client_id,$field='usa_nota_fiscal')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_alterdata_by_client($client_id,$field='alterdata')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_email_by_client($client_id,$field='email')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_client_aliquota_iss($client_id,$field='aliquota_iss')
    {
        return $this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    // wrp - 2020-09-11
    function get_ibge_by_client($client_id,$field='cod_ibge')
    {
        return $this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }    
    function get_log_acesso($client_id)
    {
        //$this->db->count_all_results('log_acesso');
        $this->db->where('user', $client_id);
        $this->db->where('tipo =', 'accesso');
        $this->db->from('log_acesso');

        return	$this->db->count_all_results();
    }
    function get_ultimo_acesso($client_id,$field='ultimo_acesso')
    {
       return $this->db->get_where('w_log_ultimo_acesso_cliente',array('client'=>$client_id))->row()->$field;
    }
    ///////// Client Sócio /////////////
    function get_count_socio($client_id)
    {
        //$this->db->count_all_results('client_socio');  // Produces an integer, like 25
        $this->db->where('client_socio_id', $client_id);
        $this->db->from('client_socio');

        return	$this->db->count_all_results();
    }
    function get_client_socio_info($client_socio_id)
    {

        $query	=	$this->db->get_where('client_socio' , array('client_socio_id' => $client_socio_id));

        return $query->result_array();
    }
    function get_all_client_socio_info($client_id)
    {
        $query	=	$this->db->get_where('client_socio' , array('client' => $client_id));

        return $query->result_array();
    }
    function get_nome_by_client_socio($client_id,$field='name')
    {
        return	@$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    function get_cnpj_cpf_by_client_socio($client_id,$field='cnpj_cpf')
    {
        return	@$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    function get_id_by_client_socio($client_id,$field='cliente_socio')
    {
        return	@$this->db->get_where('w_client_socio_resp_cnpj',array('client'=>$client_id))->row()->$field;
    }
    //////// Cliente Atividade /////////////
    function get_client_atividade_desc($cae,$field='descricao')
    {
        return @$this->db->get_where('tb_ex_cae',array('cae'=>$cae))->row()->$field;
    }
    //////// Cliente Certificado /////////////
    function certificado_existente($caminho)
    {
        $query = $this->db->get_where('client_certificado', array('caminho' => $caminho));
        
        if(count($query->result_array()) > 0) {
            return true;
        } else {
            return false;
        }
    }    
    //////// Cliente Cnae /////////////
    function get_client_cnae_desc($cnae,$field='descricao')
    {
        return $this->db->get_where('tb_ex_cnae',array('cnae'=>$cnae))->row()->$field;
    }
    ///////// Dest Cliente - Meus Clientes /////////////
    function get_client_dest_cliente_all_info($client_id)
    {

        $query	=	$this->db->get_where('dest_cliente' , array('cliente' => $client_id));

        return $query->result_array();
    }
    function get_client_dest_cliente_info($dest_client_id)
    {

        $query	=	$this->db->get_where('dest_cliente' , array('dest_cliente_id' => $dest_client_id));

        return $query->result_array();
    }
    function get_name_by_dest_client($dest_cliente_id,$field='dest_cliente')
    {
        return	$this->db->get_where('dest_cliente',array('dest_cliente_id'=>$dest_cliente_id))->row()->$field;
    }
    //////// Cliente Configurações /////////////
    function get_client_config_permite_retroativo($cliente,$field='permite_retroativo')
    {
        return $this->db->get_where('client_config',array('client'=>$cliente))->row()->$field;
    }
    ///////// Funcionário /////////////
    function get_funcionario_info($dp_funcionario_id)
    {

        $query	=	$this->db->get_where('dp_funcionario' , array('dp_funcionario_id' => $dp_funcionario_id));

        return $query->result_array();
    }
    function get_funcionario_status($status)
    {

        switch ($status){
                                  case 'A':
                                      $texto = 'Ativo';
                                    break;
                                  case 'F':
                                      $texto =  'Férias';
                                    break;
                                  case 'L':
                                      $texto =  'Licença';
                                    break;
                                  case 'D':
                                      $texto =  'Desligado';
                                    break;
                                  case 'C':
                                      $texto =  'Cancelado';
                                    break;
                  }

        return ($texto);
    }
    ///////// Dependente /////////////
    function get_dependente_info($dp_dependente_id)
    {

        $query	=	$this->db->get_where('dp_dependente' , array('dp_dependente_id' => $dp_dependente_id));

        return $query->result_array();
    }

    /////////GROUP/////////////
    function get_group()
    {
        $query	=	$this->db->get('group' );
        return $query->result_array();
    }
    function get_group_info($group_id)
    {
        $query	=	$this->db->get_where('group' , array('group_id' => $group_id));
        return $query->result_array();
    }

    /////////INVOICE/////////////
    function get_invoice()
    {
        $query	=	$this->db->get('invoice' );
        return $query->result_array();
    }
    function get_invoice_info($invoice_id)
    {
        $query	=	$this->db->get_where('invoice' , array('invoice_id' => $invoice_id));
        return $query->result_array();
    }
    function get_orders_by_client($client_id)
    {
        $query	=	$this->db->get_where('order' , array('client' => $client_id));
        return $query->result_array();
    }
    function get_product_detail_by_order($order_id, $field = 'name', $product = 'product')
    {
        $product = $this->db->get_where('order',array('order_id'=>$order_id))->row()->$product;
        return	$this->db->get_where('product',array('product_id'=>$product))->row()->$field;
    }

    function get_order_amount($order_id, $field = 'total_price')
    {
        return	$this->db->get_where('order',array('order_id'=>$order_id))->row()->$field;
    }

    /////////MESSAGE/////////////
    function get_message()
    {
        $query	=	$this->db->get('message' );
        return $query->result_array();
    }
    function get_message_info($message_id)
    {
        $query	=	$this->db->get_where('message' , array('message_id' => $message_id));
        return $query->result_array();
    }

    /////////NOTE/////////////
    function get_note()
    {
        $query	=	$this->db->get('note' );
        return $query->result_array();
    }
    function get_note_info($note_id)
    {
        $query	=	$this->db->get_where('note' , array('note_id' => $note_id));
        return $query->result_array();
    }
    function get_note_name($sender,$field='name')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$sender))->row()->$field;
    }
    function get_count_anotacao($admin_id)
    {
        $this->db->count_all_results('note');  // Produces an integer, like 25
        $this->db->where('note', $admin_id);
        $this->db->where('status !=', 'finalizado');
        $this->db->from('note');

        return	$this->db->count_all_results();
    }

    /////////ORDER/////////////
    function get_order()
    {
        $query	=	$this->db->get('order' );
        return $query->result_array();
    }
    function get_order_info($order_id)
    {
        $query	=	$this->db->get_where('order' , array('order_id' => $order_id));
        return $query->result_array();
    }

    function get_products_by_type($type_id)
    {
        $query	=	$this->db->get_where('product' , array('type' => $type_id));
        return $query->result_array();
    }

    function get_ref_by_product($ref)
    {
        $query	=	$this->db->get_where('product' , array('w_product_ref' => $ref));
        return $query->result_array();
    }
    function get_cnpj_by_client($client)
    {
        $query	=	$this->db->get_where('client' , array('client_id' => $client));
        return $query->result_array();
    }
    /////////FILES/////////////
    function get_file()
    {
        $query	=	$this->db->get('files' );
        return $query->result_array();
    }
    function get_file_info($file_id)
    {
        $query	=	$this->db->get_where('files' , array('file_id' => $file_id));
        return $query->result_array();
    }


    /////////NOTAS FISCAIS/////////////
    function get_xml_info($xml_id)
    {
        $query	=	$this->db->get_where('xmls' , array('xml_id' => $xml_id));
        return $query->result_array();
    }

    function get_nome_municipio($codigo_munic,$field='nome')
    {
        return	$this->db->get_where('tb_ex_ibge',array('codigo'=>$codigo_munic))->row()->$field;
    }

    function get_nome_cnae($n_cnae,$field='descricao')
    {
        return	$this->db->get_where('tb_ex_cnae',array('cnae'=>$n_cnae))->row()->$field;
    }

    function get_nome_cae($n_cae,$field='descricao')
    {
        return	$this->db->get_where('tb_ex_cae',array('cae'=>$n_cae))->row()->$field;
    }
    function get_nfs_info($nfs_id)
    {
        $query	=	$this->db->get_where('nfs' , array('nfs_id' => $nfs_id));
        return $query->result_array();
    }
    function get_nota_num_by_client($client,$field='nfs_num')
    {
        return	$this->db->get_where('nfs_n',array('cliente'=>$client))->row()->$field;
    }
    /////////RECIBOS/////////////
    function get_recibo_info($recibo_id)
    {
        $query	=	$this->db->get_where('recibo' , array('recibo_id' => $recibo_id));
        return $query->result_array();
    }

    /////////RECIBOS NUMERO/////////////

    function get_recibo_num_by_client($client,$field='recibo_num')
    {

        return	$this->db->get_where('recibo_n',array('client'=>$client))->row()->$field;
    }

    /////////PRODUCT/////////////
    function get_product()
    {
        $query	=	$this->db->get('product' );
        return $query->result_array();
    }
    function get_product_info($product_id)
    {
        $query	=	$this->db->get_where('product' , array('product_id' => $product_id));
        return $query->result_array();
    }

    /////////TRANSACTION/////////////
    function get_transaction()
    {
        $query	=	$this->db->get('transaction' );
        return $query->result_array();
    }
    function get_transaction_info($transaction_id)
    {
        $query	=	$this->db->get_where('transaction' , array('transaction_id' => $transaction_id));
        return $query->result_array();
    }

    /////////TYPE/////////////
    function get_type()
    {
        $query	=	$this->db->get('type' );
        return $query->result_array();
    }
    function get_type_info($type_id)
    {
        $query	=	$this->db->get_where('type' , array('type_id' => $type_id));
        return $query->result_array();
    }
    function get_types_by_category($category_id)
    {
        $query	=	$this->db->get_where('type' , array('category' => $category_id));
        return $query->result_array();
    }



/////////EXTRAS/////////////

    function get_desc_pasta_num_by_product($product,$field='description')
    {
        return	$this->db->get_where('product',array('product_id'=>$product))->row()->$field;
    }

/////////FILES EXTRAS/////////////
    function get_pasta_by_files_extra_id($files_extra_id,$field='path')
    {
        return	$this->db->get_where('files_extra',array('files_extra_id'=>$files_extra_id))->row()->$field;
    }

/////////Cliente dos Clientes /////////////

    function get_dest_cliente_info($dest_cliente_id)
    {
        $query	=	$this->db->get_where('dest_cliente' , array('dest_cliente_id' => $dest_cliente_id));
        return $query->result_array();
    }


//////// CONTRATO /////////////
function get_log_contrato($client_id)
    {
        $query	=	$this->db->get_where('client_contrato' , array('cliente' => $client_id));
        return $query->result_array();
    }
///////// PERFIL /////////////
    function perfil($id,$field='perfil')
    {
        return	$this->db->get_where('admin',array('admin_id'=>$id))->row()->$field;
    }

//////// PARAMETROS /////////////
function get_contabilidade_completa_mei($client_id,$field='contabilidade_completa_mei')
    {     
        return $this->db->get_where('client_config',array('client'=>$cliente))->row()->$field;
    } 
function get_usa_contabilidade_completa($client_id)
    {     
        
        $field1 = 'contabilidade_completa_mei';
        $field2 = 'pj_pf';
        $usaCompleto = 'N';
       
        $xContabCompleta = '';
        $xContabCompleta = $this->db->get_where('client_config',array('client'=>$client_id))->row()->$field1;
        
        $xTipoEmpresa = '';
        $xTipoEmpresa = $this->db->get_where('client',array('client_id'=>$client_id))->row()->$field2;
               
        if ($xTipoEmpresa != '2') {
            $usaCompleto = 'S';
        } elseif ($xContabCompleta == 'S') {
            $usaCompleto = 'S';
        } else {
            $usaCompleto = 'N';
        }
     
        return ($usaCompleto) ;
    } 

function libera_legalizacao($id)
    {     
        
        $perfil = @$this->db->get_where('admin',array('admin_id'=>$id))->row()->perfil;
        
        switch ($perfil){
                                  case '1':
                                      $libera = 1;     // TI
                                    break;
                                  case '2':
                                      $libera = 1;     // Gestão
                                    break;
                                  case '3':
                                      $libera = 1;     // Legalização
                                    break;
                                  case '4':
                                      $libera = 0;     // Fiscal
                                    break;
                                  case '5':
                                      $libera = 0;     // Contabilidade
                                    break;
                                  case '6':
                                      $libera = 0;     // DP
                                    break; 
                                  case '7':
                                      $libera = 0;     // Financeiro
                                    break;
                                  case '8':
                                      $libera = 0;     // Marketing
                                    break;
                                  case '9':
                                      $libera = 0;     // Sucesso do Cliente
                                    break;
                                  default:
                                      $libera = 0;
                                              
                  }
        
        
        return $libera;
    }

function libera_dp($id)
    {     
        
        $perfil = @$this->db->get_where('admin',array('admin_id'=>$id))->row()->perfil;
        
        switch ($perfil){
                                  case '1':
                                      $libera = 1;     // TI
                                    break;
                                  case '2':
                                      $libera = 0;     // Gestão
                                    break;
                                  case '3':
                                      $libera = 0;     // Legalização
                                    break;
                                  case '4':
                                      $libera = 0;     // Fiscal
                                    break;
                                  case '5':
                                      $libera = 0;     // Contabilidade
                                    break;
                                  case '6':
                                      $libera = 1;     // DP
                                    break;
                                  case '7':
                                      $libera = 0;     // Financeiro
                                    break;
                                  case '8':
                                      $libera = 0;     // Marketing
                                    break;
                                  case '9':
                                      $libera = 0;     // Sucesso do Cliente
                                    break;                                                                         
                                  default:
                                      $libera = 0;
                                              
                  }
        
        
        return $libera;
    }


function libera_nf($id)
    {     
        
        $perfil = @$this->db->get_where('admin',array('admin_id'=>$id))->row()->perfil;
        
        switch ($perfil){
                                  case '1':
                                      $libera = 1;     // TI
                                    break;
                                  case '2':
                                      $libera = 0;     // Gestão
                                    break;
                                  case '3':
                                      $libera = 1;     // Legalização
                                    break;
                                  case '4':
                                      $libera = 0;     // Fiscal
                                    break;
                                  case '5':
                                      $libera = 0;     // Contabilidade
                                    break;
                                  case '6':
                                      $libera = 0;     // DP
                                    break;
                                  case '7':
                                      $libera = 0;     // Financeiro
                                    break;
                                  case '8':
                                      $libera = 0;     // Marketing
                                    break;
                                  case '9':
                                      $libera = 0;     // Sucesso do Cliente
                                    break;                                                                         
                                  default:
                                      $libera = 0;
                                              
                  }
        
        
        return $libera;
    }
    
    function get_perfil($id)
    {     
        
        $perfil = @$this->db->get_where('admin',array('admin_id'=>$id))->row()->perfil;
        
        switch ($perfil){
                                  case '1':
                                      $texto = 'TI';                 // TI
                                    break;
                                  case '2':
                                      $texto = 'Gestão';             // Gestão
                                    break;
                                  case '3':
                                      $texto = 'Legalização';        // Legalização
                                    break;
                                  case '4':
                                      $texto = 'Fiscal';             // Fiscal
                                    break;
                                  case '5':
                                      $texto = 'Contabilidade';      // Contabilidade
                                    break;
                                  case '6':
                                      $texto = 'DP';                 // DP
                                    break;
                                  case '7':
                                      $texto = 'Financeiro';         // Financeiro
                                    break;
                                  case '8':
                                      $texto = 'Marketing';          // Marketing
                                    break;
                                  case '9':
                                      $texto = 'Sucesso do Cliente'; // Sucesso do Cliente
                                    break;
                                              
                  }        
        
        return $texto;
    }
    
    function get_status_cor($status)
    {
        switch ($status) {
            case 'Novo':
                $cor = 'vermelho';
            break;
            case 'Contabilizado':
                $cor = 'verde';
            break;
            case 'A contabilizar':
                $cor = 'preto';
            break;
            case 'A pagar':
                $cor = 'amarelo';
            break;
            case 'Pendente':
                $cor = 'amarelo';
            break; 
            case 'Acessado':
                $cor = 'azul';
            break;
            case 'Pago':
                $cor = 'azul';
            break;  
            case 'Cancelado':
                $cor = 'cinza';
            break;                                                                                                                                 
            default:
               $cor = 'preto';
        } 
        return $cor;
    }
    
    function get_tipo_empresa_name($azul)
    {
        switch ($azul) {
            case '0':
                echo  'Prof. liberal';
            break;
            case '1':
                echo 'Simples ';
            break;
            case  '2':
                echo  'MEI ';
            break;
            case '3':
                echo  'Comercial ';
            break;
            case '4':
                echo  'Lucro Presumido';
            break; 
            case '5':
                echo  'Doméstica';
            break;
            case '9':
                echo  'Todos';
            break;                                                                                                                                  
        } 
    }
    
    
function get_optante_simples($azul)   
    {
        switch ($azul) {
            case '1':
                echo  'Optante';
            break;
            case '2':
                echo 'NÂO OPTANTE';
            break;                                                                                                                                  
        } 
    } 
/// Cor pacote    
function get_cor_pacote($pacote)
    {     
        $XQuery = "select cor from client_pacote where pacote='".$pacote."'";
        $result = @$this->db->query($XQuery)->row()->cor;        

        //print $contador;
        return	$result;
    } 
        
}     
             