<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Arquivo extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

        $this->load->model('arquivo_model');
        $this->load->model('caracter_model');

        if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');
    }

	public function doc_cad_contrato_social($param1 = null, $param2 = null)
	{
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_contrato_social/', 'refresh');

        }

        $page_data['files']      = $this->arquivo_model->getArquivoContratoSocial($this->session->userdata('client_id'));
        $page_data['page_name']  = 'doc_cad_contrato_social';
        $page_data['page_icon']  = 'folder-open';
        $page_data['titulo']     = 'Arquivo - Contrato Social';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_contrato_social';

		$this->load->view('cliente/template/index', $page_data);
    }
    
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad  -  Enquadramento (ME/EPP) || enquadramento ****/
    function doc_cad_enquadramento($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_enquadramento/', 'refresh');

        }

        $page_data['files']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'3'))->result_array();
        $page_data['page_name']  = 'doc_cad_enquadramento';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_enquadramento';
        $page_data['titulo']     = 'Arquivo - Enquadramento';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  CNPJ ****/
    function doc_cad_cnpj($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_cnpj/', 'refresh');
        }

        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'2'))->result_array();
        $page_data['page_name']  = 'doc_cad_cnpj';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_cnpj';
        $page_data['titulo']     = 'Arquivo - Cartão CNPJ';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Cartão de Inscrição Estadual ****/
    function doc_cad_cartao_ie($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_cartao_ie/', 'refresh');

        }

        $page_data['files']      =  $this->db->get_where('files', array('product' => '9', 'client'=>$this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'doc_cad_cartao_ie';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_cartao_ie';
        $page_data['titulo']     = 'Arquivo - Cartão de Inscrição Estadual';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  CA do Corpo de Bomdeiro ****/
    function doc_cad_ca_cb($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_ca_cb/', 'refresh');

        }
        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'5'))->result_array();
        $page_data['page_name']  = 'doc_cad_ca_cb';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_ca_cb';
        $page_data['titulo']     = 'Arquivo - CA Corpo de Bombeiros';
        $this->load->view('cliente/template/index', $page_data);
    }
    
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad  -  Alvará (Prefeitura) || alvara ****/
    function doc_cad_alvara($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_alvara/', 'refresh');

        }
        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'doc_cad_alvara';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_alvara';
        $page_data['titulo']     = 'Arquivo - Alvará';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Cadastro do MEI || cert_mei ****/
    function doc_cad_cert_mei($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_cert_mei/', 'refresh');

        }
        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'7'))->result_array();
        $page_data['page_name']  = 'doc_cad_cert_mei';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_cert_mei';
        $page_data['titulo']     = 'Certificado do MEI';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Cadastro do CEI / INSS || cei_inss ****/
    function doc_cad_cei_inss($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_cei_inss/', 'refresh');

        }
        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'8'))->result_array();
        $page_data['page_name']  = 'doc_cad_cei_inss';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']		 = 'cliente/arquivo/doc_cad_cei_inss';
        $page_data['titulo']     = 'Cadastro do CEI / INSS';
        $this->load->view('cliente/template/index', $page_data);
    }
    
    /**** DOCUMENTOS DE CADASTRO |-> doc_cad   -  Sócios (CPF, RG, Residência) || doc_soc ****/
    function doc_cad_doc_soc($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'update_status') {
            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_doc_soc/', 'refresh');
        }
        if ($param1 == 'create') {
            $data['file']      = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect('arquivo/doc_cad_doc_soc/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('arquivo/doc_cad_doc_soc/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect('arquivo/doc_cad_doc_soc/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));

            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']     = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', 'Arquivo Enviado');

            redirect('arquivo/doc_cad_doc_soc/', 'refresh');
        }
        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'6'))->result_array();
        $page_data['page_name']  = 'doc_cad_doc_soc';
        $page_data['page_icon']  = 'folder-open';
        $page_data['view']       = 'cliente/arquivo/doc_cad_doc_soc';
        $page_data['titulo'] = 'Arquivo - Documentos dos Sócios';
        $this->load->view('cliente/template/index', $page_data);
    }

    /****MANAGE CONTRATO*****/
    function contrato($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 'sistema';
            $this->db->insert('client_contrato', $data);

            $this->session->set_flashdata('flash_message', 'Contrato Registrado com Sucesso!!');

            redirect('dashboard/', 'refresh');
        }

        if ($param1 == 'do_update') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 'sistema';
            $this->db->where('dp_funcionario_id', $param2);
            $this->db->update('dp_funcionario', $data);
            redirect('arquivo/client_contrato/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_message_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client_contrato', array(
                'message_id' => $param2
            ))->result_array();
        }

        $page_data['contrato']   = $this->db->get_where('client_contrato',array('cliente' => $this->session->userdata('client_id'),'tipo' => 'sistema'))->result_array();
        $page_data['page_name']  = 'contrato';
        $page_data['page_icon']  = 'file';
        $page_data['titulo']     = 'Contrato de Prestação de Serviço';
        $page_data['view']       = 'cliente/arquivo/contrato';
        $this->load->view('cliente/template/index', $page_data);
    }
    
    /****MANAGE CONTRATO SUPORTE WHATSAPP*****/
    function whatsapp($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 'whatsapp';
            $this->db->insert('client_contrato', $data);

            $this->session->set_flashdata('flash_message', 'Contrato Registrado com Sucesso!!');

            redirect('suporte/suporte', 'refresh');
        }

        if ($param1 == 'do_update') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 'whatsapp';
            $this->db->where('dp_funcionario_id', $param2);
            $this->db->update('dp_funcionario', $data);
            redirect('arquivo/suporte/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_message_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client_contrato', array(
                'message_id' => $param2
            ))->result_array();
        }

        $page_data['contrato']   = $this->db->get_where('client_contrato',array('cliente' => $this->session->userdata('client_id'),'tipo' => 'whatsapp'))->result_array();
        $page_data['page_name']  = 'whatsapp';
        $page_data['page_icon']  = 'file';
        $page_data['titulo']     = 'Termos de uso de atendimento via WHATSAPP BUSINESS';
        $page_data['view']       = 'cliente/arquivo/whatsapp';
        $this->load->view('cliente/template/index', $page_data);
    }    

    /****MANAGE CONTRATO TERMO DE USO NOVO SUPORTE*****/
    function termo_uso_suporte($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 't_u_suport';
            $this->db->insert('client_contrato', $data);

            $this->session->set_flashdata('flash_message', 'Contrato Registrado com Sucesso!!');

            redirect('suporte/suporte', 'refresh');
        }

        if ($param1 == 'do_update') {
            $data['cliente']        = $this->input->post('cliente');
            $data['cnpj_cpf']       = $this->input->post('cnpj_cpf');
            $data['pj_pf']          = $this->input->post('pj_pf');
            $data['email']          = $this->input->post('email');
            $data['nome']           = $this->input->post('nome');
            $data['data']           = $this->input->post('data');
            $data['ip']             = $this->input->post('ip');
            $data['cliente_socio']  = $this->input->post('cliente_socio');
            $data['socio_nome']     = $this->input->post('socio_nome');
            $data['socio_cnpj_cpf'] = $this->input->post('socio_cnpj_cpf');
            $data['tipo'] = 't_u_suport';
            $this->db->where('dp_funcionario_id', $param2);
            $this->db->update('dp_funcionario', $data);
            redirect('arquivo/termo_uso_suporte/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_message_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client_contrato', array(
                'message_id' => $param2
            ))->result_array();
        }

        $page_data['contrato']   = $this->db->get_where('client_contrato',array('cliente' => $this->session->userdata('client_id'),'tipo' => 't_u_suport'))->result_array();
        $page_data['page_name']  = 'termo_uso_suporte';
        $page_data['page_icon']  = 'file';
        $page_data['titulo']     = 'Termos de uso e Politica de Privacidade - Suporte';
        $page_data['view']       = 'cliente/arquivo/termo_uso_suporte';
        $this->load->view('cliente/template/index', $page_data);
    }


}
