<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Dashboard extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		$this->load->model('dashboard_model');

		if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');
    }


	public function index()
	{
		$data['view']		  = 'cliente/dashboard/dashboard';
    $data['graficos_info'] = $this->dashboard_model->get_graficos_info($this->session->userdata('client_id'));
    $data['get_graficos_info_entradas'] = $this->dashboard_model->get_graficos_info_entradas($this->session->userdata('client_id'));
    $data['get_graficos_info_saidas'] = $this->dashboard_model->get_graficos_info_saidas($this->session->userdata('client_id'));
		$data['boletoaberto'] = $this->dashboard_model->get_count_cobranca($this->session->userdata('client_id'));
		$data['qtdAvisos'] 	  = $this->dashboard_model->getQtdAvisos($this->session->userdata('client_id'));
		$data['log_contrato'] = $this->dashboard_model->getLogContrato($this->session->userdata('client_id'));
		$data['nao_nf_mes_anterior'] = $this->dashboard_model->getNaoNfmesAnterior($this->session->userdata('client_id'));
		$data['notificacao_extra']   = $this->dashboard_model->get_count_notificacao_extra($this->session->userdata('client_id'));
    $data['certificado'] = $this->dashboard_model->get_client_certificado_vencimento($this->session->userdata('client_id'));
		$data['qtdAcessos']          = $this->dashboard_model->get_log_acesso($this->session->userdata('client_id'));
		$data['qtdGuiaImpostosDas']    = $this->dashboard_model->getQtdGuiaImpostosDas($this->session->userdata('client_id'));
		$data['qtdGuiaImpostosFolha']  = $this->dashboard_model->getQtdGuiaImpostosFolha($this->session->userdata('client_id'));
		$data['qtdGuiaImpostosDarf']   = $this->dashboard_model->getQtdGuiaImpostosDarf($this->session->userdata('client_id'));
		$data['qtdGuiaImpostosImpostos'] = $this->dashboard_model->getQtdGuiaImpostosImpostos($this->session->userdata('client_id'));
		$this->load->view('cliente/template/index', $data);
	}
  
  /**** MANAGE Agenda de Obrigações ****/
  function agenda_obrigacoes($param1 = '', $param2 = '', $param3 = '')
  {
      if ($this->session->userdata('client_login') != 1)
		      redirect(base_url(), 'refresh');
      
      if ($param1 == 'do_update') {
          $entrega = $this->db->get_where('entregas_data', array('product' => $param2))->row();
          
          if($entrega->status == 'A') {
              $data['status'] = 'N';
              
              $this->db->where('product', $param2);
              $this->db->update('entregas_data', $data);
          
              $this->session->set_flashdata('flash_message', 'A obrigação de descrição: '.$entrega->entrega.', foi atualizada!');          
          } else {
              $this->session->set_flashdata('flash_message', 'Por questões de desempenho do site não é possível reverter esta mudança');
          }
          
          redirect(base_url('dashboard'), 'refresh');
      }
  }

	/****MANAGE Avisos*****/
  function avisos($param1 = '', $param2 = '', $param3 = '')
  {
      if ($this->session->userdata('client_login') != 1)
		  redirect(base_url(), 'refresh');

      if ($param1 == 'create') {
          $data['sender']        = $this->input->post('sender');
          $data['sender_type']   = $this->input->post('sender_type');
          $data['receiver']      = $this->input->post('receiver');
          $data['receiver_type'] = $this->input->post('receiver_type');
          $data['subject']       = $this->input->post('subject');
          $data['body']          = $this->input->post('body');
          $data['time']          = $this->input->post('time');
          $data['date']          = $this->input->post('date');
          $data['status']        = $this->input->post('status');
          $this->db->insert('files', $data);

          // Envio Email
          //$Xsender        = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->name;
          //$Xsend_email    = $this->db->get_where('client', array('client_id' => $this->input->post('sender')))->row()->email;

          //$this->email_model->envia_email_mensagem_cliente($Xsender,$Xsend_email,$this->input->post('subject'),$this->input->post('body'));

          redirect('dashboard/avisos/', 'refresh');
      }
      if ($param1 == 'update_status') {

          //wrp
          
          $query = "SELECT COUNT(*) AS `n_reg` FROM `files` where file_id = '".$param2."' and product='60' and status='pago'";
          $validador = $this->db->query($query)->row()->n_reg;
          
          if ( $validador > 1) {
          
              $data['data_acesso']    = date("d/m/Y H:i:s", time());
              $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
              $this->db->where('file_id', $param2);
              $this->db->update('files', $data);
              redirect('dashboard/avisos/', 'refresh');
          
          } else {
          
              $data['status']         = 'Acessado';
              $data['data_acesso']    = date("d/m/Y H:i:s", time());
              $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
              $this->db->where('file_id', $param2);
              $this->db->update('files', $data);
              redirect('dashboard/avisos/', 'refresh');
          
          }
          
      }
      if ($param1 == 'delete') {
          $this->db->where('file_id', $param2);
          $this->db->delete('files');
          redirect('dashboard/avisos/', 'refresh');
      }

      $page_data['avisos']     = $this->db->order_by('date', 'DESC')->get_where('files', array('client' => $this->session->userdata('client_id')))->result_array();
      $page_data['view']		 = 'cliente/dashboard/avisos';
      $page_data['page_name']  = 'avisos';
      $page_data['page_icon']  = 'envelope';
      $page_data['titulo'] = 'Avisos Importantes!';
      $this->load->view('cliente/template/index', $page_data);
  } 
    
  /****** GESTÃO DO USUÁRIO E TROCA DE SENHA ***/
  function manage_profile($param1 = '', $param2 = '', $param3 = '')
  {
      if ($this->session->userdata('client_login') != 1)
          redirect(base_url() . 'index.php?login', 'refresh');
      if ($param1 == 'update_profile_info') {
          $data['name']    = trim($this->input->post('name'));
          $data['address'] = trim($this->input->post('address'));
          $data['phone']   = trim($this->input->post('phone'));
          $data['email']   = trim($this->input->post('email'));

          $this->db->where('client_id', $this->session->userdata('client_id'));
          $this->db->update('client', $data);
          $this->session->set_flashdata('flash_message', 'account_updated');
          redirect('dashboard/manage_profile/', 'refresh');
      }
      if ($param1 == 'change_password') {
          $data['password']             = $this->input->post('password');
          $data['new_password']         = $this->input->post('new_password');
          $data['confirm_new_password'] = $this->input->post('confirm_new_password');

          $current_password = $this->db->get_where('client', array(
              'client_id' => $this->session->userdata('client_id')
          ))->row()->password;

          if ($current_password == md5($data['password']) && $data['new_password'] == $data['confirm_new_password']) {
              $this->db->where('client_id', $this->session->userdata('client_id'));
              $this->db->update('client', array(
                  'password' => md5($data['new_password'])
              ));
              $this->session->set_flashdata('flash_message', 'password_updated');
          } else {
              $this->session->set_flashdata('flash_message', 'password_mismatch');
          }
          redirect('dashboard/manage_profile/', 'refresh');
      }
      
      $page_data['page_name']  = 'manage_profile';
      $page_data['titulo']     = 'Gestão Usuário';
      $page_data['view']		 = 'cliente/dashboard/manage_profile';
      $page_data['page_icon']  = 'user';
      $page_data['edit_data']  = $this->db->get_where('client', array('client_id' => $this->session->userdata('client_id')))->result_array();
      $this->load->view('cliente/template/index', $page_data);
  }
  
  /**** FALE_CONOSCO - Ver Todos os Ticket's ****/
  function tickets_cliente($param1 = '', $param2 = '', $param3 = '')
  {
      if ($this->session->userdata('client_login') != 1) {
		      redirect(base_url(), 'refresh');
      }
      
      $page_data['page_name']  = 'tickets_cliente';
      $page_data['titulo']     = 'Fale Conosco - Ver Todos os Tickets';
      $page_data['view']		 = 'cliente/dashboard/tickets_cliente';
      $page_data['page_icon']  = 'user';
      $page_data['tickets_cliente']  = $this->db->get_where('w_ticket_cliente', array('alterdata' => $this->dashboard_model->get_alterdata_by_client($this->session->userdata('client_id'))))->result_array();
      $this->load->view('cliente/template/index', $page_data);
  }

}

/***PADRÃO Página não encontrada *****/
function four_zero_four()
{
	$this->load->view('four_zero_four');
}