<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Docfiscais extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		$this->load->model('docfiscais_model');
		$this->load->model('caracter_model');
		$this->load->model('email_model');
    }

	/**** DOCUMENTOS FISCAIS |-> doc_fis  -  DEFIS Declaração Anual || defis ****/
    function doc_fis_defis($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_defis/', 'refresh');

        }

        $page_data['files']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'40'))->result_array();
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '40');
        $page_data['page_name']  = 'doc_fis_defis';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_defis';
        $page_data['titulo']     = 'Documentos Fiscais - Defis - Declaração Anual';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Extrato do Simples Nacional Mensal || extrato_simples_nacional ****/
    function doc_fis_extrato_simples_nacional($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_extrato_simples_nacional/', 'refresh');

        }

        $page_data['files']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'41'))->result_array();
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '41');
        $page_data['page_name']  = 'doc_fis_extrato_simples_nacional';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_extrato_simples_nacional';
        $page_data['titulo']     = 'Documentos Fiscais - Extrato Simples Nacional';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS FISCAIS |-> doc_fis_inform_rendimentos  -  INFORME DE RENDIMENTOS || doc_fis_inform_rendimentos ****/
    function doc_fis_inform_rendimentos($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_inform_rendimentos/', 'refresh');

        }

        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'47'))->result_array();
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '47');
        $page_data['page_name']  = 'doc_fis_inform_rendimentos';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_inform_rendimentos';
        $page_data['titulo']     = 'Informe de Rendimentos';
        $this->load->view('cliente/template/index', $page_data);
    } 

    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  RAIS Anual ||rais ****/
    function doc_fis_rais($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_rais/', 'refresh');

        }

        $page_data['files']      =  $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'43'))->result_array();
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '43');
        $page_data['page_name']  = 'doc_fis_rais';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_rais';
        $page_data['titulo']     = 'Documentos Fiscais - RAIS';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Certidão Negativa || cert_neg ****/
    function doc_fis_cert_neg($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_cert_neg/', 'refresh');

        }

        $page_data['files']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'45'))->result_array();
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '45');
        $page_data['page_name']  = 'doc_fis_cert_neg';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_cert_neg';
        $page_data['titulo']     = 'Documentos Fiscais - Certidão Negativa';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** RELATORIOS |-> relatorios  -  rel_livros_fiscais ****/
    function rel_livros_fiscais($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/rel_livros_fiscais/', 'refresh');

        }
        
        $query = "SELECT * FROM files where client='".$this->session->userdata('client_id')."' and product in ('25','42','44','48') and status <> 'cancelled' and ind_up <> 'U' order by date desc";
        
        $page_data['files']      =  $this->db->query($query)->result_array();
        $page_data['page_name']  = 'rel_livros_fiscais';
        $page_data['page_icon']  = 'print';
        $page_data['view']       = 'cliente/doc-fiscais/rel_livros_fiscais';
        $page_data['titulo']     = 'Relatórios - Outros Documentos';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** DOCUMENTOS FISCAIS |-> doc_fis  -  Certidão Negativa || cert_neg ****/
    function doc_fis_dasn_simei($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('docfiscais/doc_fis_dasn_simei/', 'refresh');

        }
        
        $page_data['files']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'46'))->result_array();;
        $page_data['tipo']       = $this->docfiscais_model->get_type_name_by_id('product', '46');
        $page_data['page_name']  = 'doc_fis_dasn_simei';
        $page_data['page_icon']  = 'file';
        $page_data['view']       = 'cliente/doc-fiscais/doc_fis_dasn_simei';
        $page_data['titulo']     = 'Documentos DASN - SIMEI';
        $this->load->view('cliente/template/index', $page_data);
    }

    /****GESTÃO - files_extra*****/
    function files_extra($param1 = '', $param2 = '', $param3 = '')
    {
        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';


        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['file']         = $this->input->post('file');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['product']      = $this->input->post('product');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['ind_up']       = $this->input->post('ind_up');
            $data['status']       = $this->input->post('status');
            $this->db->insert('files_extra', $data);
            redirect('docfiscais/files_extra/', 'refresh');
        }
        
        if ($param1 == 'notificacao') 
        {
            $page_data['notificacao'] =  @$this->db->get_where('client_notificacao_extra', array('cliente' => $this->session->userdata('client_id')))->result_array();
        }
        
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_extra_id', $param2);
            $this->db->update('files_extra', $data);
            redirect('docfiscais/files_extra/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files_extra', array(
                'file_extra_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('files_extra', array('file_extra_id' => $param2))->result_array();
             //print_r($Xdados);

            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/doc_extra/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            // Geração do Log   ------------------------------------------------
            $log['admin']        = '';
            $log['client']       = $this->session->userdata('client_id');
            $log['path']         = $destino;
            $format              = 'DATE_W3C';
            $time = time();
            $log['date']         = standard_date($format, $time) ;
            $log['tipo']         = 'deleted';
            $this->db->insert('log', $log);
            // FIM - Geração do Log   ------------------------------------------

            $this->db->where('file_extra_id', $param2);
            $this->db->delete('files_extra');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect('docfiscais/files_extra/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

            if ( !empty($_FILES['file']['name'])){

                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
    
                $data['file']         = $_FILES['file']['name'];
                $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
                //$data['path']         = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$_FILES['file']['name'];
                $data['client']       = $this->input->post('client');
                $data['product']      = $this->input->post('product');
                //$data['desc_file']    = $_FILES['file']['name'];
                $data['desc_file']    = $this->input->post('desc_file');
                $data['quantity']     = $this->input->post('quantity');
                $data['valor']        = $this->input->post('valor');
                $data['date']         = $this->input->post('date');
                $data['data_venc']    = $this->input->post('date');
                $data['ind_up']       = $this->input->post('ind_up');
                $data['status']       = $this->input->post('status');
                $this->db->insert('files_extra', $data);
    
                $query = $this->db->query('SELECT LAST_INSERT_ID()');
                $row = $query->row_array();
                $LastIdInserted = $row['LAST_INSERT_ID()'];
    
                move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                //move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$_FILES['file']['name']);
                $this->session->set_flashdata('flash_message', 'Arquivo Enviado');
    
                $Xcontato       = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->contact;
                $Xemail         = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->email;
                $Xnome_empresa  = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->name;
                $Xtel           = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->ddd_phone.' '.$this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->phone;
                $Xdocumento     = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->cnpj_cpf;
                $Xalterdata     = $this->db->get_where('client', array('client_id' => $this->input->post('client')))->row()->alterdata;
                $Xdesc_arquivo  = $this->input->post('desc_file');
                $Xarquivo       = ($this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                $XNotificacao   = @$this->input->post('notificacao');
                $Xemail_solicitante = @$this->db->get_where('client_notificacao_extra', array('client_notificacao_extra_id' => $XNotificacao))->row()->email_solicitante;
    
                if (!empty($XNotificacao)){      
                  $data2['status'] = 'P';
                  $data2['file'] = $LastIdInserted;
                  $data2['dt_acesso'] = date('Y-m-d');
                  $data2['ip'] = $_SERVER['REMOTE_ADDR'];
                  $this->db->where('client_notificacao_extra_id', $XNotificacao);
                  $this->db->update('client_notificacao_extra', $data2);
                  
                  if (!empty($Xemail_solicitante))
                  {
                    $this->email_model->envia_email_notificacao($Xcontato,$Xemail,$Xnome_empresa,$Xarquivo,$Xdesc_arquivo,$Xtel,$Xdocumento,$Xalterdata,$XNotificacao,$Xemail_solicitante);
                  } else 
                  {                 
                    $this->session->set_flashdata('flash_message', 'Notificação Atualizada, Mas email destinatário não encontrado!');                    
                  } 
                  
                } 
                else 
                {         
                    $this->email_model->envia_email_postagem_cliente($Xcontato,$Xemail,$Xnome_empresa,$Xarquivo,$Xdesc_arquivo,$Xtel,$Xdocumento,$Xalterdata,$XNotificacao);               
                }
    
                redirect('docfiscais/files_extra/', 'refresh');
            }  else
                {
               $this->session->set_flashdata('flash_message', 'Arquivo Não Enviado, favor adicionar um arquivo!');
               redirect('docfiscais/files_extra/', 'refresh');
               }

        }

        $page_data['files']       = $this->db->order_by('date', 'DESC')->get_where('files_extra', array('client' => $this->session->userdata('client_id'),'product'=>'99'))->result_array();
        $page_data['client_alterdata']   = $this->docfiscais_model->get_client_info($this->session->userdata('client_id'));
        $page_data['page_name']   = 'files_extra';
        $page_data['page_icon']   = 'file';
        $page_data['view']        = 'cliente/doc-fiscais/files_extra';
        $page_data['titulo']  = 'Enviar Documentos Extras';
        $this->load->view('cliente/template/index', $page_data);
    }

}
