<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Guias extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

        $this->load->model('guias_model');
        
        if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');
    }

	public function guias_das($param1 = null, $param2 = null)
	{
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            
            redirect('guias/guias_das/', 'refresh');
        }

        $page_data['files']      =  $this->guias_model->getGuiasDAS($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_das';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias/Impostos - Simples Nacional ou DAS-MEI';
        $page_data['view']		 = 'cliente/guias/guias_das';

    		$this->load->view('cliente/template/index', $page_data);
    } 
    
	public function guias_dae($param1 = null, $param2 = null)
	{
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            
            redirect('guias/guias_dae/', 'refresh');
        }

        $page_data['files']      =  $this->guias_model->getGuiasDAE($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_dae';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias/Impostos - Documento de Arrecadação E-Social (DAE)';
        $page_data['view']		 = 'cliente/guias/guias_dae';

    		$this->load->view('cliente/template/index', $page_data);
    }    

    public function guias_gps($param1 = null, $param2 = null)
	{
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            
            redirect('guias/guias_gps/', 'refresh');

        }

        $page_data['files']      =  $this->guias_model->getGuiasGPS($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_gps';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias/Impostos - GPS';
        $page_data['view']		 = 'cliente/guias/guias_gps';

		$this->load->view('cliente/template/index', $page_data);
    }

    public function guias_darf($param1 = null, $param2 = null)
	{

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('guias/guias_darf/', 'refresh');

        }

        $page_data['files']      =  $this->guias_model->getGuiasDARF($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_darf';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias/DARF';
        $page_data['view']		 = 'cliente/guias/guias_darf';

		$this->load->view('cliente/template/index', $page_data);
    }

    public function guias_impostos($param1 = null, $param2 = null)
	{

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('guias/guias_impostos/', 'refresh');

        }

        $page_data['files']      =  $this->guias_model->getGuiasImpostos($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_impostos';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias - Impostos';
        $page_data['view']		 = 'cliente/guias/guias_impostos';

		$this->load->view('cliente/template/index', $page_data);
    }

    public function guias_fgts($param1 = null, $param2 = null)
	{

        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect('guias/guias_fgts/', 'refresh');

        }

        $page_data['files']      =  $this->guias_model->getGuiasFGTS($this->session->userdata('client_id'));
        $page_data['page_name']  = 'guias_fgts';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Guias/Impostos - FGTS';
        $page_data['view']		 = 'cliente/guias/guias_fgts';

		$this->load->view('cliente/template/index', $page_data);
    }
    
    
}
