<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Mensalidade extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

        $this->load->model('mensalidade_model');
        $this->load->model('caracter_model');

        if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');
    }

	public function index()
	{
        $page_data['files']      =  $this->mensalidade_model->getDadosBoleto($this->session->userdata('client_id'));
        $page_data['page_name']  = 'cobranca_mensalidade';
        $page_data['page_icon']  = 'calendar';
        $page_data['titulo']     = 'Cobrança - Mensalidade(s)';
        $page_data['view']		 = 'cliente/mensalidade/listar';

		$this->load->view('cliente/template/index', $page_data);
    }
    
    /**** COBRANÇA |-> cobranca - mensalidade  *****/
    function cobranca_mensalidade($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
        if ($param1 == 'create') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'mensalidade/cobranca_mensalidade/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'mensalidade/cobranca_mensalidade/', 'refresh');
        } 
        else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;
        } 
        else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            redirect(base_url() . 'mensalidade/cobranca_mensalidade/', 'refresh');
        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));

            $data['file']        = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_file']   = $this->input->post('desc_file');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', 'Arquivo Enviado');

            redirect(base_url() . 'mensalidade/cobranca_mensalidade/', 'refresh');
        }
        if ($param1 == 'update_status') {

            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'mensalidade/cobranca_mensalidade/', 'refresh');

        }
        
    }
}
