<?php
use Ofx\Parser;
require("./vendor/autoload.php");
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Movimentacoes extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		$this->load->model('movimentacoes_model');
		$this->load->model('caracter_model');
    }

	public function index()
	{
        if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');
            
        $page_data['mov']        = $this->movimentacoes_model->listar_movimentacoes($this->session->userdata('client_id'));
        $page_data['mov_soma']   = $this->db->get_where('w_lancamento_hist_dados',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['total_s']    = $this->db->get_where('w_graf_saida_dados',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['total_e']    = $this->db->get_where('w_graf_entrada_dados',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['client_alterdata']     = $this->movimentacoes_model->get_client_info($this->session->userdata('client_id'));
        $page_data['permite_retroativo']   = $this->movimentacoes_model->get_client_config_permite_retroativo($this->session->userdata('client_id'));
        $page_data['page_name']  = 'mov_lancar';
        $page_data['page_icon']  = 'inbox';
        $page_data['titulo']     = 'Movimentações - Lançamento Contábil';
        $page_data['view']		 = 'cliente/movimentacoes/mov_lancar';

		$this->load->view('cliente/template/index', $page_data);
    }

	 public function dados_movimentacao(){
		
		//recebo o id_mov da view para trazer os dados somente daquela movimentação
		$id_mov = $this->input->post("id_mov");
			
		//chamo a função clientes() dentro do model que me traz somente os dados de um cliente, pois estou passando o id_cliente como parãmetro
		$consulta = $this->db->get_where('mov', array('mov_id' => $id_mov))->result_array();
		
		//antes de continuar, verifico se alguma informação foi retornada, para não dar erro.
		if ($consulta->num_rows() == 0) {
			die("Movimento não encontrado");
		}
		
		//como eu vou retornar os dados para a view em formato jSon, aqui eu crio os índices para serem acessados dentro da função $.post()
		$array_movimentacao = array(
		
			"id_mov" => $consulta->row()->id_mov,
			"category" => $consulta->row()->category,
			"tipo_mov" => $consulta->row()->tipo_mov
			
		);
		print('passou aqui');
		/*
		 * Após os índices criados para o formato jSon, dou um echo no jsonEcode da array acima.
		 */
		echo json_encode($array_movimentacao);
    }

    public function editar()
    	{
    		//Carrego o model clientes
    		$this->load->model("m_clientes", "clientes");
    		
    		$id_cliente = $this->input->post("id_cliente");
    		$category= $this->input->post("category");
    		//$email = $this->input->post("email");
    		    		
    		//Aqui eu seto cada campo da tabela com seu respectivo valor para o update no model.
    		$dados_cliente = array(
    		
    			"category" => category
    		
    		);
    		
    		//Agora eu chamo a função salvar() dentro do model passando o id_cliente e os dados do cliente como parâmetro
    		//Se tiver sucesso, então retorno com o código 1, pois recupero as informações via ajax na view.
    		if ($this->clientes->salvar($id_cliente, $dados_cliente))
    			echo 1;
    		else
    			echo 0;		
    	}

    function mov_lancar($param1 = '', $param2 = '', $param3 = '')
    {
        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['mov']          = $_FILES['mov']['name'];
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            if ( empty($_FILES['mov']['name'])){
                $data['path']         = 'Sem Arquivo';
            }  
            else 
            {
                $Xrand =  mt_rand();
                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['mov']['name']));
                $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_E_'.$Xrand.'_'.$XnovoNome;
            }

            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('desc_mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = str_replace('-','',str_replace(',','.',str_replace('.','',$this->input->post('valor'))));
            $data['date']         = date('Y-m-d',strtotime(str_replace('/', '-',$this->input->post('date'))));
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->insert('mov', $data);

            move_uploaded_file($_FILES['mov']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_E_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', 'Movimento Salvo!');

            redirect('movimentacoes', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['mov']          = $this->input->post('mov');
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = str_replace(',','.',$this->input->post('valor'));
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->where('mov_id', $param2);
            $this->db->update('mov', $data);

            redirect('movimentacoes', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('mov', array(
                'mov_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('mov', array('mov_id' => $param2))->result_array();
            //print_r($Xdados);

            $this->db->where('mov_id', $param2);
            $this->db->delete('mov');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect('movimentacoes', 'refresh');

        }
        if ($param1 == 'visualizar') {

            //$caminho =  $this->db->get_where('mov', array('mov_id' => $param2))->result_array();
            echo   'id cliente:'.$this->input->post('client') ;
            echo   ' - ' ;
            echo   'id movimento:'.$this->input->post('mov_id') ;
            redirect('movimentacoes', 'refresh');
        }
        if ($param1 == 'historico') {
            
            $XFiltro = $this->input->post('data_ano').'-'.$this->input->post('data_mes');
            $this->session->set_flashdata('XFiltro', $XFiltro);

            redirect('movimentacoes', 'refresh');
        }   
        if ($param1 == 'create_saida') {

            $data['mov']          = $_FILES['mov']['name'];
            $data['tipo_mov']     = $this->input->post('tipo_mov');
            if ( empty($_FILES['mov']['name'])){
                $data['path']         = 'Sem Arquivo';
            }  
            else 
            {
                $Xrand =  mt_rand();
                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['mov']['name']));
                $data['path']         = $this->input->post('path').$this->input->post('alterdata').'_S_'.$Xrand.'_'.$XnovoNome;
            }

            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_mov']     = $this->input->post('desc_mov');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = str_replace(',','.',str_replace('.','',$this->input->post('valor')))*(-1);
            $data['date']         = date('Y-m-d',strtotime(str_replace('/', '-',$this->input->post('date'))));
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->insert('mov', $data);

            move_uploaded_file($_FILES['mov']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_S_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', 'Movimento Salvo!');

            redirect('movimentacoes', 'refresh');
        }

    }
    
    /**** MOV |-> Movimentações  -  editar ****/
    function mov_editar($param1 = '', $param2 = '', $param3 = '') {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if ($param1 == 'editar') {
            global $mov_id;
            $mov_id = $param2;
        }
        if ($param1 == 'do_update') {
            $data['desc_mov'] = $this->input->post('desc_mov');
            $data['category'] = $this->input->post('category');

            $this->db->where('mov_id', $param2);            
            $this->db->update('mov', $data);
            
            $this->session->set_flashdata('flash_message', 'Categoria Salva!');
            redirect(base_url('movimentacoes'), 'refresh');
        }
        
        $page_data['mov'] = $this->db->get_where('mov', array('mov_id' => $mov_id))->row();    
        $page_data['page_name']  = 'mov_editar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['titulo']     = 'Movimentações - Editar Categoria';
        $page_data['view']		 = 'cliente/movimentacoes/mov_editar';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** MOV |-> Movimentações  -  importar ****/
    function mov_importar($param1 = '', $param2 = '', $param3 = '')
    {
        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('files', $data);
            redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['file']        = $this->input->post('file');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('files', array(
                'file_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('files', array('file_id' => $param2))->result_array();
            //print_r($Xdados);

            foreach($Xdados as $row):
                $origem = $row['path'];
                $destino = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/mov/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);
            
            $cliente = $this->db->get_where('files', array('file_id' => $param2))->row()->client;
            $caminho = $this->db->get_where('files', array('file_id' => $param2))->row()->path;
            
            $this->db->where('client', $cliente);
            $this->db->where('path', $caminho);
            $this->db->delete('mov');
            
            $this->db->where('file_id', $param2);
            $this->db->delete('files');
            
            $this->session->set_flashdata('flash_message', 'Arquivo e Movimentações Deletados!');
            
            redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');

        }
        
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

             if (!empty($_FILES['file']['tmp_name'])){

                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
                
                $file_info = pathinfo($_FILES['file']['name']);              

                    $data['file']        = $_FILES['file']['name'];
                    $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
                    $data['client']      = $this->input->post('client');
                    $data['product']     = $this->input->post('product');
                    $data['desc_file']   = date('m/Y',strtotime("previous month"));
                    //$data['desc_file']   = $this->input->post('desc_file').'/'.$this->input->post('desc_file_year');
                    $data['quantity']    = $this->input->post('quantity');
                    $data['valor']       = $this->input->post('valor');
                    $data['date']        = $this->input->post('date');
                    $data['ind_up']      = $this->input->post('ind_up');
                    $data['status']      = $this->input->post('status');
                    $this->db->insert('files', $data);
        
                    move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                    $this->session->set_flashdata('flash_message', 'Arquivo Enviado');
                    
                    redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');
                    
              }
              
              elseif (empty($_FILES['file']['name'])){
                            $dados['path']         = 'Sem Arquivo';
                            $this->session->set_flashdata('flash_message', 'Arquivo Não Informado, Favor entre com um arquivo!');
                            redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');
              }

        $page_data['files']      =  $this->movimentacoes_model->listar_extrato($this->session->userdata('client_id'));
        $page_data['client_alterdata']  =  $this->movimentacoes_model->get_client_info($this->session->userdata('client_id'));
        $page_data['page_name']  = 'mov_importar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['titulo']     = 'Movimentações - Importar Extrato Bancário';
        $page_data['view']		 = 'cliente/movimentacoes/mov_importar';
        $this->load->view('cliente/template/index', $page_data);
    }        
                
        if ($param1 == 'upload_info_new') {

            $Xrand =  mt_rand();

             if (!empty($_FILES['file']['tmp_name'])){

                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));
                
                $file_info = pathinfo($_FILES['file']['name']);
                
                if($file_info['extension'] == 'ofx' && $this->movimentacoes_model->arquivo_existente($_FILES['file']['name'])) {
    
                    $data['file']        = $_FILES['file']['name'];
                    $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
                    $data['client']      = $this->input->post('client');
                    $data['product']     = $this->input->post('product');
                    $data['desc_file']   = date('m/Y',strtotime("previous month"));
                    //$data['desc_file']   = $this->input->post('desc_file').'/'.$this->input->post('desc_file_year');
                    $data['quantity']    = $this->input->post('quantity');
                    $data['valor']       = $this->input->post('valor');
                    $data['date']        = $this->input->post('date');
                    $data['ind_up']      = $this->input->post('ind_up');
                    $data['status']      = $this->input->post('status');
                    $this->db->insert('files', $data);
        
                    move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                    $this->session->set_flashdata('flash_message', 'Arquivo Enviado');
                                        
                    $ofxParser = new \OfxParser\Parser();
                    $ofx = $ofxParser->loadFromFile($data['path']);
    
                    $bankAccount = reset($ofx->bankAccounts);
                    
                    $transactions = $bankAccount->statement->transactions;
    
                    foreach ($transactions as $t) {
                        if($t->amount < 0) {
                            $dados['tipo_mov'] = 'S';
                        } else {
                            $dados['tipo_mov'] = 'E';
                        }
                        
                        // $dados['tipo_mov']     = $this->input->post('tipo_mov');
    
                        $category = 1;
                        if ((substr_count($t->memo, "GPS") >= 1) || (substr_count($t->memo, "GUIA PREV") >= 1)) {
                            $category = 72;
                        } elseif ((substr_count($t->memo, "CONTSIMPLES") >= 1) || (substr_count($t->memo, "ContSimples") >= 1)) {
                            $category = 83;
                        } elseif (substr_count($t->memo, "aluguel") >= 1) {
                            $category = 77;
                        } elseif ((substr_count($t->memo, "LUZ") >= 1) || (substr_count($t->memo, "luz") >= 1)){
                            $category = 78;
                        } elseif (substr_count($t->memo, "NUTRIHEALTH") >= 1) {
                            $category = 171;
                        } elseif (substr_count($t->memo, "LAVITTE") >= 1) {
                            $category = 171;
                        } elseif (substr_count($t->memo, "jlfit") >= 1) {
                            $category = 171;
                        } elseif (substr_count($t->memo, "TBI") >= 1) {
                            $category = 8;
                        } elseif (substr_count($t->memo, "DAS") >= 1) {
                            $category = 56;
                        } elseif(substr_count($t->memo, "BCE") >= 1) {
                            $category = 133;
                        } elseif(substr_count($t->memo, "DARF") >= 1) {
                            $category = 58;
                        } elseif (substr_count($t->memo, "MOV TIT COB") >= 1) {
                            $category = 8;
                        } elseif(substr_count($t->memo, "PACOTE SERVICOS") >= 1) {
                            $category = 144;
                        } elseif(substr_count($t->memo, "CONTRATO DE CAMBIO") >= 1) {
                            $category = 144;
                        } elseif((substr_count($t->memo, "APLICACAO") >= 1) && ($t->amount < 0)) {
                            $category = 133;
                        } elseif(substr_count($t->memo, "RESGATE AUT CONTAMAX") >= 1) {
                            $category = 100;
                        } elseif(substr_count($t->memo, "OPERACAO DE CAMBIO") >= 1) {
                            $category = 100;
                        } elseif (substr_count($t->memo, "TAR") >= 1) {
                            $category = 133;
                        } elseif (substr_count($t->memo, "DOC") >= 1) {
                            $category = 102;
                        } elseif (substr_count($t->memo, "TRANSFERENCIA A DEBITO") >= 1) {
                            $category = 133;
                        } elseif (substr_count($t->memo, "TED ENVIADA") >= 1) {
                            $category = 51;
                        } elseif (substr_count($t->memo, "TED RECEBIDA") >= 1) {
                            $category = 102;
                        } elseif (substr_count($t->memo, "TRANSFERENCIA A CREDITO") >= 1) {
                            $category = 102;
                        } elseif (substr_count($t->memo, "PAGAMENTO DE TITULO") >= 1) {
                            $category = 133;
                        } elseif (substr_count($t->memo, "CREDITO DOMICILIO CARTAO") >= 1) {
                            $category = 102;
                        } elseif ((substr_count($t->memo, "PAGAMENTO") >= 1) || (substr_count($t->memo, "PGTO") >= 1)){
                            $category = 133;
                        } elseif(substr_count($t->memo, "TRANSF") >= 1) {
                            $category = 133;
                        } elseif (substr_count($t->memo, "COMPRA CARTAO") >= 1) {
                            $category = 133;
                        } elseif ((substr_count($t->memo, "SISPAG") >= 1) && ($t->amount < 0)) {
                            $category = 133;
                        } elseif ((substr_count($t->memo, "SISPAG") >= 1) && ($t->amount > 0)) {
                            $category = 102;
                        }
                        
                        if (empty($_FILES['file']['name'])){
                            $dados['path']         = 'Sem Arquivo';
                        }  
                        else 
                        {
                            $dados['path']         = $data['path'];
                        }
    
                        $dados['client']       = $this->input->post('client');
                        $dados['category']     = $category;
                        $dados['desc_mov']     = $t->memo;
                        $dados['quantity']     = $this->input->post('quantity');
                        $dados['valor']        = str_replace(',','.',$t->amount);
                        $dados['date']         = date_format($t->date, 'Y-m-d');
                        $dados['alt_date']     = date("Y-m-d");
                        $dados['status']       = $this->input->post('status');
                        $this->db->insert('mov', $dados);
                    }
                    
                } elseif(($file_info['extension'] == 'pdf') && ($this->input->post('alterdata') == '1503')) {
                    // exceção feita para que o cliente de código 1503 pudesse importar arquivos em formato PDF | GCN 28/04/2021 |
                    $data['file']        = $_FILES['file']['name'];
                    $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
                    $data['client']      = $this->input->post('client');
                    $data['product']     = $this->input->post('product');
                    $data['desc_file']   = date('m/Y',strtotime("previous month"));
                    //$data['desc_file']   = $this->input->post('desc_file').'/'.$this->input->post('desc_file_year');
                    $data['quantity']    = $this->input->post('quantity');
                    $data['valor']       = $this->input->post('valor');
                    $data['date']        = $this->input->post('date');
                    $data['ind_up']      = $this->input->post('ind_up');
                    $data['status']      = $this->input->post('status');
                    $this->db->insert('files', $data);
                    
                    move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                    $this->session->set_flashdata('flash_message', 'Arquivo Enviado');
                } else {
                    $this->session->set_flashdata('flash_message', 'O arquivo não apresenta o formato correto ou tem nome igual a um arquivo já enviado.');
                }
         
            } else {
                $this->session->set_flashdata('flash_message', 'Arquivo Não Informado, Favor entre com um arquivo!');
            }
            
            redirect(base_url() . 'movimentacoes/mov_importar/', 'refresh');
            
        }
        $page_data['files']      =  $this->movimentacoes_model->listar_extrato($this->session->userdata('client_id'));
        $page_data['client_alterdata']  =  $this->movimentacoes_model->get_client_info($this->session->userdata('client_id'));
        $page_data['page_name']  = 'mov_importar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['titulo']     = 'Movimentações - Importar Extrato Bancário';
        $page_data['view']		 = 'cliente/movimentacoes/mov_importar';
        $this->load->view('cliente/template/index', $page_data);
    }

    public function permiteRetroativo($cliente_id)
    {
        return $this->movimentacoes_model->get_client_config_permite_retroativo($cliente_id);;
    }
       
}