<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

include(APPPATH.'libraries/enotas/src/eNotasGW.php');
use eNotasGW\Api\Exceptions as Exceptions;
use eNotasGW\Api\fileParameter as fileParameter;

class Notafiscal extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		$this->load->model('notafiscal_model');
		$this->load->model('caracter_model');
    }

    /**** MEUS CLIENTES |-> meus_clientes ****/
    /**** MEUS CLIENTES |-> meus_clientes -> info ****/
    /**** MEUS CLIENTES |-> meus_clientes -> editar ****/
    function meus_clientes($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {

            $this->form_validation->set_rules('dest_cnpj_cpf', 'CPF OU CNPJ', 'trim|required');

            if($this->form_validation->run()) {
                $data['dest_cliente']       = strtoupper($this->input->post('dest_cliente'));
                $data['cliente']            =  $this->input->post('cliente');
                $data['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cnpj_cpf'))));
                $data['dest_ie']            = str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('dest_ie'))));
                $data['dest_cmc']           = str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('dest_cmc'))));
                $data['dest_end']           = mb_strtoupper($this->input->post('dest_end'), 'UTF-8');
                $data['dest_n']             = strtoupper($this->input->post('dest_n'));
                $data['dest_comp']          = mb_strtoupper($this->input->post('dest_comp'), 'UTF-8');
                $data['dest_bairro']        = mb_strtoupper($this->input->post('dest_bairro'), 'UTF-8');
                $data['dest_cidade']        = mb_strtoupper($this->input->post('dest_cidade'), 'UTF-8');
                $data['dest_uf']            = strtoupper($this->input->post('dest_uf'));
                $data['dest_pais']          = strtoupper($this->input->post('dest_pais'));
                $data['dest_cep']           = $this->input->post('dest_cep');
                $data['dest_ibge']          = $this->input->post('dest_ibge');
                $data['dest_email']         = $this->input->post('dest_email');
                $data['dest_ddd']           = str_replace('(', '', str_replace(')', '', $this->input->post('dest_ddd')));
                $data['dest_tel']           = str_replace('-', '', $this->input->post('dest_tel'));
                $data['dest_desc']          = $this->input->post('dest_desc');
                $data['dest_data']          = date('Y-m-d');
                $data['dest_alt_data']      = date('Y-m-d');
                $data['dest_desc']          = $this->input->post('dest_desc');
                $this->db->insert('dest_cliente', $data);

                $this->session->set_flashdata('flash_message', 'Cliente adicionado com sucesso!!!');

                redirect('notafiscal/meus_clientes/', 'refresh');

            } else {
                setMsg('msgCadastro', 'Erro ao cadastrar', 'erro');
                redirect('notafiscal/meus_clientes/', 'refresh');
            }

        }
        if ($param1 == 'do_update') {
            $data['dest_cliente']       = strtoupper($this->input->post('dest_cliente'));
           // $data['cliente']            =  $this->input->post('cliente');
            $data['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cnpj_cpf'))));
            $data['dest_ie']            = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_ie'))));
            $data['dest_cmc']           = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cmc'))));
            $data['dest_end']           = strtoupper($this->input->post('dest_end'));
            $data['dest_n']             = strtoupper($this->input->post('dest_n'));
            $data['dest_comp']          = strtoupper($this->input->post('dest_comp'));
            $data['dest_bairro']        = strtoupper($this->input->post('dest_bairro'));
            $data['dest_cidade']        = strtoupper($this->input->post('dest_cidade'));
            $data['dest_uf']            = strtoupper($this->input->post('dest_uf'));
            $data['dest_pais']          = strtoupper($this->input->post('dest_pais'));
            $data['dest_cep']           = $this->input->post('dest_cep');
            $data['dest_email']         = $this->input->post('dest_email');
            $data['dest_ddd']           = $this->input->post('dest_ddd');
            $data['dest_tel']           = $this->input->post('dest_tel');
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_data']          = $this->input->post('dest_data');
           // $data['dest_alt_data']      = dataDiaDb();
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_status']        = $this->input->post('dest_status');

            $this->db->where('dest_cliente_id', $param2);
            $this->db->update('dest_cliente', $data);

            redirect(base_url() . 'notafiscal/meus_clientes/', 'refresh');
        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']  = true;
            $page_data['current_dest_cliente_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('dest_cliente', array(
                'dest_cliente_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $data['dest_status']        = 'inativo';

            $this->db->where('dest_cliente_id', $param2);
            $this->db->update('dest_cliente', $data);
            redirect(base_url() . 'notafiscal/meus_clientes/', 'refresh');

        }

        $page_data['client']    = $this->db->get('dest_cliente')->result_array();
        $page_data['client_pj_pf'] = $this->notafiscal_model->get_client_pj_pf($this->session->userdata('client_id'));
        $page_data['dest_cliente'] = $this->db->get_where('dest_cliente',array('cliente' => $this->session->userdata('client_id')))->result_array();
        $page_data['view']      = 'cliente/nota-fiscal/meus_clientes';
        $page_data['page_icon'] = 'user';
        $page_data['titulo'] = 'Cadastro de Clientes';

        $this->load->view('cliente/template/index', $page_data);

    }
    
    function meus_clientes_info($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if($param1 == 'visualizar') {
            global $dest_client_id;
            $dest_client_id = $param2;
        }
    
        $page_data['client_pj_pf'] = $this->notafiscal_model->get_client_pj_pf($this->session->userdata('client_id'));
        $page_data['dest_cliente'] = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $dest_client_id))->result_array();
        $page_data['view']      = 'cliente/nota-fiscal/meus_clientes_info';
        $page_data['page_icon'] = 'user';
        $page_data['titulo'] = 'Informações de Clientes';

        $this->load->view('cliente/template/index', $page_data);
    }
    
    function meus_clientes_editar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if($param1 == 'editar') {
            global $dest_client_id;
            $dest_client_id = $param2;
        }
        if($param1 == 'do_update') {
            $data['dest_cliente']       = strtoupper($this->input->post('dest_cliente'));
            $data['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cnpj_cpf'))));
            $data['dest_ie']            = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_ie'))));
            $data['dest_cmc']           = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cmc'))));
            $data['dest_end']           = strtoupper($this->input->post('dest_end'));
            $data['dest_n']             = strtoupper($this->input->post('dest_n'));
            $data['dest_comp']          = strtoupper($this->input->post('dest_comp'));
            $data['dest_bairro']        = strtoupper($this->input->post('dest_bairro'));
            $data['dest_cidade']        = strtoupper($this->input->post('dest_cidade'));
            $data['dest_uf']            = strtoupper($this->input->post('dest_uf'));
            $data['dest_pais']          = strtoupper($this->input->post('dest_pais'));
            $data['dest_cep']           = $this->input->post('dest_cep');
            $data['dest_ibge']          = $this->input->post('dest_ibge');
            $data['dest_email']         = $this->input->post('dest_email');
            $data['dest_ddd']           = str_replace('(','',str_replace(')','',$this->input->post('dest_ddd')));
            $data['dest_tel']           = str_replace('-', '', $this->input->post('dest_tel'));
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_alt_data']      = date('Y-m-d');
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_status']        = $this->input->post('dest_status');
        
            $this->db->where('dest_cliente_id', $param2);
            $this->db->update('dest_cliente', $data);
            
            $this->session->set_flashdata('flash_message', 'Cliente Atualizado!');
            
            redirect(base_url() . 'notafiscal/meus_clientes/', 'refresh');
        }
    
        $page_data['client_pj_pf'] = $this->notafiscal_model->get_client_pj_pf($this->session->userdata('client_id'));
        $page_data['dest_cliente'] = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $dest_client_id))->result_array();
        $page_data['view']      = 'cliente/nota-fiscal/meus_clientes_editar';
        $page_data['page_icon'] = 'user';
        $page_data['titulo'] = 'Edição de Clientes';

        $this->load->view('cliente/template/index', $page_data);
    }

    /**** NOTAS FISCAIS |-> nf  -  importar ****/
    function nf_importar($param1 = '', $param2 = '', $param3 = '')
    {

        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['xml']         = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['competencia'] = $this->input->post('competencia');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('xmls', $data);
            redirect(base_url() . 'notafiscal/nf_importar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['xml']         = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['competencia'] = $this->input->post('competencia');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('xml_id', $param2);
            $this->db->update('xmls', $data);
            redirect(base_url() . 'notafiscal/nf_consultar/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_xml_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('xmls', array(
                'xml_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('xmls', array('xml_id' => $param2))->result_array();
             //print_r($Xdados);

            foreach($Xdados as $row):
            $origem = $row['path'];
            $destino = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            $this->db->where('xml_id', $param2);
            $this->db->delete('xmls');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'notafiscal/nf_consultar/', 'refresh');

        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

            if (!empty($_FILES['file']['name'])) {

            $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));

            $data['xml']         = $_FILES['file']['name'];
            $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['desc_xml']    = $_FILES['file']['name'];
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['competencia'] = $this->input->post('competencia');
            $data['ind_up']      = $this->input->post('ind_up');
            $data['status']      = $this->input->post('status');
            $this->db->insert('xmls', $data);

            move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
            $this->session->set_flashdata('flash_message', 'Arquivo Enviado');

            redirect(base_url() . 'notafiscal/nf_importar/', 'refresh');

            }  
            else
            {
                $this->session->set_flashdata('flash_message', 'Arquivo Não Importado, favor adicionar o arquivo');
                redirect(base_url() . 'notafiscal/nf_importar/', 'refresh');
            }
        }
        
        $page_data['xmls']      = $this->db->get_where('xmls', array('client' => $this->session->userdata('client_id')))->result_array();      
        $page_data['client_alterdata'] = $this->notafiscal_model->get_client_info($this->session->userdata('client_id'));
        $page_data['page_name'] = 'nf_importar';
        $page_data['page_icon'] = 'download-alt';
        $page_data['titulo']    = 'Nota Fiscal - Importar';
        $page_data['view']      = 'cliente/nota-fiscal/nf_importar';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** NOTAS FISCAIS |-> nf  -  consultar ****/
    function nf_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1) {
            redirect(base_url(), 'refresh');
        }

        $page_data['files']      = $this->db->get_where('xmls', array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['xmls']       = $this->db->order_by('date', 'DESC')->get_where('xmls',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'nf_consultar';
        $page_data['page_icon']  = 'search';
        $page_data['titulo'] = 'Nota Fiscal - Consultar';
        $page_data['view']      = 'cliente/nota-fiscal/nf_consultar';
        $this->load->view('cliente/template/index', $page_data);

        if ($param1 == 'historico') {

            $XFiltro = $this->input->post('data_ano').'-'.$this->input->post('data_mes');

            $this->session->set_flashdata('XFiltro', $XFiltro);

            redirect(base_url() . 'notafiscal/nf_consultar/', 'refresh');
        }
        
        if($param1 =='update_status') {
        
            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('xml_id', $param2);
            $this->db->update('xml', $data);

            redirect('notafiscal/nf_consultar/', 'refresh');        
        
        }

    }

/**** NOTAS FISCAIS SERVIÇO |-> nfS  -  emitir ****/
    function nfs_emitir($param1 = '', $param2 = '', $param3 = '', $param4 = '')

    {
          /**** Definição de variáveis *****/
          $Xrand = '';
          $origem = '';
          $destino = '';
          $XnovoNome = '';


          if ($this->session->userdata('client_login') != 1)
              redirect(base_url(), 'refresh');

          if ($param1 == 'gerar_todos') {
  
/* Gerar até o final do mês vigente   */

            $emissao_inicio= date("Y-m-d"); // base para o sistema
            $emissao= date("Y-m-d"); // base para o sistema
            $data_competencia= date("Y-m-d"); // base para o tx2
         
            //$XQuery = "SELECT * FROM  w_mensalidade_zoop where status='pending' and valor_original > '0' and ano='".$ano."' and mes='".$mes."'";
  
            $XQuery = "SELECT 
            c.client_id as cliente
            ,c.name
            ,c.cnpj_cpf
            ,c.alterdata
            ,m.client_mensalidade_id
            ,m.obs
            ,m.status
            ,m.status_nf
            ,m.cliente
            ,m.valor_original
            ,m.emissao
            ,DATE_FORMAT(m.pagamento, '%d/%m/%Y') as data_competencia
            ,d.dest_cliente_id
            ,d.dest_cliente
            ,d.dest_cnpj_cpf
            ,d.dest_ie
            ,d.dest_cmc
            ,d.dest_end
            ,d.dest_n
            ,d.dest_comp
            ,d.dest_bairro
            ,d.dest_cidade
            ,d.dest_uf
            ,d.dest_pais
            ,d.dest_cep
            ,d.dest_ibge
            ,d.dest_email
            ,d.dest_ddd
            ,d.dest_tel
            FROM  client_mensalidade m
            join client c on m.cliente = c.client_id
            join w_dest_cliente_contsimples_todos d on c.client_id = d.dest_cliente_id
            where m.status='pago' and status_nf='gerar' and m.valor_recebido > '0'
            and year(m.pagamento) = year(CURDATE()) and month(m.pagamento) = month(CURDATE())";  

// FIM  - gerar mês vigente
 
/*                       */
/* Gerar retorativo 
                    * /
            $emissao_inicio= '2023-10-31'; // base para o sistema
            $emissao= '2023-10-31'; // base para o sistema
            $data_competencia= '2023-10-31'; // base para o tx2
            $ano = '2023';
            $mes = '10';
         
            //$XQuery = "SELECT * FROM  w_mensalidade_zoop where status='pending' and valor_original > '0' and ano='".$ano."' and mes='".$mes."'";
  
            $XQuery = "SELECT 
            c.client_id as cliente
            ,c.name
            ,c.cnpj_cpf
            ,c.alterdata
            ,m.client_mensalidade_id
            ,m.obs
            ,m.status
            ,m.status_nf
            ,m.cliente
            ,m.valor_original
            ,m.emissao
            ,DATE_FORMAT(m.pagamento, '%d/%m/%Y') as data_competencia
            ,d.dest_cliente_id
            ,d.dest_cliente
            ,d.dest_cnpj_cpf
            ,d.dest_ie
            ,d.dest_cmc
            ,d.dest_end
            ,d.dest_n
            ,d.dest_comp
            ,d.dest_bairro
            ,d.dest_cidade
            ,d.dest_uf
            ,d.dest_pais
            ,d.dest_cep
            ,d.dest_ibge
            ,d.dest_email
            ,d.dest_ddd
            ,d.dest_tel
            FROM  client_mensalidade m
            join client c on m.cliente = c.client_id
            join w_dest_cliente_contsimples_todos d on c.client_id = d.dest_cliente_id
            where m.status='pago' and status_nf='gerar' and m.valor_recebido > '0'
            and year(m.pagamento) = '".$ano."' and month(m.pagamento) = '".$mes."'";  

// FIM  - gerar mês retroativo 
/**/                      
                          
            $gerar = @$this->db->query($XQuery)->result_array();
            
            //var_dump($gerar);

            $cont = 0;
            foreach($gerar as $value){             
              
              $cont++;  
              //$cliente = $value['cliente'];
              $cliente = $value['dest_cliente_id'];
              $cliente_emissor = $this->session->userdata('client_id');
              $id_mensalidade = $value['client_mensalidade_id'];
              $obs = $value['obs'];
  
              $NFS =  $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id'))  ;
              $xnfs_num = $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id')) ;
              //$xnfs_rps = $this->crud_model->get_rps_num_by_client($this->session->userdata('client_id')) ;   // WRP - 2020-03-10
              $quantidade = '1';
  
              $DataInicio = $data_competencia;
              $DataEmissao = $data_competencia;             
              //$data_emissao =  $emissao; 
              $data_emissao =  $data_competencia;              
  
              $VALOR = $value['valor_original'] ; 
              $valor_deducao = '0.00';
              $valor_liquido = $value['valor_original'];
              $valor_desc_inc = '0.00'  ;
              $valor_desc_cond = '0.00' ;
              $item_lista_servico =  '171901';
              $cod_tribut_municipio =  '171901';
  
  
              $tipo_nfs = '1'; // tipo RPS
              $nat_operacao = '6';
              
              //$desc_nfs = 'Prestação de serviços contábeis em Fevereiro de 2019. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              $desc_nfs = 'Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              if(!empty($obs)) {
                  $desc_nfs =  $obs.'. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              }
              $cod_cnae = '';
              $iss_aliquota = '2';
  
              // Dados do TOMADOR  
  
              $cnpj = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cnpj_cpf ;
              $razao_social = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cliente ; 
              $cmc = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cmc ; 
              $ie = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ie ; 
              $endereco = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_end ; 
              $end_n = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_n ; 
              $end_compl = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_comp ; 
              $bairro = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_bairro ; 
  
              $cidade = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cidade ; 
              $uf = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_uf ;
              $pais = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_pais ; 
              $cep = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cep ;
              $cod_ibge = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ibge ;  
              $ddd = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ddd ; 
              $tel = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_tel ; 
              $email = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_email ;   
  
              // FIM Dados TOMADOR              
  
  
              if (!empty($this->input->post('incentivador_cultural'))){
                  $incentivador_cultural = 2;
              } else { $incentivador_cultural = 2; };
  
              if (!empty($this->input->post('iss_retido'))){
                  $iss_retido = 2;
              } else { $iss_retido = 2; };

              $emissor = $this->notafiscal_model->get_client_info($cliente_emissor);
              //var_dump($row_emissor);

              $data['nfs']                    = $NFS;
              $data['nfs_num']                = $xnfs_num;
              $data['tipo_nfs']               = $tipo_nfs;
              $data['caminho']                = 'caminho';
              $data['cliente']                = $cliente_emissor;
              $data['dest_cliente']           = $cliente;
              $data['categoria']              = 'categoria';
              $data['desc_nfs']               = $desc_nfs;
              $data['quantidade']             = $quantidade;
              $data['valor']                  = str_replace(',','.',$VALOR); //ver
              $data['valor_liquido']          = str_replace(',','.',$VALOR); //ver
              $data['data_emissao']           = date("Y-m-d H:i:s", time());
              $data['data_competencia']       = date("Y-m-d H:i:s", time());
              $data['alt_data']               = date("Y-m-d H:i:s", time());
              $data['status']                 = 'Salva';
              $data['cod_verificacao']        = '';
              $data['nat_operacao']           = $nat_operacao;
              $data['opt_simplesnacional']    = '1';
              $data['incentivador_cultural']  = $incentivador_cultural;
              $data['outras_informacoes']     = 'Contribuinte ME, EPP ou MEI/Simples Nacional';
              $data['iss_retido']             = $iss_retido;
              $data['iss_valor']              = '0.00';
              $data['iss_aliquota']           = '0.00';
              $data['item_lista_servico']     = $item_lista_servico;
              $data['cod_cnae']               = $cod_cnae;
              $data['codigo_trib_municipio']  = $cod_tribut_municipio;
              $data['valor_deducao']          = $valor_deducao;
              $data['valor_desc_inc']         = $valor_desc_inc;
              $data['valor_desc_cond']        = $valor_desc_cond;
  
              $this->db->insert('nfs', $data);
  
              // incrementa nº nfs  
              $data2['nfs_num']     =  $xnfs_num+1;
              
              $this->db->where('cliente', $cliente_emissor);
              $this->db->update('nfs_n', $data2);
  
              //atualiza status da tabela de boleto
  
              $data_up['status_nf']                 = 'salva';
              
              $this->db->where('client_mensalidade_id', $id_mensalidade);
              $this->db->update('client_mensalidade', $data_up);
  
          }
          redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
      } 
      
          if ($param1 == 'gerar_todos_retroativo') {
  

/* Gerar retorativo */ 

            $emissao_inicio= '2023-04-01'; // base para o sistema
            $emissao= '2023-04-33'; // base para o sistema
            $data_competencia= '2022-04-30'; // base para o tx2
            $ano = '2023';
            $mes = '04';
            $fator_multiplicador = '0.65';
            $desconto_boleto = '3.35';
         
            //$XQuery = "SELECT * FROM  w_mensalidade_zoop where status='pending' and valor_original > '0' and ano='".$ano."' and mes='".$mes."'";
  
            $XQuery = "SELECT 
            c.client_id as cliente
            ,c.name
            ,c.cnpj_cpf
            ,c.alterdata
            ,m.client_mensalidade_id
            ,m.obs
            ,m.status
            ,m.status_nf
            ,m.cliente
            ,m.valor_original
            ,m.emissao
            ,DATE_FORMAT(m.pagamento, '%d/%m/%Y') as data_competencia
            ,d.dest_cliente_id
            ,d.dest_cliente
            ,d.dest_cnpj_cpf
            ,d.dest_ie
            ,d.dest_cmc
            ,d.dest_end
            ,d.dest_n
            ,d.dest_comp
            ,d.dest_bairro
            ,d.dest_cidade
            ,d.dest_uf
            ,d.dest_pais
            ,d.dest_cep
            ,d.dest_ibge
            ,d.dest_email
            ,d.dest_ddd
            ,d.dest_tel
            FROM  client_mensalidade m
            join client c on m.cliente = c.client_id
            join w_dest_cliente_contsimples_todos d on c.client_id = d.dest_cliente_id
            where m.status='pago' and status_nf='gerar' and m.valor_recebido > '0'
            and year(m.pagamento) = '".$ano."' and month(m.pagamento) = '".$mes."'";  

// FIM  - gerar mês retroativo 
                     
                          
            $gerar = @$this->db->query($XQuery)->result_array();
            
            //var_dump($gerar);

            $cont = 0;
            foreach($gerar as $value){             
              
              $cont++;  
              //$cliente = $value['cliente'];
              $cliente = $value['dest_cliente_id'];
              $cliente_emissor = $this->session->userdata('client_id');
              $id_mensalidade = $value['client_mensalidade_id'];
              $obs = $value['obs'];
  
              $NFS =  $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id'))  ;
              $xnfs_num = $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id')) ;
              //$xnfs_rps = $this->crud_model->get_rps_num_by_client($this->session->userdata('client_id')) ;   // WRP - 2020-03-10
              $quantidade = '1';
  
              $DataInicio = $data_competencia;
              $DataEmissao = $data_competencia;             
              //$data_emissao =  $emissao; 
              $data_emissao =  $data_competencia;              
  
              $VALOR = $value['valor_original'] ; 
              $valor_deducao = '0.00';
              $valor_liquido = ($value['valor_original']-$desconto_boleto)*$fator_multiplicador;
              $valor_desc_inc = '0.00'  ;
              $valor_desc_cond = '0.00' ;
              $item_lista_servico =  '171901';
              $cod_tribut_municipio =  '171901';
  
  
              $tipo_nfs = '1'; // tipo RPS
              $nat_operacao = '6';
              
              //$desc_nfs = 'Prestação de serviços contábeis em Fevereiro de 2019. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              $desc_nfs = 'Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($valor_liquido*0.1345),2)).' (Fonte IBPT 13,45%)';
              if(!empty($obs)) {
                  $desc_nfs =  $obs.'. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($valor_liquido*0.1345),2)).' (Fonte IBPT 13,45%)';
              }
              $cod_cnae = '';
              $iss_aliquota = '2';
  
              // Dados do TOMADOR  
  
              $cnpj = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cnpj_cpf ;
              $razao_social = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cliente ; 
              $cmc = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cmc ; 
              $ie = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ie ; 
              $endereco = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_end ; 
              $end_n = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_n ; 
              $end_compl = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_comp ; 
              $bairro = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_bairro ; 
  
              $cidade = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cidade ; 
              $uf = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_uf ;
              $pais = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_pais ; 
              $cep = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cep ;
              $cod_ibge = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ibge ;  
              $ddd = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ddd ; 
              $tel = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_tel ; 
              $email = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_email ;   
  
              // FIM Dados TOMADOR              
  
  
              if (!empty($this->input->post('incentivador_cultural'))){
                  $incentivador_cultural = 2;
              } else { $incentivador_cultural = 2; };
  
              if (!empty($this->input->post('iss_retido'))){
                  $iss_retido = 2;
              } else { $iss_retido = 2; };

              $emissor = $this->notafiscal_model->get_client_info($cliente_emissor);
              //var_dump($row_emissor);

              $data['nfs']                    = $NFS;
              $data['nfs_num']                = $xnfs_num;
              $data['tipo_nfs']               = $tipo_nfs;
              $data['caminho']                = 'caminho';
              $data['cliente']                = $cliente_emissor;
              $data['dest_cliente']           = $cliente;
              $data['categoria']              = 'categoria';
              $data['desc_nfs']               = $desc_nfs;
              $data['quantidade']             = $quantidade;
              $data['valor']                  = str_replace(',','.',$VALOR); //ver
              $data['valor_liquido']          = str_replace(',','.',$VALOR); //ver
              $data['data_emissao']           = date("Y-m-d H:i:s", time());
              $data['data_competencia']       = date("Y-m-d H:i:s", time());
              $data['alt_data']               = date("Y-m-d H:i:s", time());
              $data['status']                 = 'Salva';
              $data['cod_verificacao']        = '';
              $data['nat_operacao']           = $nat_operacao;
              $data['opt_simplesnacional']    = '1';
              $data['incentivador_cultural']  = $incentivador_cultural;
              $data['outras_informacoes']     = 'Contribuinte ME, EPP ou MEI/Simples Nacional';
              $data['iss_retido']             = $iss_retido;
              $data['iss_valor']              = '0.00';
              $data['iss_aliquota']           = '0.00';
              $data['item_lista_servico']     = $item_lista_servico;
              $data['cod_cnae']               = $cod_cnae;
              $data['codigo_trib_municipio']  = $cod_tribut_municipio;
              $data['valor_deducao']          = $valor_deducao;
              $data['valor_desc_inc']         = $valor_desc_inc;
              $data['valor_desc_cond']        = $valor_desc_cond;
  
              $this->db->insert('nfs', $data);
  
              // incrementa nº nfs  
              $data2['nfs_num']     =  $xnfs_num+1;
              
              $this->db->where('cliente', $cliente_emissor);
              $this->db->update('nfs_n', $data2);
  
              //atualiza status da tabela de boleto
  
              $data_up['status_nf']                 = 'salva';
              
              $this->db->where('client_mensalidade_id', $id_mensalidade);
              $this->db->update('client_mensalidade', $data_up);
  
          }
          redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
      } 
      
          if ($param1 == 'gerar_manual') {
  

            $emissao_inicio= date("Y-m-d"); // base para o sistema
            $emissao= date("Y-m-d"); // base para o sistema
            $data_competencia= date("Y-m-d"); // base para o tx2
         
            //$XQuery = "SELECT * FROM  w_mensalidade_zoop where status='pending' and valor_original > '0' and ano='".$ano."' and mes='".$mes."'";
  
            $XQuery = "SELECT 
            c.client_id as cliente
            ,c.name
            ,c.cnpj_cpf
            ,c.alterdata
            ,m.client_mensalidade_id
            ,m.obs
            ,m.status
            ,m.status_nf
            ,m.cliente
            ,m.valor_original
            ,m.emissao
            ,DATE_FORMAT(m.pagamento, '%d/%m/%Y') as data_competencia
            ,d.dest_cliente_id
            ,d.dest_cliente
            ,d.dest_cnpj_cpf
            ,d.dest_ie
            ,d.dest_cmc
            ,d.dest_end
            ,d.dest_n
            ,d.dest_comp
            ,d.dest_bairro
            ,d.dest_cidade
            ,d.dest_uf
            ,d.dest_pais
            ,d.dest_cep
            ,d.dest_ibge
            ,d.dest_email
            ,d.dest_ddd
            ,d.dest_tel
            FROM  client_mensalidade m
            join client c on m.cliente = c.client_id
            join w_dest_cliente_contsimples_todos d on c.client_id = d.dest_cliente_id
            where m.status='pago' and status_nf='manual' and m.valor_recebido > '0'";  

                     
                          
            $gerar = @$this->db->query($XQuery)->result_array();
            
            //var_dump($gerar);

            $cont = 0;
            foreach($gerar as $value){             
              
              $cont++;  
              //$cliente = $value['cliente'];
              $cliente = $value['dest_cliente_id'];
              $cliente_emissor = $this->session->userdata('client_id');
              $id_mensalidade = $value['client_mensalidade_id'];
              $obs = $value['obs'];
  
              $NFS =  $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id'))  ;
              $xnfs_num = $this->notafiscal_model->get_nota_num_by_client($this->session->userdata('client_id')) ;
              //$xnfs_rps = $this->crud_model->get_rps_num_by_client($this->session->userdata('client_id')) ;   // WRP - 2020-03-10
              $quantidade = '1';
  
              $DataInicio = $data_competencia;
              $DataEmissao = $data_competencia;             
              //$data_emissao =  $emissao; 
              $data_emissao =  $data_competencia;              
  
              $VALOR = $value['valor_original'] ; 
              $valor_deducao = '0.00';
              $valor_liquido = $value['valor_original'];
              $valor_desc_inc = '0.00'  ;
              $valor_desc_cond = '0.00' ;
              $item_lista_servico =  '171901';
              $cod_tribut_municipio =  '171901';
  
  
              $tipo_nfs = '1'; // tipo RPS
              $nat_operacao = '6';
              
              //$desc_nfs = 'Prestação de serviços contábeis em Fevereiro de 2019. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              $desc_nfs = 'Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              if(!empty($obs)) {
                  $desc_nfs =  $obs.'. Valor aproximado dos tributos R$ '.str_replace(".", ",", number_format(strval($VALOR*0.1345),2)).' (Fonte IBPT 13,45%)';
              }
              $cod_cnae = '';
              $iss_aliquota = '2';
  
              // Dados do TOMADOR  
  
              $cnpj = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cnpj_cpf ;
              $razao_social = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cliente ; 
              $cmc = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cmc ; 
              $ie = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ie ; 
              $endereco = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_end ; 
              $end_n = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_n ; 
              $end_compl = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_comp ; 
              $bairro = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_bairro ; 
  
              $cidade = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cidade ; 
              $uf = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_uf ;
              $pais = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_pais ; 
              $cep = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_cep ;
              $cod_ibge = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ibge ;  
              $ddd = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_ddd ; 
              $tel = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_tel ; 
              $email = $this->db->get_where('w_dest_cliente_contsimples' , array('dest_cliente_id' => $cliente))->row()->dest_email ;   
  
              // FIM Dados TOMADOR              
  
  
              if (!empty($this->input->post('incentivador_cultural'))){
                  $incentivador_cultural = 2;
              } else { $incentivador_cultural = 2; };
  
              if (!empty($this->input->post('iss_retido'))){
                  $iss_retido = 2;
              } else { $iss_retido = 2; };

              $emissor = $this->notafiscal_model->get_client_info($cliente_emissor);
              //var_dump($row_emissor);

              $data['nfs']                    = $NFS;
              $data['nfs_num']                = $xnfs_num;
              $data['tipo_nfs']               = $tipo_nfs;
              $data['caminho']                = 'caminho';
              $data['cliente']                = $cliente_emissor;
              $data['dest_cliente']           = $cliente;
              $data['categoria']              = 'categoria';
              $data['desc_nfs']               = $desc_nfs;
              $data['quantidade']             = $quantidade;
              $data['valor']                  = str_replace(',','.',$VALOR); //ver
              $data['valor_liquido']          = str_replace(',','.',$VALOR); //ver
              $data['data_emissao']           = date("Y-m-d H:i:s", time());
              $data['data_competencia']       = date("Y-m-d H:i:s", time());
              $data['alt_data']               = date("Y-m-d H:i:s", time());
              $data['status']                 = 'Salva';
              $data['cod_verificacao']        = '';
              $data['nat_operacao']           = $nat_operacao;
              $data['opt_simplesnacional']    = '1';
              $data['incentivador_cultural']  = $incentivador_cultural;
              $data['outras_informacoes']     = 'Contribuinte ME, EPP ou MEI/Simples Nacional';
              $data['iss_retido']             = $iss_retido;
              $data['iss_valor']              = '0.00';
              $data['iss_aliquota']           = '0.00';
              $data['item_lista_servico']     = $item_lista_servico;
              $data['cod_cnae']               = $cod_cnae;
              $data['codigo_trib_municipio']  = $cod_tribut_municipio;
              $data['valor_deducao']          = $valor_deducao;
              $data['valor_desc_inc']         = $valor_desc_inc;
              $data['valor_desc_cond']        = $valor_desc_cond;
  
              $this->db->insert('nfs', $data);
  
              // incrementa nº nfs  
              $data2['nfs_num']     =  $xnfs_num+1;
              
              $this->db->where('cliente', $cliente_emissor);
              $this->db->update('nfs_n', $data2);
  
              //atualiza status da tabela de boleto
  
              $data_up['status_nf']                 = 'salva';
              
              $this->db->where('client_mensalidade_id', $id_mensalidade);
              $this->db->update('client_mensalidade', $data_up);
  
          }
          redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
      }                       
                       
              
          if ($param1 == 'create') {

              $client = $param2;
              //$Xcnpj_verifica = $this->db->get_where('dest_cliente', array('dest_cnpj_cpf' => str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf_cnpj'))))))->row()->cliente;

              if ($this->input->post('cpf_cnpj_novo') == '') {

                  $data3['dest_ie'] = str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('ie'))));
                  $data3['dest_cmc'] = str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('cmc'))));
                  $data3['dest_end'] = strtoupper($this->input->post('endereco'));
                  $data3['dest_n'] = strtoupper($this->input->post('end_n'));
                  $data3['dest_comp'] = strtoupper($this->input->post('end_compl'));
                  $data3['dest_bairro'] = strtoupper($this->input->post('bairro'));
                  $data3['dest_cidade'] = strtoupper($this->input->post('cidade'));                  
                  $data3['dest_uf'] = strtoupper($this->input->post('uf'));
                  $data3['dest_pais'] = strtoupper($this->input->post('pais'));
                  $data3['dest_cep'] = $this->input->post('cep');
                  $data3['dest_ibge'] = $this->input->post('ibge');
                  $data3['dest_email'] = $this->input->post('email');
                  $data3['dest_ddd'] = $this->input->post('ddd');
                  $data3['dest_tel'] = $this->input->post('tel');
                  $data3['dest_alt_data'] = $this->input->post('alt_data');
                  $this->db->where('dest_cliente_id', $this->input->post('dest_cliente'));
                  $this->db->update('dest_cliente', $data3);

                  $LastIdInserted = $this->input->post('dest_cliente');
              }

              else {

                  $data4['dest_cliente']       = strtoupper($this->input->post('razao_social'));
                  $data4['cliente']            =  $this->input->post('cliente');
                  $data4['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cpf_cnpj_novo'))));
                  $data4['dest_ie']            = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('ie'))));
                  $data4['dest_cmc']           = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('cmc'))));
                  $data4['dest_end']           = strtoupper($this->input->post('endereco'));
                  $data4['dest_n']             = strtoupper($this->input->post('end_n'));
                  $data4['dest_comp']          = strtoupper($this->input->post('end_compl'));
                  $data4['dest_bairro']        = strtoupper($this->input->post('bairro'));
                  $data4['dest_cidade']        = strtoupper($this->input->post('cidade'));              
                  $data4['dest_uf']            = strtoupper($this->input->post('uf'));
                  $data4['dest_pais']          = strtoupper($this->input->post('pais'));
                  $data4['dest_cep']           = $this->input->post('cep');
                  $data4['dest_ibge']          = $this->input->post('ibge');
                  $data4['dest_email']         = $this->input->post('email');
                  $data4['dest_ddd']           = $this->input->post('ddd');
                  $data4['dest_tel']           = $this->input->post('tel');
                  $data4['dest_desc']          = $this->input->post('dest_desc');
                  $data4['dest_data']          = $this->input->post('alt_data');
                  $data4['dest_alt_data']      = $this->input->post('alt_data');
                  $data4['dest_desc']          = $this->input->post('dest_desc');
                  $data4['dest_status']        = 'ativo';
                  $this->db->insert('dest_cliente', $data4);

                  $query = $this->db->query('SELECT LAST_INSERT_ID()');
                  $row = $query->row_array();
                  $LastIdInserted = $row['LAST_INSERT_ID()'];
                  

              };

              if (!empty($this->input->post('incentivador_cultural'))){
                  $incentivador_cultural = $this->input->post('incentivador_cultural');
              } else { $incentivador_cultural = 2; };

              if (!empty($this->input->post('iss_retido'))){
                  $iss_retido = $this->input->post('iss_retido');
              } else { $iss_retido = 2; };              
          

              $data['nfs']                    = $this->input->post('nfs');
              $data['nfs_num']                = $this->input->post('xnfs_num');
              $data['tipo_nfs']               = $this->input->post('tipo_nfs');
              $data['caminho']                = $this->input->post('caminho');
              $data['cliente']                = $this->input->post('cliente');
              $data['dest_cliente']           = $LastIdInserted;//$this->input->post('dest_cliente');
              $data['categoria']              = $this->input->post('categoria');
              $data['desc_nfs']               = $this->input->post('desc_nfs');
              $data['quantidade']             = $this->input->post('quantidade');
              $data['valor']                  = str_replace(',','.',$this->input->post('valor'));
              $data['valor_liquido']          = str_replace(',','.',$this->input->post('valor_liquido'));
              $data['data_emissao']           = $this->input->post('data_emissao');
              $data['data_competencia']       = $this->input->post('data_competencia');
              $data['alt_data']               = $this->input->post('alt_data');
              $data['status']                 = $this->input->post('status');
              $data['cod_verificacao']        = $this->input->post('cod_verificacao');
              $data['nat_operacao']           = $this->input->post('nat_operacao');
              $data['opt_simplesnacional']    = $this->input->post('opt_simplesnacional');
              $data['incentivador_cultural']  = $incentivador_cultural;
              $data['outras_informacoes']     = $this->input->post('outras_informacoes');
              $data['iss_retido']             = $iss_retido;
              $data['iss_valor']              = str_replace(',','.',$this->input->post('iss_valor'));
              $data['iss_aliquota']           = $this->input->post('iss_aliquota');
              $data['item_lista_servico']     = $this->input->post('item_lista_servico');
              $data['cod_cnae']               = $this->input->post('cod_cnae');
              $data['codigo_trib_municipio']  = $this->input->post('item_lista_servico');
              $data['valor_deducao']          = str_replace(',','.',$this->input->post('valor_deducao'));
              $data['valor_desc_inc']         = str_replace(',','.',$this->input->post('valor_desc_inc'));
              $data['valor_desc_cond']        = str_replace(',','.',$this->input->post('valor_desc_cond'));

              $this->db->insert('nfs', $data);

              // incrementa nº nfs

              $data2['nfs_num']     =  $this->input->post('xnfs_num')+1;
              $this->db->where('cliente', $this->input->post('cliente'));
              $this->db->update('nfs_n', $data2);

              $this->session->set_flashdata('flash_message', 'Nota Criada com Sucesso!!!');


              //move_uploaded_file($_FILES['recibo']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_R_'.$_FILES['recibo']['name']);
              //$this->session->set_flashdata('flash_message', 'Recibo Salvo!');

              redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
          } 
        if ($param1 == 'dest_cliente_consultar') {

                
            //consulta diferente para contsimples e clientes
            if ( $this->session->userdata('client_id') == '2'){
            
                $Xdados = $this->db->get_where('w_dest_cliente_contsimples', array('dest_cliente_id' => $param2))->result_array();
              
            } else {
            
                $Xdados = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $param2))->result_array();
            }

            $this->session->set_flashdata('Xdest_cliente', $Xdados);

            $Xdt_competencia = $this->input->post('data_competencia');

            $this->session->set_flashdata('Xdt_competencia', $Xdt_competencia);

            redirect(base_url() . 'notafiscal/nfs_emitir/', 'refresh');
        }
        if ($param1 == 'dest_cliente_consultar_edit') {

            $Xdados = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $param4))->result_array();

            $this->session->set_flashdata('Xdest_cliente', $Xdados);

            $Xdt_competencia = $this->input->post('data_competencia');

            $this->session->set_flashdata('Xdt_competencia', $Xdt_competencia);

            redirect(base_url() . 'notafiscal/nfs_editar/novo_dest/'.$param3, 'refresh');
        }

        if ($param1 == 'historico') {

            //echo $this->input->post('data_mes');
            //echo $this->input->post('data_ano');

            $XFiltro = $this->input->post('data_ano').'-'.$this->input->post('data_mes');

            $this->session->set_flashdata('XFiltro', $XFiltro);

            redirect(base_url() . 'notafiscal/nfs_emitir/', 'refresh');
        }


        $page_data['nfs']        = $this->db->get('nfs')->result_array();
        $page_data['page_name']  = 'nfs_emitir';
        $page_data['page_icon']  = 'file';
        $page_data['titulo']     = 'Emissão de Nota Fiscal de Serviços - NFS-e';
        $page_data['view']		 = 'cliente/nota-fiscal/nfs_emitir';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  editar ****/
    function nfs_editar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect('login_cliente', 'refresh');

        if (empty($param1)) {
            redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
        }

        if ($param1 == 'edit') {

        $incentivador_cultural = 0;
        if (!empty($this->input->post('incentivador_cultural'))){
            $incentivador_cultural = $this->input->post('incentivador_cultural');
        }

        $iss_retido = 0;
        if (!empty($this->input->post('iss_retido'))){
            $iss_retido = $this->input->post('iss_retido');
        }
        
        $novolote = $this->input->post('xnfs_num') + 1;

        $emissor = $this->notafiscal_model->get_client_info($param2);

        $data['dest_cliente']           = $this->input->post('dest_cliente_id');
        // informações e valores nfs
        $data['data_emissao']           = $this->input->post('data_emissao');
        $data['desc_nfs']               = $this->input->post('desc_nfs');
        $data['nat_operacao']           = $this->input->post('nat_operacao');
        $data['incentivador_cultural']  = $incentivador_cultural;
        $data['iss_retido']             = $iss_retido;
        $data['iss_valor']              = str_replace(',','.',$this->input->post('iss_valor'));
        $data['iss_aliquota']           = $this->input->post('iss_aliquota');
        $data['item_lista_servico']     = $this->input->post('item_lista_servico');
        $data['codigo_trib_municipio']  = $this->input->post('codigo_trib_municipio');
        $data['valor']                  = str_replace(',','.',$this->input->post('valor_servico'));
        $data['valor_liquido']          = str_replace(',','.',$this->input->post('valor_liquido'));
        $data['valor_deducao']          = str_replace(',','.',$this->input->post('valor_deducao'));
        $data['valor_desc_inc']         = str_replace(',','.',$this->input->post('valor_desc_inc'));
        $data['valor_desc_cond']        = str_replace(',','.',$this->input->post('valor_desc_cond'));
        // $data['tx2']                 = $tx2;

        $this->db->where('nfs_id', $param3);
        $this->db->update('nfs', $data);

        redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
    }

    if ($param1 == 'consultar') {
        $id_nfs = $param2;
        $buscar_nfs      = $this->db->get_where('nfs', 'nfs_id = '.$id_nfs)->result_array();
        $id_dest_cliente = $buscar_nfs[0]['dest_cliente'];
        $dest_cliente    = $this->db->get_where('dest_cliente', 'dest_cliente_id = '.$id_dest_cliente)->result_array();
        
        if($this->session->userdata('client_id') == '2') {
            $dest_cliente = $this->db->get_where('w_dest_cliente_contsimples', 'dest_cliente_id = '.$id_dest_cliente)->result_array();
        }

        $page_data['nfs']                     = $buscar_nfs;
        $page_data['nfs_dest_cliente']        = $dest_cliente;
    }
    if ($param1 == 'novo_dest') {
        $id_nfs = $param2;
        $buscar_nfs      = $this->db->get_where('nfs', 'nfs_id = '.$id_nfs)->result_array();

        $page_data['nfs']                     = $buscar_nfs;
    }
    
        $page_data['page_name'] = 'nfs_editar';
        $page_data['page_icon'] = 'file';
        $page_data['titulo']    = 'Editar NFS-e';
        $page_data['view']      = 'cliente/nota-fiscal/nfs_editar';
        $this->load->view('cliente/template/index', $page_data);

    }

      /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  enviar ****/
    function nfs_enviar($nfs_id)
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
      	
            // busca a nota no banco
            $nfs = $this->db->get_where('nfs', array('nfs_id' => $nfs_id))->row();
            // busca o destinatario da nota no banco
            if($this->session->userdata('client_id') == '2') {
                $dest_client = $this->db->get_where('w_dest_cliente_contsimples', array('dest_cliente_id' => $nfs->dest_cliente))->row();
            } else {
                $dest_client = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $nfs->dest_cliente))->row();
            }
            
            $client_id = $this->session->userdata('client_id');              
            
        if ($this->notafiscal_model->is_client_enotas($client_id)) {
        
            eNotasGW::configure(array(
          		'apiKey' => 'OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw'
          	));
            

            //var_dump($cod_interno_servico_municipal);
            //return;

                // verifica se a empresa é a contsimples
                if($this->session->userdata('client_id') == '2') {
                    
                    // emissão de nota pela Matriz                  
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client($client_id); 
                    $desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id($nfs_id);
                    $cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, $client_id);
                    
                    //Emissão pela Filial
                    //$empresaId = $this->notafiscal_model->get_enotas_id_by_client('1078');
                    //$desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id('1078');
                    //$cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, '1078');
                    
                    
                } else {
                
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client($client_id);
                    $desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id($nfs_id);
                    $cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, $client_id);
                    
                }            
            
            $tipo_pessoa = 'J';
            if(strlen($dest_client->dest_cnpj_cpf) == 11) {
                $tipo_pessoa = "F";
            }

            $idExterno = $nfs_id;
            
  /*          
            $teste = array(  // vai enviar a nfs para o enotas e retornar um ID
              "tipo" => "NFS-e",
              "idExterno" => $idExterno,
              "ambienteEmissao" => "Producao", //"Homologacao" ou "Producao",
              "enviarPorEmail" => true,	
              "cliente"  => array(
                  "endereco" => array(
                      "pais" => $dest_client->dest_pais,
                      "uf"   => $dest_client->dest_uf,
                      "cidade" => $dest_client->dest_cidade,
                      "logradouro" => $dest_client->dest_end,
                      "numero" => $dest_client->dest_n,
                      "complemento" => $dest_client->dest_comp,
                      "bairro" => $dest_client->dest_bairro,
                      "cep"    =>  $dest_client->dest_cep
                  ),
                  "tipoPessoa" => $tipo_pessoa,
                  "nome"    => $dest_client->dest_cliente,
                  "email"   => $dest_client->dest_email,
                  "cpfCnpj" => $dest_client->dest_cnpj_cpf,
                  //"inscricaoMunicipal"    => str_replace(' ', '', str_replace('/', '', str_replace('-', '', str_replace('.', '', $dest_client->dest_cmc)))),
                  //"inscricaoEstadual"     => $dest_client->dest_ie,
                  "telefone" => $dest_client->dest_ddd.$dest_client->dest_tel
              ),
              "servico" => array(
                  "codigoInternoServicoMunicipal" => $cod_interno_servico_municipal, //carinhas 239055 analise e desenvolvimento de sistemas. 
                  "descricao" => $nfs->desc_nfs,
                  "issRetidoFonte" => false,
                  "valorCofins" => 0,
                  "valorCsll" => 0,
                  "valorInss" => 0,
                  "valorIr" => 0,
                  "valorPis" => 0
              ),
              "valorTotal" => $nfs->valor_liquido
          		);
              
              var_dump($teste);
*/            
            try
          	{
          		$nfeId = eNotasGW::$NFeApi->emitir($empresaId, array(  // vai enviar a nfs para o enotas e retornar um ID
              "tipo" => "NFS-e",
              "idExterno" => $idExterno,
              "ambienteEmissao" => "Producao", //"Producao" ou "Producao",
              "dataCompetencia" => "2023-06-30",
              "enviarPorEmail" => true,	
              "cliente"  => array(
                  "endereco" => array(
                      "pais" => $dest_client->dest_pais,
                      "uf"   => $dest_client->dest_uf,
                      "cidade" => $dest_client->dest_cidade,
                      "logradouro" => $dest_client->dest_end,
                      "numero" => $dest_client->dest_n,
                      "complemento" => $dest_client->dest_comp,
                      "bairro" => $dest_client->dest_bairro,
                      "cep"    =>  $dest_client->dest_cep
                  ),
                  "tipoPessoa" => $tipo_pessoa,
                  "nome"    => $dest_client->dest_cliente,
                  "email"   => $dest_client->dest_email,
                  "cpfCnpj" => $dest_client->dest_cnpj_cpf,
                  //"inscricaoMunicipal"    => str_replace(' ', '', str_replace('/', '', str_replace('-', '', str_replace('.', '', $dest_client->dest_cmc)))),
                  //"inscricaoEstadual"     => $dest_client->dest_ie,
                  "telefone" => $dest_client->dest_ddd.$dest_client->dest_tel
              ),
              "servico" => array(
                  "codigoInternoServicoMunicipal" => $cod_interno_servico_municipal, //carinhas 239055 analise e desenvolvimento de sistemas. 
                  "descricao" => $nfs->desc_nfs,
                  "issRetidoFonte" => false,
                  "valorCofins" => 0,
                  "valorCsll" => 0,
                  "valorInss" => 0,
                  "valorIr" => 0,
                  "valorPis" => 0
              ),
              "valorTotal" => $nfs->valor_liquido
          		));
          		
          		  //echo 'Sucesso! <br>';
                //echo "ID da NFe: {$nfeId}";
                  
                $data = array(
                    'client_enotas_id' => $empresaId,
                    'cliente' => $nfs->cliente,
                    'email' => 'teste',
                    'enotas_id' => $nfeId
                );

                $nota['nfeId']  = $nfeId;
                $nota['status'] = 'Enviada';

                $return_model = $this->notafiscal_model->doUpdate($nota, $idExterno);
                
                $retorno = [
                    'erro' => 0,
                    'msg'  => $return_model . " ID da NFe: {$nfeId}"
                ];
                
          	}
          	catch(Exceptions\invalidApiKeyException $ex) {

          		  echo 'Erro de autenticação: </br></br>';
                echo $ex->getMessage();

                $data = array(
                    'mensagem' => $ex->getMessage()
                );
                
                $this->db->where('nfs_id', $idExterno);
                $this->db->update('nfs', $data);

                $retorno = [
                    'erro' => 1,
                    'msg'  => $ex->getMessage()
                ];

                echo json_encode($retorno);
          	}
          	catch(Exceptions\unauthorizedException $ex) {

          		  echo 'Acesso negado: </br></br>';
                echo $ex->getMessage();
                
                $data = array(
                    'mensagem' => $ex->getMessage()
                );
                
                $this->db->where('nfs_id', $idExterno);
                $this->db->update('nfs', $data);

                $retorno = [
                    'erro' => 1,
                    'msg'  => $ex->getMessage()
                ];

                echo json_encode($retorno);
          	}
          	catch(Exceptions\apiException $ex) {

                echo 'Erro de validação: </br></br>';
                echo $ex->getMessage();
                
                $data = array(
                    'mensagem' => $ex->getMessage()
                );
                
                $this->db->where('nfs_id', $idExterno);
                $this->db->update('nfs', $data);

                $retorno = [
                    'erro' => 1,
                    'msg'  => 'Erro de validação: '. utf8_encode($ex->getMessage()) 
                ];

                echo json_encode($retorno);
          	}
          	catch(Exceptions\requestException $ex) {
          		echo 'Erro na requisição web: </br></br>';
          		
          		echo 'Requested url: ' . $ex->requestedUrl;
          		echo '</br>';
          		echo 'Response Code: ' . $ex->getCode();
          		echo '</br>';
          		echo 'Message: ' . $ex->getMessage();
          		echo '</br>';
          		echo 'Response Body: ' . $ex->responseBody;
          	}
        } else {
            $this->session->set_flashdata('flash_message', 'Para emitir sua nota fiscal entre em contato através do Fale Conosco');
        }

        redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
    }
    
        /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  Enviar notas salvas - FINANCEIRO ****/
    function nfs_enviar_todas($client_id = null)
    {
    
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        /* Envia notas vigêntes */    
        $XQuery = "SELECT nfs_id FROM nfs WHERE cliente = '2' and status = 'Salva' and year(data_competencia) = year(CURDATE()) and month(data_competencia) = month(CURDATE())";
        
        /* Envia notas retroativas */
        $ano = '2023';
        $mes = '10';
        $XQuery = "SELECT nfs_id FROM nfs WHERE cliente = '2' and status = 'Salva' and year(data_competencia) = '".$ano."' and month(data_competencia) = '".$mes."' ;";
        /**/
        
        
        $gerar = @$this->db->query($XQuery)->result_array();
         
        foreach($gerar as $value){  
        // busca a nota no banco
            $nfs_id = $value['nfs_id'];
        
            $nfs = $this->db->get_where('nfs', array('nfs_id' => $nfs_id))->row();
            // busca o destinatario da nota no banco
            if($this->session->userdata('client_id') == '2') {
                $dest_client = $this->db->get_where('w_dest_cliente_contsimples', array('dest_cliente_id' => $nfs->dest_cliente))->row();
            } else {
                $dest_client = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $nfs->dest_cliente))->row();
            }
            
            $client_id = $this->session->userdata('client_id');              
            
            if ($this->notafiscal_model->is_client_enotas($client_id)) {
            
                eNotasGW::configure(array(
              		'apiKey' => 'OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw'
              	));
                
                
                // verifica se a empresa é a contsimples
                if($this->session->userdata('client_id') == '2') {
                    
                    // emissão de nota pela Matriz                  
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client($client_id); 
                    $desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id($nfs_id);
                    $cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, $client_id);
                    
                    if (empty($cod_interno_servico_municipal)) { $cod_interno_servico_municipal = '1719'; }
                    
                    //wrp 30/11/2023
                    $cod_interno_servico_municipal = '15005';
                    
                    //Emissão pela Filial
                    //$empresaId = $this->notafiscal_model->get_enotas_id_by_client('1078'); 
                    //$desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id('1078');
                    //$cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, '1078');

                    
                } else {
                
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client($client_id); 
                    $desc_atividade = $this->notafiscal_model->get_desc_atividade_by_nfs_id($nfs_id);
                    $cod_interno_servico_municipal = $this->notafiscal_model->get_cod_interno_servico_municipal($desc_atividade->descricao, $client_id);
                
                }
                
                
                $tipo_pessoa = 'J';
                if(strlen($dest_client->dest_cnpj_cpf) == 11) {
                    $tipo_pessoa = "F";
                }
    
                $idExterno = $nfs_id;

/* scrip de teste envio arry enotas  */              
                $teste  = array(  // vai enviar a nfs para o enotas e retornar um ID
                      "tipo" => "NFS-e",
                      "idExterno" => $idExterno,
                      "ambienteEmissao" => "Producao", //"Homologacao" ou "Producao",
                      "dataCompetencia" => "2023-10-31",
                      "enviarPorEmail" => false, // "enviarPorEmail" => true  or false
                      "dadosAdicionaisEmail" => array(
                          "outrosDestinatarios" => $dest_client->dest_email
                      ),	
                      "cliente"  => array(
                          "endereco" => array(
                              "pais" => $dest_client->dest_pais,
                              "uf"   => $dest_client->dest_uf,
                              "cidade" => $dest_client->dest_cidade,
                              "logradouro" => $dest_client->dest_end,
                              "numero" => $dest_client->dest_n,
                              "complemento" => $dest_client->dest_comp,
                              "bairro" => $dest_client->dest_bairro,
                              "cep"    =>  $dest_client->dest_cep
                          ),
                          "tipoPessoa" => $tipo_pessoa,
                          "nome"    => $dest_client->dest_cliente,
                          "email"   => $dest_client->dest_email, //$dest_client->dest_email, //    "notafiscal@contsimples.com.br"
                          //"email"   => "notafiscal@contsimples.com.br",
                          "cpfCnpj" => $dest_client->dest_cnpj_cpf,
                          //"inscricaoMunicipal"    => str_replace(' ', '', str_replace('/', '', str_replace('-', '', str_replace('.', '', $dest_client->dest_cmc)))),
                          //"inscricaoEstadual"     => $dest_client->dest_ie,
                          "telefone" => $dest_client->dest_ddd.$dest_client->dest_tel
                      ),
                      "servico" => array(
                          "codigoInternoServicoMunicipal" => $cod_interno_servico_municipal, //239055 analise e desenvolvimento de sistemas. 
                          "descricao" => $nfs->desc_nfs,
                          "issRetidoFonte" => false,
                          "valorCofins" => 0,
                          "valorCsll" => 0,
                          "valorInss" => 0,
                          "valorIr" => 0,
                          "valorPis" => 0
                      ),
                      "valorTotal" => $nfs->valor_liquido
              		);
                
                var_dump( $teste);
                
                //exit;
/**/                
                
                try
              	{
              		$nfeId = eNotasGW::$NFeApi->emitir($empresaId, array(  // vai enviar a nfs para o enotas e retornar um ID
                      "tipo" => "NFS-e",
                      "idExterno" => $idExterno,
                      "ambienteEmissao" => "Producao", //"Homologacao" ou "Producao",
                      "dataCompetencia" => "2023-10-31",
                      "enviarPorEmail" => false, // "enviarPorEmail" => true  or false
                      "dadosAdicionaisEmail" => array(
                          "outrosDestinatarios" => $dest_client->dest_email
                      ),	
                      "cliente"  => array(
                          "endereco" => array(
                              "pais" => $dest_client->dest_pais,
                              "uf"   => $dest_client->dest_uf,
                              "cidade" => $dest_client->dest_cidade,
                              "logradouro" => $dest_client->dest_end,
                              "numero" => $dest_client->dest_n,
                              "complemento" => $dest_client->dest_comp,
                              "bairro" => $dest_client->dest_bairro,
                              "cep"    =>  $dest_client->dest_cep
                          ),
                          "tipoPessoa" => $tipo_pessoa,
                          "nome"    => $dest_client->dest_cliente,
                          "email"   => $dest_client->dest_email, //$dest_client->dest_email, //    "notafiscal@contsimples.com.br"
                          //"email"   => "notafiscal@contsimples.com.br",
                          "cpfCnpj" => $dest_client->dest_cnpj_cpf,
                          //"inscricaoMunicipal"    => str_replace(' ', '', str_replace('/', '', str_replace('-', '', str_replace('.', '', $dest_client->dest_cmc)))),
                          //"inscricaoEstadual"     => $dest_client->dest_ie,
                          "telefone" => $dest_client->dest_ddd.$dest_client->dest_tel
                      ),
                      "servico" => array(
                          "codigoInternoServicoMunicipal" => $cod_interno_servico_municipal, //239055 analise e desenvolvimento de sistemas. 
                          "descricao" => $nfs->desc_nfs,
                          "issRetidoFonte" => false,
                          "valorCofins" => 0,
                          "valorCsll" => 0,
                          "valorInss" => 0,
                          "valorIr" => 0,
                          "valorPis" => 0
                      ),
                      "valorTotal" => $nfs->valor_liquido
              		));
              		
              		  //echo 'Sucesso! <br>';
                    //echo "ID da NFe: {$nfeId}";
                      
                    $data = array(
                        'client_enotas_id' => $empresaId,
                        'cliente' => $nfs->cliente,
                        'email' => 'teste',
                        'enotas_id' => $nfeId
                    );
    
                    $nota['nfeId']  = $nfeId;
                    $nota['status'] = 'Enviada';
    
                    $return_model = $this->notafiscal_model->doUpdate($nota, $idExterno);
                    
                    $retorno = [
                        'erro' => 0,
                        'msg'  => $return_model . " ID da NFe: {$nfeId}"
                    ];
                    
              	}
              	catch(Exceptions\invalidApiKeyException $ex) {
    
              		  echo 'Erro de autenticação: </br></br>';
                    echo $ex->getMessage();
    
                    $data = array(
                        'mensagem' => $ex->getMessage()
                    );
                    
                    $this->db->where('nfs_id', $idExterno);
                    $this->db->update('nfs', $data);
    
                    $retorno = [
                        'erro' => 1,
                        'msg'  => $ex->getMessage()
                    ];
    
                    echo json_encode($retorno);
              	}
              	catch(Exceptions\unauthorizedException $ex) {
    
              		  echo 'Acesso negado: </br></br>';
                    echo $ex->getMessage();
                    
                    $data = array(
                        'mensagem' => $ex->getMessage()
                    );
                    
                    $this->db->where('nfs_id', $idExterno);
                    $this->db->update('nfs', $data);
    
                    $retorno = [
                        'erro' => 1,
                        'msg'  => $ex->getMessage()
                    ];
    
                    echo json_encode($retorno);
              	}
              	catch(Exceptions\apiException $ex) {
    
                    echo 'Erro de validação: </br></br>';
                    echo $ex->getMessage();
                    
                    $data = array(
                        'mensagem' => $ex->getMessage()
                    );
                    
                    $this->db->where('nfs_id', $idExterno);
                    $this->db->update('nfs', $data);
    
                    $retorno = [
                        'erro' => 1,
                        'msg'  => 'Erro de validação: '. utf8_encode($ex->getMessage()) 
                    ];
    
                    echo json_encode($retorno);
              	}
              	catch(Exceptions\requestException $ex) {
              		echo 'Erro na requisição web: </br></br>';
              		
              		echo 'Requested url: ' . $ex->requestedUrl;
              		echo '</br>';
              		echo 'Response Code: ' . $ex->getCode();
              		echo '</br>';
              		echo 'Message: ' . $ex->getMessage();
              		echo '</br>';
              		echo 'Response Body: ' . $ex->responseBody;
              	}
            } else {
            $this->session->set_flashdata('flash_message', 'Para emitir sua nota fiscal entre em contato através do Fale Conosco');
        }
        
      } //finaliza o foreach
        $this->session->set_flashdata('flash_message', 'Notas Enviadas com Sucesso!!');           
        redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
    }
    
    /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  cancelar ****/
    function nfs_cancelar($nfs_id = null)
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
      	
            // busca a nota no banco
            $nfs      = $this->db->get_where('nfs', array('nfs_id' => $nfs_id))->row();
            // busca o destinatario da nota no banco
            $dest_client = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $nfs->dest_cliente))->row();
            
            eNotasGW::configure(array(
          		'apiKey' => 'OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw'
          	));
            
                if($this->session->userdata('client_id') == '2') {
                               
                    //Emissão pela Filial
                    //$empresaId = $this->notafiscal_model->get_enotas_id_by_client('1078');
                    
                    //Emissão pela Matriz
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client('2');
                    
                    
                    $idExterno = $nfs_id;
                    
                  } else {
                    $empresaId = $this->notafiscal_model->get_enotas_id_by_client($this->session->userdata('client_id'));
                    $idExterno = $nfs_id;
                  }            
            

            
            try
            {
                // descomentar caso queira efetuar o cancelamento pelo id Enotas
                //$nfeId = 'ab765f39-a2e0-4c4b-88b4-4b6b4a2baace';
                //eNotasGW::$NFeApi->cancelar($empresaId, $nfeId);
                
                eNotasGW::$NFeApi->cancelarPorIdExterno($empresaId, $idExterno);
                
                setMsg('msgNfs', 'Cancelamento solicitado com sucesso! Aguarde a Resposta da Prefeitura', 'sucesso');

                redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
            }
            catch(Exceptions\invalidApiKeyException $ex) {

                setMsg('msgNfs', 'Erro de autenticação: '.$ex->getMessage(), 'erro');
                redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
            }
            catch(Exceptions\unauthorizedException $ex) {

                setMsg('msgNfs', 'Acesso negado: '.$ex->getMessage(), 'erro');
                redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
            }
            catch(Exceptions\apiException $ex) {

                setMsg('msgNfs', 'Erro de validação: '.$ex->getMessage(), 'erro');
                redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
            }
            catch(Exceptions\requestException $ex) {

                setMsg('msgNfs', 'Erro na requisição web: '.$ex->getMessage(), 'erro');
                redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
            }
        
    }

    /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  cancelar ****/
    function nfs_tomadas($data_inicio = null, $data_fim = null)
    {

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

            // PEGA A DATA DO CALENDARIO FORMULARIO
            if (!empty($this->input->post("data_inicial"))) {
                $dataInicial = $this->input->post("data_inicial");
                $dataFinal   = $this->input->post("data_final");
            // FAZER SCRIPT PARA PEGAR DATA DO ULTIMO MES
            } else {
                $dataInicial = '2020-08-01';
                $dataFinal   = '2020-11-01';
            }            

            // PEGAR O ID_ENOTAS DO CLIENTE LOGADO
            $empresaId   = '76EA105E-6960-4E5C-B461-F07803510600';
                    
            $curl = curl_init();

            curl_setopt_array($curl, array(
                CURLOPT_URL => "https://api2.enotasgw.com.br/v3/empresas/76EA105E-6960-4E5C-B461-F07803510600/nota-tomada/nfs-e/consulta?dataInicial=".$dataInicial."&dataFinal=".$dataFinal,
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_ENCODING => "",
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_TIMEOUT => 0,
                CURLOPT_FOLLOWLOCATION => true,
                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                CURLOPT_CUSTOMREQUEST => "GET",
                CURLOPT_HTTPHEADER => array(
                "Authorization: Basic OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw",
                "Accept: application/json"
                ),
            ));
            
            $response = json_decode(curl_exec($curl));
            
            curl_close($curl);

            $page_data['response']   =  $response;
            $page_data['page_name']  = 'nfs_tomadas';
            $page_data['page_icon']  = 'calendar';
            $page_data['titulo']     = 'Notas de Serviço Tomadas';
            $page_data['view']		 = 'cliente/nota-fiscal/nfs_tomadas';

            $this->load->view('cliente/template/index', $page_data);
            
    }
    
    /**** NOTAS FISCAIS SERVIÇO |-> nfS  -  Download XML para nosso Servidor ****/
    function webhook($dadosnfs = null)
    {

        /* DADOS QUE A API RETORNA PARA O WEBKOOK
        {
            "tipo": "NFS-e",
            "empresaId": "string",
            "nfeId": "string",
            "nfeIdExterno": "string",
            "nfeStatus": "string",
            "nfeMotivoStatus": "string",
            "nfeLinkPdf": "http://api.enotasgw.com.br/file/(...)/pdf",
            "nfeLinkXml": "http://api.enotasgw.com.br/file/(...)/xml",
            "nfeNumero": "string",
            "nfeCodigoVerificacao": "string",
            "nfeNumeroRps": "string",
            "nfeSerieRps": "string",
            "nfeDataCompetencia": "date"
        } */
        
        function handleException($ex) {
      		//reportar que houve erro no processamento da notificação
      		header('HTTP/1.1 500 Internal Server Error');
      	}
        
      	function handleError($errno, $errstr, $errfile, $errline) {
      		//reportar que houve erro no processamento da notificação
      		header('HTTP/1.1 500 Internal Server Error');
      	}
      
      	set_exception_handler('handleException');
      	set_error_handler("handleError");
      
      	eNotasGW::configure(array(
      		'apiKey' => 'OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw'
      	));
      	
      	function downloadXml($empresaId, $nfeId, $nfeNumero) {
      		$xml = eNotasGW::$NFeApi->downloadXml($empresaId, $nfeId);
      		file_put_contents("Notas\Autorizadas\NF-{$nfeNumero}.xml", $xml);
      	}
      	
      	function downloadPdf($empresaId, $nfeId, $nfeNumero) {
      		$pdf = eNotasGW::$NFeApi->downloadPdf($empresaId, $nfeId);
      		file_put_contents("Notas\Autorizadas\NF-{$nfeNumero}.pdf", $pdf);
      	}
      	
      	function gerarLogNFeNegada($id, $motivoStatus) {
      		file_put_contents("Notas\Negadas\NF-{$id}-erros.txt", $motivoStatus);
      	}
      	
      	$postContent = file_get_contents("php://input");
      	
      	if(!empty($postContent)) {
      		$formatter = eNotasGW::getMediaFormatter($_SERVER['CONTENT_TYPE']);
      		$webHookData = $formatter->decode($postContent);
      		
      		switch(strtolower($webHookData->nfeStatus)) {
      			case 'autorizada':
      				//downloadXml($webHookData->empresaId, $webHookData->nfeId, $webHookData->nfeNumero);
      				//downloadPdf($webHookData->empresaId, $webHookData->nfeId, $webHookData->nfeNumero);
              
              $id_nota            = $webHookData->nfeIdExterno;
              $dados['status']    = strtoupper($webHookData->nfeStatus);
              $dados['nfs_num']   = $webHookData->nfeNumeroRps;
              $dados['caminho_pdf'] = $webHookData->nfeLinkPdf;
              $dados['caminho_xml'] = $webHookData->nfeLinkXml;
              $this->notafiscal_model->doUpdateWebhook($dados, $id_nota);
              
      				break;
      			case 'negada':
      				//gerarLogNFeNegada((empty($webHookData->nfeIdExterno) ? $webHookData->nfeId : $webHookData->nfeIdExterno), $webHookData->nfeMotivoStatus);
      				
              $id_nota            = $webHookData->nfeIdExterno;
              $dados['status']    = strtoupper($webHookData->nfeStatus);
              $dados['nfs_num']   = $webHookData->nfeNumero;
              $dados['mensagem']  = $webHookData->nfeMotivoStatus;
              $this->notafiscal_model->doUpdateWebhook($dados, $id_nota);
              
              break;
      			case 'cancelada':
      				if(!empty($webHookData->nfeNumero)) {
      					//download do pdf atualizado (com carimbo de cancelada)
      					//downloadPdf($webHookData->empresaId, $webHookData->nfeId, $webHookData->nfeNumero);
                
                $id_nota          = $webHookData->nfeIdExterno;
                $dados['status']  = strtoupper($webHookData->nfeStatus);
                $dados['caminho_pdf'] = $webHookData->nfeLinkPdf;
                $dados['caminho_xml'] = $webHookData->nfeLinkXml;
                $this->notafiscal_model->doUpdateWebhook($dados, $id_nota);
                
      				}
      				break;
      			default:
      				break;
      		}
      	}      

    }

    function insereLogo(){

        eNotasGW::configure(array(
            'apiKey' => 'OWEwZTE4M2ItMmFhMS00NjVmLTliNDAtNDNiNGRlMzYwNjAw',
        ));
        
        $empresaId = '76EA105E-6960-4E5C-B461-F07803510600';
        
        try
        {
            $file = fileParameter::fromPath('{logo image path}', 
                'image/png', 'logo.png');
            
            eNotasGW::$EmpresaApi->atualizarLogo($empresaId, $file);
            echo 'Logo atualizada com sucesso!';
        }
        catch(Exceptions\invalidApiKeyException $ex) {
            echo 'Erro de autenticação: </br></br>';
            echo $ex->getMessage();
        }
        catch(Exceptions\unauthorizedException $ex) {
            echo 'Acesso negado: </br></br>';
            echo $ex->getMessage();
        }
        catch(Exceptions\apiException $ex) {
            echo 'Erro de validação: </br></br>';
            echo $ex->getMessage();
        }
        catch(Exceptions\requestException $ex) {
            echo 'Erro na requisição web: </br></br>';
            
            echo 'Requested url: ' . $ex->requestedUrl;
            echo '</br>';
            echo 'Response Code: ' . $ex->getCode();
            echo '</br>';
            echo 'Message: ' . $ex->getMessage();
            echo '</br>';
            echo 'Response Body: ' . $ex->responseBody;
        }
    }

/**** NOTAS FISCAIS SERVIÇO |-> nfS  -  importar ****/
    function nfs_importar($param1 = '', $param2 = '', $param3 = '')
    {

        /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['xml']      = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->insert('xmls', $data);
            redirect(base_url() . 'notafiscal/nf_importar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['xml']        = $this->input->post('xml');
            $data['path']        = $this->input->post('path');
            $data['client']      = $this->input->post('client');
            $data['product']     = $this->input->post('product');
            $data['quantity']    = $this->input->post('quantity');
            $data['valor']       = $this->input->post('valor');
            $data['date']        = $this->input->post('date');
            $data['ind_up']      = $this->input->post('ind_up');
            //$data['rate']      = $this->input->post('rate');
            $data['status']      = $this->input->post('status');
            $this->db->where('xml_id', $param2);
            $this->db->update('xmls', $data);
            redirect(base_url() . 'notafiscal/nfs_importar/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_xml_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('xmls', array(
                'xml_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $Xdados = $this->db->get_where('xmls', array('xml_id' => $param2))->result_array();
            //print_r($Xdados);

            foreach($Xdados as $row):
                $origem = $row['path'];
                $destino = $origem;
            endforeach;
            //print_r($origem);

            $destino =  str_replace('/xml/','/_lixo/', $destino);
            //print_r($destino);

            copy($origem, $destino);
            unlink($origem);

            $this->db->where('xml_id', $param2);
            $this->db->delete('xmls');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');

        }
        if ($param1 == 'upload_info') {

            $Xrand =  mt_rand();

            if ( !empty($_FILES['file']['name'])){

                $XnovoNome = strtolower($this->caracter_model->t5f_translit($_FILES['file']['name']));

                $data['xml']         = $_FILES['file']['name'];
                $data['path']        = $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome;
                $data['client']      = $this->input->post('client');
                $data['product']     = $this->input->post('product');
                $data['desc_xml']    = $_FILES['file']['name'];
                $data['quantity']    = $this->input->post('quantity');
                $data['valor']       = $this->input->post('valor');
                $data['date']        = $this->input->post('date');
                $data['ind_up']      = $this->input->post('ind_up');
                $data['status']      = $this->input->post('status');
                $this->db->insert('xmls', $data);

                move_uploaded_file($_FILES['file']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_'.$Xrand.'_'.$XnovoNome);
                $this->session->set_flashdata('flash_message', 'Arquivo Enviado');

                redirect(base_url() . 'notafiscal/nfs_importar/', 'refresh');
            }  else
            {
                $this->session->set_flashdata('flash_message', 'Arquivo Não Importado, favor adicionar o arquivo');
                redirect(base_url() . 'notafiscal/nfs_importar/', 'refresh');
            }
        }
        
        $page_data['xmls']      = $this->db->get('xmls')->result_array();
        $page_data['page_name']  = 'nfs_importar';
        $page_data['page_icon'] = 'download-alt';
        $page_data['titulo'] = 'Nota Fiscal Serviço - Importar';
        $this->load->view('index', $page_data);
    }

/**** NOTAS FISCAIS SERVIÇO |-> nfS  -  consultar ****/
    function nfs_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        //$page_data['files']      = $this->db->get('nfs')->result_array();
        $page_data['nfs']        = $this->db->get_where('nfs', array('cliente' => $this->session->userdata('client_id')))->result_array();
        $page_data['page_name']  = 'nfs_consultar';
        $page_data['page_icon']  = 'search';
        $page_data['titulo'] = 'Nota Fiscal Serviço - Consultar';
        $page_data['view']       = 'cliente/nota-fiscal/nfs_consultar';
        $page_data['app_enotas'] = 'public/js/enotasgwt.js';
        $this->load->view('cliente/template/index', $page_data);

        if ($param1 == 'historico') {

            //echo $this->input->post('data_mes');
            //echo $this->input->post('data_ano');

            $XFiltro = $this->input->post('data_ano').'-'.$this->input->post('data_mes');

            $this->session->set_flashdata('XFiltro', $XFiltro);


            redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
        }
        if ($param1 == 'delete') {

            $this->db->where('nfs_id', $param2);
            $this->db->delete('nfs');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');
            redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');

        }
        if ($param1 == 'email') {

            $Xnota = $this->input->post('nfs_id');

            $data['status']      = 'processando';
            $this->db->where('nfs_id', $Xnota);
            $this->db->update('nfs', $data);


            $this->email_model->envia_email_cadastro_de_nota($Xnota);

            $this->session->set_flashdata('flash_message', 'Nota enviada! Favor aguardar retorno da prefeitura...');

            redirect(base_url() . 'notafiscal/nfs_consultar/', 'refresh');
        }

    }

/**** NOTAS FISCAIS INFO |-> nfS  -  rascunho ****/    
    function nfs_info($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if($param1 == 'rascunho') {
            global $nfs_id;
            $nfs_id = $param2;
        }

        $page_data['page_name']  = 'nfs_info';
        $page_data['nfs_info'] = $this->db->get_where('nfs', array('nfs_id' => $nfs_id))->result_array();
        $page_data['page_icon']  = 'search';
        $page_data['titulo'] = 'Nota Fiscal Serviço - Info';
        $page_data['view'] = 'cliente/nota-fiscal/nfs_info';
        $this->load->view('cliente/template/index', $page_data);

    }

    public function pegainfodest($dest_id)
    {
        $info = $this->notafiscal_model->get_dest_cliente_info($dest_id);

        $retorno['erro']         = 0;
        $retorno['dest_client']  = $info;
        echo json_encode($retorno);
    }
/**** FIM - BLOCO  -    NOTAS FISCAIS SERVIÇO |-> nfS    *****/
    
 /**** NOTAS FISCAIS CONTRATAR |-> nfS  ****/      
    function nfs_contratar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');            
        
        $page_data['page_name']  = 'nfs_contratar';
        $page_data['view']      = 'cliente/nota-fiscal/nfs_contratar';
        $page_data['page_icon'] = 'user';
        $page_data['titulo'] = 'Contratação Nota Fiscal';
        $this->load->view('cliente/template/index', $page_data);
    }    
/**** FIM - BLOCO  -    NOTAS FISCAIS CONTRATAR |-> nfS    *****/    
    
}