<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Prolabore extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		    $this->load->model('prolabore_model');

    }

	/**** BLOCO  - PRÓ LABORE |-> pro_labore

    Distribuição das cotas ||
    Cadastro dos Sócios ||

    *****/
    function pro_labore($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {
            $data['client']           = $this->input->post('client');
            $data['cnpj_cpf']         = $this->input->post('cnpj_cpf');
            $data['pj_pf']            = $this->input->post('pj_pf');
            $data['email']            = $this->input->post('email');
            $data['name']             = strtoupper($this->input->post('name'));
            $data['creation_date']    = $this->input->post('creation_date');
            $data['alt_date']         = $this->input->post('alt_date');
            $data['cota']             = $this->input->post('cota');
            $data['administrador']    = $this->input->post('administrador');
            $data['tem_pl']           = $this->input->post('tem_pl');
            $data['pl_valor']         = $this->input->post('pl_valor');
            $data['ddd_phone']        = $this->input->post('ddd_phone');
            $data['phone']            = $this->input->post('phone');
            $data['contact']          = $this->input->post('contact');
            $this->db->insert('client_socio', $data);

            redirect('prolabore/pro_labore/', 'refresh');
        }
        if ($param1 == 'do_update') {
            //$data['client']           = $this->input->post('client');
            //$data['cnpj_cpf']         = $this->input->post('cnpj_cpf');
            //$data['pj_pf']            = $this->input->post('pj_pf');
            $data['email']              = $this->input->post('email');
            //$data['name']             = strtoupper($this->input->post('name'));
            //$data['creation_date']    = $this->input->post('creation_date');
            $data['alt_date']           = $this->input->post('alt_date');
            //$data['cota']             = $this->input->post('cota');
            //$data['administrador']    = $this->input->post('administrador');
            //$data['tem_pl']           = $this->input->post('tem_pl');
            $data['pis']                = $this->input->post('pis');

            if  (strstr($this->input->post('pl_valor'),',')){
                $data['pl_valor'] = str_replace(',','.',str_replace('.','',$this->input->post('pl_valor')));
            } 
            else {  
                $data['pl_valor'] = $this->input->post('pl_valor');   }; 
                $data['ddd_phone']        = $this->input->post('ddd_phone');
                $data['phone']            = $this->input->post('phone');
                $data['contact']          = $this->input->post('contact');

            $this->db->where('client_socio_id', $param2);
            $this->db->update('client_socio', $data);

            $this->session->set_flashdata('flash_message', 'Cadastro Atualizado Com Sucesso!!!');

            redirect('prolabore/pro_labore/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']   = true;
            $page_data['current_client_socio_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('client_socio', array(
                'client_socio_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {
            $this->db->where('client_socio_id', $param2);
            $this->db->delete('client_socio');
            redirect('prolabore/pro_labore/', 'refresh');
        }

        $page_data['pro_labore']    =  $this->db->get_where('client_socio', array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['total_socios']  =  $this->prolabore_model->get_count_socio($this->session->userdata('client_id'));
        $page_data['page_name']     = 'pro_labore';
        $page_data['page_icon']     = 'briefcase';
        $page_data['view']		    = 'cliente/pro-labore/pro_labore';
        $page_data['titulo']        = 'Pró Labore';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** Pro Labore Resultados |-> pro_labore_relatorios****/
    function pro_labore_relatorios($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if ($param1 == 'update_status') {
            $data['status']         = 'Acessado';
            $data['data_acesso']    = date("d/m/Y H:i:s", time());
            $data['cliente_ip']     = $_SERVER['REMOTE_ADDR'];
            $this->db->where('file_id', $param2);
            $this->db->update('files', $data);
            
            redirect('prolabore/pro_labore_relatorios', 'refresh');
        }

        $page_data['pro_labore_relatorios']      = $this->db->order_by('date', 'DESC')->get_where('files',array('client' => $this->session->userdata('client_id'),'product'=>'72'))->result_array();
        $page_data['tipo']       = $this->prolabore_model->get_type_name_by_id('product', '72');
        $page_data['page_name']  = 'pro_labore_relatorios';
        $page_data['page_icon']  = 'print';
        $page_data['view']		 = 'cliente/pro-labore/pro_labore_relatorios';
        $page_data['titulo']     = 'Relatórios - Pró Labore';
        $this->load->view('cliente/template/index', $page_data);
    }


        /**** PRO_LABORE |-> CADASTRO  -  editar ****/
    function pro_labore_editar($param1 = '', $param2 = '', $param3 = '') {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if ($param1 == 'editar') {
            global $pro_labore_id;
            $pro_labore_id = $param2;
        }
        if ($param1 == 'do_update') {
            $data['alt_date']     = date('Y-m-d');
            $data['email']        = $this->input->post('email');
            $data['ddd_phone']    = $this->input->post('ddd_phone');
            $data['phone']        = $this->input->post('phone');  

            $this->db->where('client_socio_id', $param2);
            $this->db->update('client_socio', $data);
            
            $this->session->set_flashdata('flash_message', 'Registro alterado com sucesso!');
            redirect('prolabore/pro_labore/', 'refresh');
        }
        
        $page_data['pro_labore_editar']      = $this->db->get_where('client_socio', array('client_socio_id' => $pro_labore_id))->row();
        $page_data['page_name']  = 'pro_labore_editar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['view']		 = 'cliente/pro-labore/pro_labore_editar';
        $page_data['titulo']     = 'Editar - Pró Labore';
        $this->load->view('cliente/template/index', $page_data);
    }
    
/**** PRO_LABORE |-> CADASTRO  -  visualizar ****/
    function pro_labore_visualizar($param1 = '', $param2 = '', $param3 = '') {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if ($param1 == 'visualizar') {
            global $pro_labore_id;
            $pro_labore_id = $param2;
        }
        
        $page_data['pro_labore_visualizar']      = $this->db->get_where('client_socio', array('client_socio_id' => $pro_labore_id))->row();
        $page_data['page_name']  = 'pro_labore_visualizar';
        $page_data['page_icon']  = 'download-alt';
        $page_data['view']		 = 'cliente/pro-labore/pro_labore_visualizar';
        $page_data['titulo']     = 'Visualizar - Pró Labore';
        $this->load->view('cliente/template/index', $page_data);
    }
        
    }