<?php
defined('BASEPATH') OR exit('No direct script access allowed');
date_default_timezone_set('America/Sao_Paulo');

class Recibo extends CI_Controller {

	public function __construct()
    {
        parent::__construct();

		$this->load->model('recibo_model');
		$this->load->model('caracter_model');
    }

    function meus_clientes($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'create') {

            $this->form_validation->set_rules('dest_cnpj_cpf', 'CPF OU CNPJ', 'trim|required');

            if($this->form_validation->run()) {
                $data['dest_cliente']       = strtoupper($this->input->post('dest_cliente'));
                $data['cliente']            =  $this->input->post('cliente');
                $data['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cnpj_cpf'))));
                $data['dest_ie']            = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_ie'))));
                $data['dest_cmc']           = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cmc'))));
                $data['dest_end']           = mb_strtoupper($this->input->post('dest_end'), 'UTF-8');
                $data['dest_n']             = strtoupper($this->input->post('dest_n'));
                $data['dest_comp']          = mb_strtoupper($this->input->post('dest_comp'), 'UTF-8');
                $data['dest_bairro']        = mb_strtoupper($this->input->post('dest_bairro'), 'UTF-8');
                $data['dest_cidade']        = mb_strtoupper($this->input->post('dest_cidade'), 'UTF-8');
                $data['dest_uf']            = strtoupper($this->input->post('dest_uf'));
                $data['dest_pais']          = strtoupper($this->input->post('dest_pais'));
                $data['dest_cep']           = $this->input->post('dest_cep');
                $data['dest_email']         = $this->input->post('dest_email');
                $data['dest_ddd']           = $this->input->post('dest_ddd');
                $data['dest_tel']           = $this->input->post('dest_tel');
                $data['dest_desc']          = $this->input->post('dest_desc');
                $data['dest_data']          = date('Y-m-d');
                $data['dest_alt_data']      = date('Y-m-d');
                $data['dest_desc']          = $this->input->post('dest_desc');
                $data['dest_status']        = $this->input->post('dest_status');
                $this->db->insert('dest_cliente', $data);

                $this->session->set_flashdata('flash_message', 'Cliente adicionado com sucesso!!!');

                redirect('recibo/meus_clientes/', 'refresh');

            } else {
                setMsg('msgCadastro', 'Erro ao cadastrar', 'erro');
                redirect('recibo/meus_clientes/', 'refresh');
            }

        }
        if ($param1 == 'do_update') {
            $data['dest_cliente']       = strtoupper($this->input->post('dest_cliente'));
            $data['cliente']            =  $this->input->post('cliente');
            $data['dest_cnpj_cpf']      = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cnpj_cpf'))));
            $data['dest_ie']            = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_ie'))));
            $data['dest_cmc']           = str_replace('/','',str_replace('.','',str_replace('-','',$this->input->post('dest_cmc'))));
            $data['dest_end']           = strtoupper($this->input->post('dest_end'));
            $data['dest_n']             = strtoupper($this->input->post('dest_n'));
            $data['dest_comp']          = strtoupper($this->input->post('dest_comp'));
            $data['dest_bairro']        = strtoupper($this->input->post('dest_bairro'));
            $data['dest_cidade']        = strtoupper($this->input->post('dest_cidade'));
            $data['dest_uf']            = strtoupper($this->input->post('dest_uf'));
            $data['dest_pais']          = strtoupper($this->input->post('dest_pais'));
            $data['dest_cep']           = $this->input->post('dest_cep');
            $data['dest_email']         = $this->input->post('dest_email');
            $data['dest_ddd']           = $this->input->post('dest_ddd');
            $data['dest_tel']           = $this->input->post('dest_tel');
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_data']          = $this->input->post('dest_data');
            $data['dest_alt_data']      = dataDiaDb();
            $data['dest_desc']          = $this->input->post('dest_desc');
            $data['dest_status']        = $this->input->post('dest_status');

            $this->db->where('dest_cliente_id', $param2);
            $this->db->update('dest_cliente', $data);

            redirect(base_url() . 'recibo/meus_clientes/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile']  = true;
            $page_data['current_dest_cliente_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('dest_cliente', array(
                'dest_cliente_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $data['dest_status']        = 'inativo';

            $this->db->where('dest_cliente_id', $param2);
            $this->db->update('dest_cliente', $data);
            redirect(base_url() . 'recibo/meus_clientes/', 'refresh');

        }

        $page_data['client']    = $this->db->get('dest_cliente')->result_array();
        $page_data['view']      = 'cliente/recibo/meus_clientes';
        $page_data['page_icon'] = 'user';
        $page_data['titulo'] = 'Cadastro de Clientes';
        $page_data['client_pj_pf'] = $this->recibo_model->get_client_pj_pf($this->session->userdata('client_id'));

        $this->load->view('cliente/template/index', $page_data);

    }

    /**** MOV |-> Movimentações  -  Recibos ****/
    function mov_recibos($param1 = '', $param2 = '', $param3 = '')
    {
                /**** Definição de variáveis *****/
        $Xrand = '';
        $origem = '';
        $destino = '';
        $XnovoNome = '';

        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');
            
        if ($param1 == 'create') {

            // cliente não encontrado
            if ($this->input->post('dest_cliente') == '')
                $XNome_Cliente = $this->input->post('rec_cliente');
            else
                $XNome_Cliente = $this->db->get_where('dest_cliente', array(
                    'dest_cliente_id' => $this->input->post('dest_cliente')))->row()->dest_cliente;

                //move_uploaded_file($_FILES['recibo']['tmp_name'], $this->input->post('path').$this->input->post('alterdata').'_R_'.$_FILES['recibo']['name']);
                //$this->session->set_flashdata('flash_message', 'Recibo Salvo!');

                //$data['recibo']       = $_FILES['recibo']['name'];
                $data['recibo']       = $this->input->post('recibo');
                $data['recibo_num']   = $this->input->post('xrecibo_n');
                $data['tipo_recibo']  = $this->input->post('tipo_recibo');
                //$data['path']         = $this->input->post('path').$this->input->post('alterdata').'_R_'.$_FILES['recibo']['name'];
                $data['path']         = 'Sem Arquivo';
                $data['client']       = $this->input->post('client');
                $data['category']     = $this->input->post('category');
                $data['desc_recibo']  = $this->input->post('desc_recibo');
                $data['quantity']     = $this->input->post('quantity');
                $data['valor']        = str_replace(',','.',$this->input->post('valor'));
                $data['date']         = $this->input->post('date');
                $data['alt_date']     = $this->input->post('alt_date');
                $data['atend_date']   = date('Y-m-d',strtotime($this->input->post('rec_atend_date')));
                $data['status']       = $this->input->post('status');
                $data['rec_cliente']  = $XNome_Cliente;
                $data['rec_doc']      = $this->input->post('rec_doc');
                $data['rec_end']      = $this->input->post('rec_end');
                $data['rec_n']        = $this->input->post('rec_n');
                $data['rec_comp']     = $this->input->post('rec_comp');
                $data['rec_bairro']   = $this->input->post('rec_bairro');
                $data['rec_cidade']   = $this->input->post('rec_cidade');
                $data['rec_uf']       = $this->input->post('rec_uf');
                $data['rec_cep']      = $this->input->post('rec_cep');
                $data['rec_ddd']      = $this->input->post('rec_ddd');
                $data['rec_tel']      = $this->input->post('rec_tel');
                $data['rec_email']    = $this->input->post('rec_email');
                $data['rec_desc']     = $this->input->post('rec_desc');

                $this->db->insert('recibo', $data);

                // incrementa nº recibo

                $data3['recibo_num']     =  $this->input->post('xrecibo_n')+1;
                $this->db->where('client', $this->input->post('client'));
                $this->db->update('recibo_n', $data3);

                $this->session->set_flashdata('flash_message', 'Recibo Criado com Sucesso!!!');

                // verifica se cpf ou cnpj já existe então atualiza ou cadastra

                $XCpf_Cnpj = $this->db->get_where('dest_cliente', array(
                    'cliente' => $this->input->post('client')))->result_array();

                $XnDest_Client_ID = 0 ;

                foreach($XCpf_Cnpj as $XCpf_Cnpj_row):
                    if ($XCpf_Cnpj_row['dest_cnpj_cpf'] == str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('rec_doc')))))
                        $XnDest_Client_ID = $XnDest_Client_ID + 1;
                endforeach;

                if ($XnDest_Client_ID == 0) {
                    $data2['dest_cliente'] = strtoupper($this->input->post('rec_cliente'));
                    $data2['cliente'] = $this->input->post('client');
                    $data2['dest_ie'] = '';
                    $data2['dest_cmc'] = '';
                    $data2['dest_cnpj_cpf'] = str_replace('/', '', str_replace('.', '', str_replace('-', '', $this->input->post('rec_doc'))));
                    $data2['dest_end'] = strtoupper($this->input->post('rec_end'));
                    $data2['dest_n'] = strtoupper($this->input->post('rec_n'));
                    $data2['dest_comp'] = strtoupper($this->input->post('rec_comp'));
                    $data2['dest_bairro'] = strtoupper($this->input->post('rec_bairro'));
                    $data2['dest_cidade'] = strtoupper($this->input->post('rec_cidade'));
                    $data2['dest_uf'] = strtoupper($this->input->post('rec_uf'));
                    $data2['dest_pais'] = $this->input->post('rec_pais');
                    $data2['dest_cep'] = $this->input->post('rec_cep');
                    $data2['dest_email'] = $this->input->post('rec_email');
                    $data2['dest_ddd'] = $this->input->post('rec_ddd');
                    $data2['dest_tel'] = $this->input->post('rec_tel');
                    $data2['dest_desc'] = 'Cliente gerado pelo Recibo';
                    $data2['dest_data'] = date('Y-m-d');
                    $data2['dest_alt_data'] = date('Y-m-d');
                    $data2['dest_status'] = 'ativo';
                    $this->db->insert('dest_cliente', $data2);

                    $LastIdInserted = $this->input->post('dest_cliente');
            }

            redirect(base_url() . 'recibo/mov_recibos_consultar/', 'refresh');
        }
        if ($param1 == 'do_update') {
            $data['recibo']       = $this->input->post('recibo');
            $data['tipo_recibo']  = $this->input->post('tipo_recibo');
            $data['path']         = $this->input->post('path');
            $data['client']       = $this->input->post('client');
            $data['category']     = $this->input->post('category');
            $data['desc_recibo']  = $this->input->post('recibo');
            $data['quantity']     = $this->input->post('quantity');
            $data['valor']        = $this->input->post('valor');
            $data['date']         = $this->input->post('date');
            $data['alt_date']     = $this->input->post('alt_date');
            $data['status']       = $this->input->post('status');
            $this->db->where('recibo_id', $param2);
            $this->db->update('recibo', $data);
            redirect(base_url() . 'recibo/mov_recibos/', 'refresh');

        } else if ($param1 == 'personal_profile') {
            $page_data['personal_profile'] = true;
            $page_data['current_file_id'] = $param2;

        } else if ($param1 == 'edit') {
            $page_data['edit_data'] = $this->db->get_where('recibo', array(
                'recibo_id' => $param2
            ))->result_array();
        }
        if ($param1 == 'delete') {

            $caminho =  $this->db->get_where('recibo', array('recibo_id' => $param2))->result_array();
            //delte_file($caminho['path'])

            $this->db->where('recibo_id', $param2);
            $this->db->delete('recibo');
            $this->session->set_flashdata('flash_message', 'Arquivo Deletado!');

            redirect(base_url() . 'recibo/mov_recibos_consultar/', 'refresh');
        }
        if ($param1 == 'cancelar') {

            $data['quantity']     = '0';
            $data['alt_date']     = (date('Y-m-d'));
            $data['status']       = 'cancelado';
            $this->db->where('recibo_id', $param2);
            $this->db->update('recibo', $data);

            $this->session->set_flashdata('flash_message', 'Recibo Cancelado!');

            redirect(base_url() . 'recibo/mov_recibos_consultar/', 'refresh');
        }
        if ($param1 == 'dest_cliente_consultar') {

            $Xdados = $this->db->get_where('dest_cliente', array('dest_cliente_id' => $param2))->result_array();

            $this->session->set_flashdata('Xdest_cliente', $Xdados);

            $valor = $this->input->post('valor');
            $this->session->set_flashdata('Xvalor', $valor);

            redirect(base_url() . 'recibo/mov_recibos/', 'refresh');
        }

        /* $page_data['rec']        =  $this->db->get_where('recibo', array('client' => ''))->result_array();
        $page_data['mov']        =  $this->db->get('recibo')->result_array(); */
        $page_data['client_alterdata']   =  $this->recibo_model->get_client_info($this->session->userdata('client_id'));
        $page_data['num_recibo'] =  $this->recibo_model->get_recibo_num_by_client($this->session->userdata('client_id'));
        $page_data['tomador']    =  $this->recibo_model->get_client_dest_cliente_all_info($this->session->userdata('client_id'));
        $page_data['page_name']  = 'mov_recibos';
        $page_data['page_icon']  = 'list-alt';
        $page_data['view']       = 'cliente/recibo/mov_recibos';
        $page_data['titulo'] = 'Recibo - Emitir Recibo';
        $this->load->view('cliente/template/index', $page_data);
    }

    /**** MOV |-> Movimentações  -  Recibos Consultar****/
    function mov_recibos_consultar($param1 = '', $param2 = '', $param3 = '')
    {
        if ($this->session->userdata('client_login') != 1)
            redirect(base_url(), 'refresh');

        if ($param1 == 'historico') {

            //echo $this->input->post('data_mes');
            //echo $this->input->post('data_ano');

            $XFiltro = $this->input->post('data_ano').'-'.$this->input->post('data_mes');

            $this->session->set_flashdata('XFiltro', $XFiltro);

            redirect(base_url() . 'recibo/mov_recibos_consultar/', 'refresh');
        }

        if ($param1 == 'email') {

        //$data = $this->db->get_where('recibo', array('recibo_id' => $this->input->post('recibo_id')));
        $data =  [];
        $XRecido_id_envia_cliente = $this->input->post('recibo_id');
        $this->session->set_flashdata('XRecido_id_envia_cliente', $XRecido_id_envia_cliente);
        //load the view and saved it into $html variable
        $html=$this->load->view('cliente/recibo/mov_recibos_imprimir', $data, true);

        echo  $html;
        //this the the PDF filename that user will get to download
        $pdfFilePath = "output_pdf_name.pdf";

        echo  $pdfFilePath;

       //generate the PDF from the given html
        $this->pdf->pdf->WriteHTML($html);

        echo $this->pdf->pdf->WriteHTML($html);
        //download it.
        $this->pdf->pdf->Output($pdfFilePath, "D");

        echo $this->pdf->pdf->Output($pdfFilePath, "D");

        // Envio Email
        $Xn_recibo        = $this->db->get_where('recibo', array('recibo_id' => $this->input->post('recibo_id')))->row()->recibo_num;
        $Xn_rec_email     = $this->db->get_where('recibo', array('recibo_id' => $this->input->post('recibo_id')))->row()->rec_email;
        
        }

        $page_data['rec']        =  $this->db->get_where('recibo', array('client' => ''))->result_array();
        $page_data['mov']        =  $this->db->get_where('recibo',array('client' => $this->session->userdata('client_id')))->result_array();
        $page_data['nome']        = $this->recibo_model->get_type_name_by_id('client', $this->session->userdata('client_id'));
        $page_data['page_name']  = 'mov_recibos_consultar';
        $page_data['page_icon']  = 'search';
        $page_data['view']       = 'cliente/recibo/mov_recibos_consultar';
        $page_data['titulo']     = 'Recibo - Consultar Recibos';
        $this->load->view('cliente/template/index', $page_data);
    }

}