<?php defined('BASEPATH') OR exit('No direct script access allowed');

// Cria variáveis para montar o menu de Balancete período e botão solicite serviço avulso
function menu()
{
    $CI =& get_instance();
    $CI->load->model('relatorios_model');

    $page_data['nome']          = $CI->relatorios_model->get_name_by_client($CI->session->userdata('client_id'));
    $page_data['email']         = $CI->relatorios_model->get_email_by_client($CI->session->userdata('client_id'));
    $page_data['custom1']       = $CI->relatorios_model->get_alterdata_by_client($CI->session->userdata('client_id'));

    return $page_data;
}

// SETAR UMA MENSAGEM
function setMsg($id, $msg, $tipo) {
    $CI =& get_instance();

    switch ($tipo) {
        case 'erro':
            $CI->session->set_flashdata($id, '<div class="alert alert-danger" role="alert">'.$msg.'</div>');
            break;
        
        case 'sucesso':
            $CI->session->set_flashdata($id, '<div class="alert alert-success" role="alert">'.$msg.'</div>');
            break;
    }

    return FALSE;
}

// RECUPERAR UMA MENSAGEM
function getMsg($id) {
    $CI =& get_instance();

    if ($CI->session->flashdata($id)) {
        echo $CI->session->flashdata($id);
    }
}

// MOSTRA OS ERROS DE VALIDAÇÃO DE FORMULARIOS APOS O POST
function errosValidacao() {
    if (validation_errors()) {
        echo '<div class="alert alert-danger" role="alert">'.validation_errors().'</div>';
    }
}

// RECUPERAR A DATA E HORA ATUAL
function dataDiaDb()
{
    date_default_timezone_set('America/Sao_paulo');
    $formato = 'DATE_W3C';
    $hora    = time();
    return standard_date($formato, $hora);
}

// RECUPERAR A DATA ATUAL
function dataDb()
{
    date_default_timezone_set('America/Sao_paulo');
    $formato = '%Y-%m-%d';
    $data    = time();
    $data    = mdate($formato, $data);
    return $data;
}

function formataDataDb($data = null)
{
    /* FORMATA A DATA PARA INSERIR NO BANCO
       ENTRADA -> 10/12/1980
       SAIDA RETURN -> 1980-12-10 
    */
    if ($data) {
        $data = explode('/', $data);
        $dia = $data[0];
        $mes = $data[1];
        $ano = $data[2];

        return $ano. '-' .$mes. '-' .$dia;
    }
}

function formataDataView($data = null)
{
    /* FORMATA A DATA PARA MOSRAR NA VIEW
       ENTRADA -> 2000-12-10 
       SAIDA RETURN -> 10/12/2000
    */
    if ($data) {
        $data = explode('-', $data);
        $ano = $data[0];
        $mes = $data[1];
        $dia = $data[2];

        return $dia. '/' .$mes. '/' .$ano;
    }
}

// FORMATAR UM VALOR PARA VIEW
function formataMoedaReal($valor = null, $real = false)
{
    if ($valor) {
        $valor = ($real == TRUE ? 'R$ ' : '') . number_format($valor, 2, ',', '.');
        return $valor;
    }    
}

// FORMATAR UM VALOR PARA BD
function formataDecimal($valor = null)
{
    if ($valor) {
        $valor = str_replace('.', '', $valor);
        $valor = str_replace(',', '', $valor);
        return $valor;
    }    
}

function slug($string=NULL)
{
	$string = remove_acentos($string);
	return url_title($string, '-', TRUE);
}

// REMOVER ACENTOS
function remove_acentos($string=NULL)
{
	$procurar    = array('À','Á','Ã','Â','É','Ê','Í','Ó','Õ','Ô','Ú','Ü','Ç','à','á','ã','â','é','ê','í','ó','õ','ô','ú','ü','ç');
	$substituir  = array('a','a','a','a','e','r','i','o','o','o','u','u','c','a','a','a','a','e','e','i','o','o','o','u','u','c');
	return str_replace($procurar, $substituir, $string);
}

function clear_cache()
{
    $this->output->set_header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
    $this->output->set_header('Pragma: no-cache');
}


/**
 * Limpar nome de arquivo no upload
 * 
 * Sanitization test done with the filename:
 * ÄäÆæÀàÁáÂâÃãÅåªₐāĆćÇçÐđÈèÉéÊêËëₑƒğĞÌìÍíÎîÏïīıÑñⁿÒòÓóÔôÕõØøₒÖöŒœßŠšşŞ™ÙùÚúÛûÜüÝýÿŽž¢€‰№$℃°C℉°F⁰¹²³⁴⁵⁶⁷⁸⁹₀₁₂₃₄₅₆₇₈₉±×₊₌⁼⁻₋–—‑․‥…‧.png
 * @author toscho
 * @url    https://github.com/toscho/Germanix-WordPress-Plugin
 */
function t5f_sanitize_filename( $filename )
{

    $filename    = html_entity_decode( $filename, ENT_QUOTES, 'utf-8' );
    $filename    = t5f_translit( $filename );
    $filename    = t5f_lower_ascii( $filename );
    $filename    = t5f_remove_doubles( $filename );
    return $filename;
}

/**
 * Converte maiúsculas em minúsculas e remove o resto.
 * https://github.com/toscho/Germanix-WordPress-Plugin
 *
 * @uses   apply_filters( 'germanix_lower_ascii_regex' )
 * @param  string $str Input string
 * @return string
 */

function t5f_lower_ascii( $str )
{
    $str     = strtolower( $str );
    $regex   = array(
        'pattern'        => '~([^a-z\d_.-])~'
        , 'replacement'  => ''
    );
    // Leave underscores, otherwise the taxonomy tag cloud in the
    // backend won’t work anymore.
    return preg_replace( $regex['pattern'], $regex['replacement'], $str );
}
/**
 * Pega o mês de uma data e transforma em extenso
 * criado por Wallace Pacheco
**/

	function get_dia_do_mes($mes)
	{ 
        switch ($mes){
 
            case 1: $mes_por_extenso = "JANEIRO"; break;
            case 2: $mes_por_extenso = "FEVEREIRO"; break;
            case 3: $mes_por_extenso = "MARÇO"; break;
            case 4: $mes_por_extenso = "ABRIL"; break;
            case 5: $mes_por_extenso = "MAIO"; break;
            case 6: $mes_por_extenso = "JUNHO"; break;
            case 7: $mes_por_extenso = "JULHO"; break;
            case 8: $mes_por_extenso = "AGOSTO"; break;
            case 9: $mes_por_extenso = "SETEMBRO"; break;
            case 10: $mes_por_extenso = "OUTUBRO"; break;
            case 11: $mes_por_extenso = "NOVEMBRO"; break;
            case 12: $mes_por_extenso = "DEZEMBRO"; break;
                               
            }
    
            return $mes_por_extenso;
	}

/**
 * Pega um valor e atribui a mascara
 * criado por Wallace Pacheco
**/
  
  function mask($val, $mask)
  {
  
   $maskared = '';
   $k = 0;
   for($i = 0; $i<=strlen($mask)-1; $i++)
   {
     if($mask[$i] == '#')
     {
     if(isset($val[$k]))
      $maskared .= $val[$k++];
     }
     else
     {
     if(isset($mask[$i]))
      $maskared .= $mask[$i];
     }
   }
   return $maskared;
  }


/**
 * Reduz meta caracteres (-=+.) repetidos para apenas um.
 * https://github.com/toscho/Germanix-WordPress-Plugin
 *
 * @param  string $str Input string
 * @return string
 */
function t5f_remove_doubles( $str )
{
    $regex = array(
        'pattern'        => '~([=+.-])\\1+~'
        , 'replacement'  => "\\1"
    );
    return preg_replace( $regex['pattern'], $regex['replacement'], $str );
}


/**
 * Substitui caracteres não-ASCII.
 * https://github.com/toscho/Germanix-WordPress-Plugin
 *
 * Modified version of Heiko Rabe’s code.
 *
 * @author Heiko Rabe http://code-styling.de
 * @link   http://www.code-styling.de/?p=574
 * @param  string $str
 * @return string
 */
function t5f_translit( $str )
{
    $utf8 = array(
        'Ä'  => 'Ae'
        , 'ä'    => 'ae'
        , 'Æ'    => 'Ae'
        , 'æ'    => 'ae'
        , 'À'    => 'A'
        , 'à'    => 'a'
        , 'Á'    => 'A'
        , 'á'    => 'a'
        , 'Â'    => 'A'
        , 'â'    => 'a'
        , 'Ã'    => 'A'
        , 'ã'    => 'a'
        , 'Å'    => 'A'
        , 'å'    => 'a'
        , 'ª'    => 'a'
        , 'ₐ'    => 'a'
        , 'ā'    => 'a'
        , 'Ć'    => 'C'
        , 'ć'    => 'c'
        , 'Ç'    => 'C'
        , 'ç'    => 'c'
        , 'Ð'    => 'D'
        , 'đ'    => 'd'
        , 'È'    => 'E'
        , 'è'    => 'e'
        , 'É'    => 'E'
        , 'é'    => 'e'
        , 'Ê'    => 'E'
        , 'ê'    => 'e'
        , 'Ë'    => 'E'
        , 'ë'    => 'e'
        , 'ₑ'    => 'e'
        , 'ƒ'    => 'f'
        , 'ğ'    => 'g'
        , 'Ğ'    => 'G'
        , 'Ì'    => 'I'
        , 'ì'    => 'i'
        , 'Í'    => 'I'
        , 'í'    => 'i'
        , 'Î'    => 'I'
        , 'î'    => 'i'
        , 'Ï'    => 'Ii'
        , 'ï'    => 'ii'
        , 'ī'    => 'i'
        , 'ı'    => 'i'
        , 'I'    => 'I' // turkish, correct?
        , 'Ñ'    => 'N'
        , 'ñ'    => 'n'
        , 'ⁿ'    => 'n'
        , 'Ò'    => 'O'
        , 'ò'    => 'o'
        , 'Ó'    => 'O'
        , 'ó'    => 'o'
        , 'Ô'    => 'O'
        , 'ô'    => 'o'
        , 'Õ'    => 'O'
        , 'õ'    => 'o'
        , 'Ø'    => 'O'
        , 'ø'    => 'o'
        , 'ₒ'    => 'o'
        , 'Ö'    => 'Oe'
        , 'ö'    => 'oe'
        , 'Œ'    => 'Oe'
        , 'œ'    => 'oe'
        , 'ß'    => 'ss'
        , 'Š'    => 'S'
        , 'š'    => 's'
        , 'ş'    => 's'
        , 'Ş'    => 'S'
        , '™'    => 'TM'
        , 'Ù'    => 'U'
        , 'ù'    => 'u'
        , 'Ú'    => 'U'
        , 'ú'    => 'u'
        , 'Û'    => 'U'
        , 'û'    => 'u'
        , 'Ü'    => 'Ue'
        , 'ü'    => 'ue'
        , 'Ý'    => 'Y'
        , 'ý'    => 'y'
        , 'ÿ'    => 'y'
        , 'Ž'    => 'Z'
        , 'ž'    => 'z'
        // misc
        , '¢'    => 'Cent'
        , '€'    => 'Euro'
        , '‰'    => 'promille'
        , '№'    => 'Nr'
        , '$'    => 'Dollar'
        , '℃'    => 'Grad Celsius'
        , '°C' => 'Grad Celsius'
        , '℉'    => 'Grad Fahrenheit'
        , '°F' => 'Grad Fahrenheit'
        // Superscripts
        , '⁰'    => '0'
        , '¹'    => '1'
        , '²'    => '2'
        , '³'    => '3'
        , '⁴'    => '4'
        , '⁵'    => '5'
        , '⁶'    => '6'
        , '⁷'    => '7'
        , '⁸'    => '8'
        , '⁹'    => '9'
        // Subscripts
        , '₀'    => '0'
        , '₁'    => '1'
        , '₂'    => '2'
        , '₃'    => '3'
        , '₄'    => '4'
        , '₅'    => '5'
        , '₆'    => '6'
        , '₇'    => '7'
        , '₈'    => '8'
        , '₉'    => '9'
        // Operators, punctuation
        , '±'    => 'plusminus'
        , '×'    => 'x'
        , '₊'    => 'plus'
        , '₌'    => '='
        , '⁼'    => '='
        , '⁻'    => '-' // sup minus
        , '₋'    => '-' // sub minus
        , '–'    => '-' // ndash
        , '—'    => '-' // mdash
        , '‑'    => '-' // non breaking hyphen
        , '․'    => '.' // one dot leader
        , '‥'    => '..'  // two dot leader
        , '…'    => '...'  // ellipsis
        , '‧'    => '.' // hyphenation point
        , ' '    => '-'   // nobreak space
        , ' '    => '-'   // normal space
    );

    $str = strtr( $str, $utf8 );
    return trim( $str, '-' );
  }