<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Dashboard_model extends CI_Model {
    function get_status_cor($status)
    {
        switch ($status) {
            case 'NOVO TICKET':
                $cor = 'vermelho';
            break;
            case 'Aguardando Atendimento':
                $cor = 'preto';
            break;
            case 'Processando ':
                $cor = 'amarelo';
            break;
            case 'Aguardando Resposta':
                $cor = 'amarelo';
            break;
            case 'Respondindo':
                $cor = 'azul';
            break; 
            case 'Finalizado':
                $cor = 'verde';
            break;
            default:
               $cor = 'preto'; 
        } 
        return $cor;
    }

    function get_status_cor_avisos($status)
    {
        switch ($status) {
            case 'Novo':
                $cor = 'vermelho';
            break;
            case 'Contabilizado':
                $cor = 'verde';
            break;
            case 'A contabilizar':
                $cor = 'preto';
            break;
            case 'A pagar':
                $cor = 'amarelo';
            break;
            case 'Pendente':
                $cor = 'amarelo';
            break; 
            case 'Acessado':
                $cor = 'azul';
            break;
            case 'Pago':
                $cor = 'azul';
            break;  
            case 'Cancelado':
                $cor = 'cinza';
            break;                                                                                                                                 
            default:
               $cor = 'preto';
        } 
        return $cor;
    }

    public function get_client_info($client_id = null)
    {
        $this->db->where('client_id', $client_id);
        $this->db->limit(1);
        return $this->db->get('client')->row();
    }
    
    /*
    function get_client_mov_mes($client_id, $data_mes, $data_ano)
    {
        
        $query = $this->db->query('
        SELECT
          *
          FROM
          mov
          WHERE
          client = '.$client_id.' AND
          MONTH(DATE) = '.$data_mes.' AND 
          YEAR(DATE) = '. $data_ano);
          
        return count($query->result_array());
    }*/
    
    function tickets_aberto($alterdata)
    {             
        $query = $this->db->query("
        SELECT * from w_ticket_cliente where alterdata='".$alterdata."' AND STATUS != 'FINALIZADO'");
          
        return count($query->result_array());
    }

    function get_client_pj_pf($client_id,$field='pj_pf')
    {
        return	@$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    
    function get_graficos_info($client_id)
    {
        return @$this->db->query('
          SELECT
            client, 
            YEAR(DATE) AS ano, 
            MONTH(DATE) AS mes, 
            tipo_mov, 
            COUNT('.$client_id.') AS qtd, 
            SUM(valor) AS faturamento
          FROM
            mov
          WHERE
            client = '.$client_id.' AND
            date LIKE "2020-%"
          GROUP BY
            YEAR(DATE),
            MONTH(DATE),
            tipo_mov')->result_array();
    }
    
    function get_graficos_info_entradas($client_id)
    {
        return @$this->db->query('
          SELECT 
            YEAR(DATE) AS ano, 
            MONTH(DATE) AS mes,  
            COUNT('.$client_id.') AS qtd,
            SUM(valor) AS faturamento
          FROM
            mov
          WHERE
            client = '.$client_id.' AND
            date LIKE "2023-%" AND
            tipo_mov = "E"
          GROUP BY
            YEAR(DATE),
            MONTH(DATE),
            tipo_mov')->result_array();
    }
    
        function get_graficos_info_saidas($client_id)
    {
        return @$this->db->query('
          SELECT
            YEAR(DATE) AS ano, 
            MONTH(DATE) AS mes, 
            COUNT('.$client_id.') AS qtd,
            SUM(valor) AS faturamento
          FROM
            mov
          WHERE
            client = '.$client_id.' AND
            date LIKE "2023-%" AND
            tipo_mov = "S"
          GROUP BY
            YEAR(DATE),
            MONTH(DATE),
            tipo_mov')->result_array();
    }
   
    public function getQtdAvisos($client_id)
    {
        $query = @$this->db->get_where('w_aviso_aberto_qtd', array('client' => $client_id))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->n_aviso;
        }
        else {
            return false;
        }
    }

    public function getLogContrato($client_id)
    {
        $query = @$this->db->get_where('client_contrato',array('cliente' => $client_id,'tipo' => 'sistema'))->result_array();

        if ($this->db->affected_rows() > 0) {
            return $query;
        } else {
            return false;
        }
    }
    
    public function getLogTermo_Uso_Suporte($client_id)
    {
        $query = @$this->db->get_where('client_contrato',array('cliente' => $client_id,'tipo' => 't_u_suport'))->result_array();

        if ($this->db->affected_rows() > 0) {
            return $query;
        } else {
            return false;
        }
    }    
    
    public function getNaoNfmesAnterior($client_id)
    {
        $query = @$this->db->get_where('w_clientes_alterta_sem_envio_nota', array('client_id' => $client_id))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->notas_enviadas;
        } else {
            return false;
        }
    }

    public function getQtdGuiaImpostosDas($client_id)
    {
        $query = @$this->db->get_where('w_aviso_guias_impostos_aberto_qtd', 
                                array('client' => $client_id, 'tipo'=> 'DAS'))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->n_aviso;
        } else {
            return false;
        }                        
    }

    public function getQtdGuiaImpostosFolha($client_id)
    {
        $query = @$this->db->get_where('w_aviso_guias_impostos_aberto_qtd', 
                                array('client' => $client_id, 'tipo'=> 'FOLHA'))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->n_aviso;
        } else {
            return false;
        }                        
    }

    public function getQtdGuiaImpostosDarf($client_id)
    {
        $query = @$this->db->get_where('w_aviso_guias_impostos_aberto_qtd', 
                                array('client' => $client_id, 'tipo'=> 'DARF'))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->n_aviso;
        } else {
            return false;
        }                        
    }

    public function getQtdGuiaImpostosImpostos($client_id)
    {
        $query = @$this->db->get_where('w_aviso_guias_impostos_aberto_qtd', 
                        array('client' => $client_id, 'tipo'=> 'IMPOSTOS'))->row();

        if ($this->db->affected_rows() > 0) {
            return $query->n_aviso;
        } else {
            return false;
        }                        
    }

    function get_type_name_by_id($type, $type_id='', $field='name')
    {
        return	@$this->db->get_where($type,array($type.'_id'=>$type_id))->row()->$field;
    }

    function get_count_notificacao_extra($client_id)
    {
        $contador = 0;
        //$data_atual = date('Y-m-d');
        $XQuery = "select count('.$client_id.') as qtde from client_notificacao_extra where cliente='".$client_id."' and status in ('A','P')";
        $contador = @$this->db->query($XQuery)->row()->qtde;        

        //print $contador;
        return	$contador;
    }

    function get_log_acesso($client_id)
    {
        //$this->db->count_all_results('log_acesso');
        $this->db->where('user', $client_id);
        $this->db->where('tipo =', 'accesso');
        $this->db->from('log_acesso');

        return	@$this->db->count_all_results();
    }


/* Retirada WRP - 22/12/2020 - 	
public function get_count_cobranca($client_id = null)
	{
        $contador = 0;
        $data_atual = date('Y-m-d');
        
        $this->db->count_all_results('files');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->where('product', '60'); 
        $this->db->where('ind_up', 'C');
        $this->db->where('status !=', 'pago');
        $this->db->where('status !=', 'cancelado');
        $this->db->where('status !=', 'pago + nf salva');
        $this->db->where('data_venc <=', $data_atual);
        $this->db->from('files');
        
        $contador =  @$this->db->count_all_results();
        
        $this->db->count_all_results('w_cliente_mensalidade_aviso');  // Produces an integer, like 25
        $this->db->where('cliente', $client_id);
        $this->db->where('status_boleto !=', 'pago');
        $this->db->where('status_boleto !=', 'cancelado');
        $this->db->where('status_boleto !=', 'pago + nf salva');
        $this->db->where('dias_vencido >=', 1);
        $this->db->from('w_cliente_mensalidade_aviso');
        
        $contador =  $contador +  @$this->db->count_all_results();

        return	$contador;
    }
*/
    function get_mensagem_notificacao_extra($client_id,$field='mensagem')
    {
        return	@$this->db->get_where('client_notificacao_extra',array('cliente'=>$client_id,'status'=>'A'))->row()->$field;
    }
/** WRP - 2020-03-02
Pega um CNPJ ou CPF
**/
  
    function get_client_cnpj_cpf($client_id,$field='cnpj_cpf')
    {
        return	@$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    } 
/** FIM - WRP - 2020-03-02 **/    
    
/** WRP - 2020-03-02
Pega um valor e atribui a mascara
**/
  
  function mask($val, $mask)
  {
  
   $maskared = '';
   $k = 0;
   for($i = 0; $i<=strlen($mask)-1; $i++)
   {
     if($mask[$i] == '#')
     {
     if(isset($val[$k]))
      $maskared .= $val[$k++];
     }
     else
     {
     if(isset($mask[$i]))
      $maskared .= $mask[$i];
     }
   }
   return $maskared;
  } 
/** FIM - WRP - 2020-03-02 **/ 

    function get_alterdata_by_client($client_id,$field='alterdata')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_name_by_client($client_id,$field='name')
    {
        return @$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    function get_email_by_client($client_id,$field='email')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
    
    /* PEGA BOLETOS EM ABERTO */     
    function get_count_cobranca($client_id)
    {
        $contador = 0;
        $data_atual = date('Y-m-d');

/*        
        $this->db->count_all_results('files');  // Produces an integer, like 25
        $this->db->where('client', $client_id);
        $this->db->where('product', '60'); 
        $this->db->where('ind_up', 'C');
        $this->db->where('status !=', 'pago');
        $this->db->where('status !=', 'cancelado');
        $this->db->where('status !=', 'pago + nf salva');
        $this->db->where('data_venc <=', $data_atual);
        $this->db->from('files');
        
        $contador =  @$this->db->count_all_results();
*/
/* WRP 13/07/2023
        $this->db->count_all_results('w_cliente_mensalidade_aviso');  // Produces an integer, like 25
        $this->db->where('cliente', $client_id);
        $this->db->where('status_boleto !=', 'pago');
        $this->db->where('status_boleto !=', 'cancelado');
        $this->db->where('status_boleto !=', 'pago + nf salva');
        $this->db->where('dias_vencido >=', 1);
        $this->db->from('w_cliente_mensalidade_aviso');
*/        

        $this->db->count_all_results('w_client_mensalidade_boleto');  // Produces an integer, like 25
        $this->db->where('cliente', $client_id);
        $this->db->where('status !=', 'pago');
        $this->db->where('status !=', 'cancelado');
        $this->db->where('status !=', 'pago + nf salva');
        $this->db->where('status !=', 'enviado');
        $this->db->from('w_client_mensalidade_boleto');


        $contador =  $contador +  @$this->db->count_all_results();
        

        return	$contador;
    }
function get_usa_contabilidade_completa($client_id)
    {     
        
        $field1 = 'contabilidade_completa_mei';
        $field2 = 'pj_pf';
        $usaCompleto = 'N';
       
        $xContabCompleta = '';
        $xContabCompleta = $this->db->get_where('client_config',array('client'=>$client_id))->row()->$field1;
        
        $xTipoEmpresa = '';
        $xTipoEmpresa = $this->db->get_where('client',array('client_id'=>$client_id))->row()->$field2;
               
        if ($xTipoEmpresa != '2') {
            $usaCompleto = 'S';
        } elseif ($xContabCompleta == 'S') {
            $usaCompleto = 'S';
        } else {
            $usaCompleto = 'N';
        }
     
        return ($usaCompleto) ;
    } 
function get_client_usa_dp($client_id,$field='usa_dp')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    } 
function get_client_nota_fiscal($client_id,$field='usa_nota_fiscal')
    {
        return	$this->db->get_where('client',array('client_id'=>$client_id))->row()->$field;
    }
function get_client_certificado_vencimento($client_id,$field='data_venc')
    {
        return @$this->db->query("SELECT cliente, data_venc FROM client_certificado WHERE cliente =".$client_id)->row()->$field;
    }                   

function get_client_pacote($client_id,$field='pacote')
    {
        return @$this->db->query("SELECT client, pacote FROM client_config WHERE client =".$client_id)->row()->$field;
    }                   

} 
