<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Movimentacoes_model extends CI_Model {
    function get_status_cor($status)
    {
        switch ($status) {
            case 'Novo':
                $cor = 'vermelho';
            break;
            case 'Contabilizado':
                $cor = 'verde';
            break;
            case 'A contabilizar':
                $cor = 'preto';
            break;
            case 'A pagar':
                $cor = 'amarelo';
            break;
            case 'Pendente':
                $cor = 'amarelo';
            break; 
            case 'Acessado':
                $cor = 'azul';
            break;
            case 'Pago':
                $cor = 'azul';
            break;  
            case 'Cancelado':
                $cor = 'cinza';
            break;                                                                                                                                 
            default:
               $cor = 'preto';
        } 
        return $cor;
    }
    
    function get_arquivo($caminho, $client_id)
    {
        return $this->db->get_where('files', array('path' => $caminho, 'client' => $client_id))->row();
    }
         
    function get_client_config_permite_retroativo($cliente,$field='permite_retroativo')
    {
        return $this->db->get_where('client_config', array('client' => $cliente))->row()->$field;
    }

    function get_client_info($client_id)
    {
        $query	=	$this->db->get_where('client', array('client_id' => $client_id));
        return $query->result_array();
    }
    
    function arquivo_existente($file_name)
    {
        $query = $this->db->get_where('files', array('file' => $file_name))->result_array();
        
        if(count($query) == 0) {
            return true;
        } else {
            return false;
        }
    }

    public function listar_extrato($client_id)
    {
        $this->db->where([
            'product' => '62', 
            'client' => $client_id,
            'ind_up' => 'U'
        ]);
        $this->db->order_by('date', 'DESC');
        return $this->db->get('files')->result_array();
    }
    
        public function listar_movimentacoes($client_id)
    {
        $this->db->where([ 
            'client' => $client_id,
        ]);
        $this->db->order_by('date', 'DESC');
        return $this->db->get('w_mov')->result_array();
    }
    
}