<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><?= $titulo; ?></h1>
    <ol class="breadcrumb">
        <li><a href="<?php echo base_url('admin'); ?>"><i class="fa fa-dashboard"></i> Home</a></li>
        <?php 
        if (isset($navegacao)) {
            echo '<li><a href="'.base_url($navegacao['link']).'">'.$navegacao['titulo'].'</a></li>';
        }
        ?>
        <li class="id ?>"><?php echo $titulo; ?></li>
    </ol>
</section>

<!-- Main content -->
<section class="content">

<!-- Default box -->
<div class="box">
    <div class="box-header with-border">

        <div class="row margin-bottom-20">
            <div class="col-md-12 text-right">
                <a href="<?php echo base_url('admin/gestao_clientes'); ?>" title="voltar" class="btn btn-primary"><i class="fa fa-arrow-left"></i> Voltar</a>
            </div>
        </div>

        <form method="post" class="form-horizontal" action="<?php echo base_url('admin/clientes/core'); ?>">

        <?php // Mensagens
        errosValidacao();
        getMsg('msgCadastro');
        ?>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Nome</label>
                <div class="col-sm-6">
                    <input type="text" name="name" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->name : set_value('name')) ?>" placeholder="Nome">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Telefone</label>
                <div class="col-sm-6">
                    <input type="text" name="phone" class="form-control input_telefone" 
                    value="<?= ($dados != NULL ? $dados->phone : set_value('phone')) ?>" placeholder="Telefone">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">CPF</label>
                <div class="col-sm-6">
                    <input type="text" name="cnpj_cpf" class="form-control input_cpf" 
                    value="<?= ($dados != NULL ? $dados->cnpj_cpf : set_value('cnpj_cpf')) ?>" placeholder="CPF">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Data Nascimento</label>
                <div class="col-sm-6">
                    <input type="text" name="creation_date" class="form-control input_data" 
                    value="<?= ($dados != NULL ? formataDataView($dados->creation_date) : set_value('creation_date')) ?>" placeholder="Data Nascimento">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">CEP</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_cep" class="form-control input_cep" 
                    value="<?= ($dados != NULL ? $dados->addr_cep : set_value('addr_cep')) ?>" placeholder="CEP">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Cidade</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_cidade" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->addr_cidade : set_value('addr_cidade')) ?>" placeholder="Cidade">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Endereço</label>
                <div class="col-sm-6">
                    <input type="text" name="address" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->address : set_value('address')) ?>" placeholder="Endereço">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Número</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_n" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->addr_n : set_value('addr_n')) ?>" placeholder="Número">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Bairro</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_bairro" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->addr_bairro : set_value('addr_bairro')) ?>" placeholder="Bairro">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">UF</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_estado" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->addr_estado : set_value('addr_estado')) ?>" placeholder="UF">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Complemento</label>
                <div class="col-sm-6">
                    <input type="text" name="addr_comp" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->addr_comp : set_value('addr_comp')) ?>" placeholder="Complemento">
                </div>
            </div>

            <div class="form-group">
                <label class="col-sm-2 control-label" for="">Email</label>
                <div class="col-sm-6">
                    <input type="email" name="contact_email" class="form-control" 
                    value="<?= ($dados != NULL ? $dados->contact_email : set_value('contact_email')) ?>" placeholder="Email">
                </div>
            </div>

            <!-- <div class="form-group">
                <label class="col-sm-2 control-label" for="">Ativo</label>
                <div class="col-sm-2">
                    <select name="ativo" class="form-control">
                    <?php if($dados): ?>
                        <option value="0"<?= ($dados->ativo == 0 ? 'selected' : '') ?> >Não</option>
                        <option value="1"<?= ($dados->ativo == 1 ? 'selected' : '') ?> >Sim</option>
                    <?php else: ?>
                        <option value="0">Não</option>
                        <option value="1" selected>Sim</option>
                    <?php endif; ?>
                    </select>
                </div>
            </div> -->

            <input type="hidden" name="id_cliente" value="<?= ($dados != NULL ? $dados->client_id : set_value('id_cliente')) ?>">

            <div class="form-group">
                <div class="col-sm-offset-2 col-sm-10">
                    <button type="submit" class="btn btn-primary"> Salvar </button>
                </div>
            </div>

        </form>
        
    </div>
</div>
<!-- /Default box -->

</section>
<!-- /.content -->