<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><?= $titulo; ?></h1>
    <ol class="breadcrumb">
        <li><a href="<?= base_url('dashboard'); ?>"><i class="fa fa-dashboard"></i> Home</a></li>
        <li class="active"><?= $titulo; ?></li>
    </ol>
</section>

<!-- Main content -->
<section class="content">
    
<!-- Default box -->
<div class="box">
    <div class="box-header with-border">

        <?php // Mensagens
        getMsg('msgCadastro');
        ?>

        <form action="<?= base_url('notafiscal/nfs_tomadas'); ?>" method="post">

        <div class="container-fluid">
            <div class="row">
                <label for="data_inicial">Data Inicial</label>
                <input type="date" name="data_inicial" id="data_inicial" >
            </div>

            <div class="row">
                <label for="data_final">Data Final</label>
                <input type="date" name="data_final" id="data_final">
            </div>

            <br>
            <button type="submit">BUSCAR</button>
        </div>
        </form>

        <br><br>

        <table class="table table-bordered table-listar-data-table">
            <thead>
                <tr>
                    <th><div><?php echo 'Prestador' ?></div></th>
                    <th><div><?php echo 'CNPJ' ?></div></th>
                    <th><div><?php echo 'Número Nfs' ?></div></th>
                    <th><div><?php echo 'status' ?></div></th>
                    <th><div><?php echo 'Valor' ?></div></th>
                    <th><div><?php echo 'Data' ?></div></th>
                    <th><div><?php echo 'Ações' ?></div></th>
                </tr>
            </thead>

            <tbody>
                <?php foreach($response->records as $registro): ?>
                <tr>
                    <td><?= $registro->empresa->razaoSocial ;?></td>
                    <td><?= $registro->empresa->cnpj ;?></td>
                    <td><?= $registro->numero;?></td>
                    <td><?= $registro->status;?></td>
                    <td><?= 'R$ ' . number_format($registro->valorTotal, 2, ',', '.'); ?>
                    <td><?= date('d/m/Y', strtotime($registro->dataCriacao));?></td>
                    <td>
                        <a class="btn btn-default" href="<?= $registro->linkDownloadPDF;?>" role="button" target="_blank">PDF</a>
                        <a class="btn btn-default" href="<?= $registro->linkDownloadXML;?>" role="button" target="_blank">XML</a>
                    </td>                 
                </tr>
                <?php endforeach;?>
            </tbody>
        </table>
        
    </div>
</div>
<!-- /Default box -->

</section>
<!-- /.content -->