<!-- Content Header (Page header) -->
<section class="content-header">
    <h1><?= $titulo; ?></h1>
    <ol class="breadcrumb">
        <li><a href="<?= base_url('dashboard'); ?>"><i class="fas fa-tachometer-alt"></i> Home</a></li>
        <li class="active"><?= $titulo; ?></li>
    </ol>
</section>

<!-- Main content -->
<section class="content">

<!-- Default box -->
<div class="box">
    <div class="box-header with-border">

    <?php // Mensagens
    getMsg('msgCadastro');
    ?>

    <ul class="nav nav-tabs nav-tabs-left">
        <li class="active">
            <a href="#list" data-toggle="tab"><i class="fas fa-align-justify"></i> <?php echo 'Controle da Sociedade'; ?></a>
        </li>
        <li>
            <a href="#add" data-toggle="tab"><i class="fas fa-comment"></i> <?php echo 'Informações dos Sócios'; ?></a>
        </li>
    </ul>   

    <div class="tab-content">           
        <!---- TABLE LISTING STARTS- -->
        <div class="tab-pane active" id="list">

            <div class="action-nav-normal">
                <div class="titulo-alternativo-botao">
                    <h3>Total de Sócios Cadastrados: <?php echo $total_socios ?></h3>
                </div>
                <!-- /titulo-alternativo-botao -->                
            </div>

            <div class="box-content">
                    <table id="" class="display" style="width:100%">
                        <thead>
                        <tr>
                            <th>Cod</th>
                            <th>Sócio</th>
                            <th>Cota</th>
                            <th>Administrador?</th>
                            <th>Tem Pro Labore</th>
                            <th>Valor Pro Labore</th>
                            <th>Opções</th>
                        </tr>
                        </thead>

                        <tbody>
                        <?php $count = 1;
                        foreach ($pro_labore as $row): ?>
                            <tr>
                                <td><?php echo $count++; ?></td>
                                <td><?php echo $row['name']; ?></td>
                                <td align="center"><?php echo $row['cota']; ?> %</td>
                                <td align="center"><?php if ($row['administrador'] == '1') {
                                        echo 'SIM';
                                    } else {
                                        echo 'NÃO';
                                    }; ?></td>
                                <td align="center"><?php if ($row['tem_pl'] == '1') {
                                        echo 'SIM';
                                    } else {
                                        echo 'NÃO';
                                    }; ?></td>
                                <td align="center"><?php echo 'R$ ' . number_format($row['pl_valor'], 2, ',', '.'); ?></td>
                                <td align="center">
                                    <a href="<?php echo base_url('prolabore/pro_labore_editar/editar/'.$row['client_socio_id']); ?>" class="btn btn-default">
                                        <span style="font-size 16px;">                                     
                                            <i class="fas fa-pencil-alt"></i>
                                        </span> Editar
                                    </a>
                                </td>
                            </tr>                                    
                        <?php endforeach; ?>                                
                        </tbody>
                    </table>
            </div>

        </div><!----TABLE LISTING ENDS--->

        <!-- INICIO DO MODAL EDITAR -->
        <div class="modal fade" id="modal_pro_labore_editar" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">

                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times; </span></button>
                        <h4 class="modal-title" id="myModalLabel"><i class="fas fa-arrow-circle-up"></i> Editar</h4>
                    </div>

                    <div class="modal-body">
                        <div class="tab-pane">
                            <div class="box-content">                                
                                <?php foreach ($pro_labore as $row): ?><?php echo form_open('prolabore/pro_labore/do_update/' . $row['client_socio_id'], array('class' => 'form-horizontal validatable', 'target' => '_top', 'enctype' => 'multipart/form-data')); ?>
                                    <div class="padded">
                                        <div class="formulario-modal">

                                            <div class="row">
                                                <div  class="col-md-6">                                        
                                                <?php echo '<font size=4>Última Alteração: </font>' . date('d/m/Y', strtotime($row['alt_date'])); ?>
                                                    <input type="hidden" name="alt_date" value="<?php echo(date('Y-m-d')); ?>"/>
                                                </div>
                                            </div><!-- Final da Row-->
                                                  

                                            <div class="row">
                                                <div class="col-md-3"><p>Nº Pis:</p>                                        
                                                    <input type="text" value="<?php echo $row['pis'] ?>" name="pis" class="formulario-inteiro"/>
                                                </div>
                                            </div><!--Final da Row-->

                                            <div class="row">
                                                <div class="col-md-2"><p>DDD:</p>                                        
                                                    <input type="text" value="<?php echo $row['ddd_phone'] ?>" class=" formulario-inteiro" name="ddd_phone"/>
                                                </div>

                                                <div class="col-md-4"><p>Telefone:</p>                                        
                                                    <input type="text" value="<?php echo $row['phone'] ?>" class=" formulario-inteiro" name="phone"/>
                                                </div>
                                                
                                                <div class="col-md-6"><p>E-mail:</p>                                        
                                                    <input type="email" value="<?php echo $row['email'] ?>" name="email" class="formulario-inteiro"/>
                                                </div>
                                            </div><!-- /row -->     

                                        </div><!-- /formulario-modal -->
                                    </div><!-- /padded -->

                                    <hr>
                                    <br>
                                    
                                    <div class="form-actions">
                                        <button type="button" class="btn btn-gray botao-verde" data-dismiss="modal">Salvar</button>
                                        <button type="button" class="btn btn-gray botao-fechar" data-dismiss="modal">Fechar</button>
                                    </div>    

                                </form>                    
                                <?php endforeach; ?>                
                            </div><!-- Box Content-->
                        </div><!--Final da Tab pane-->
                    </div><!--Final do modal body-->
                </div><!--Final do modal content-->
            </div><!--Final modal dialog--> 
        </div> <!-- /fim-modal -->           
        
        <!----CREATION FORM STARTS---->
        <div class="tab-pane" id="add">
            <div class="action-nav-normal">
                <div class="titulo-alternativo-botao">
                    <h3>Total de Sócios Cadastrados: <?php echo $total_socios; ?></h3>
                </div>
            </div>

            <!-- /titulo-alternativo-botao -->
            <div class="box-content">
                    <table class="display" id="exemplo2" style="width:100%">
                        <thead>
                        <tr>
                            <th>Cod</th>
                            <th>Sócio</th>
                            <th>Email</th>
                            <th>Telefone</th>
                            <th>Opções</th>
                        </tr>
                        </thead>
                        <tbody>
                        <?php $count = 1;
                        foreach ($pro_labore as $row): ?>
                            <tr>
                                <td><?php echo $count++; ?></td>
                                <td align="center"><?php echo $row['name']; ?></td>
                                <td align="center"><?php echo $row['email']; ?></td>
                                <td align="center">(<?php echo $row['ddd_phone']; ?>) <?php echo $row['phone']; ?></td>
                                <td align="center">
                                    <a href="<?php echo base_url('prolabore/pro_labore_visualizar/visualizar/'.$row['client_socio_id']); ?>" target='_blank' class="btn btn-default">
                                        <span style="font-size 16px;"> 
                                            <i class="fas fa-eye"></i>
                                        </span> Visualizar
                                    </a>                                    
                                </td>
                            </tr>                                    
                        <?php endforeach; ?>                                
                    </tbody>
                    </table>
            </div>
        </div> <!----CREATION FORM ENDS- -->        
    </div>


    <!-- INICIO DO MODAL VISUALIZAR -->
    <div class="modal fade" id="modal_pro_labore_visualizar" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <div class="modal-dialog" role="document">
            <div class="modal-content">

                <div class="modal-header"> 
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times; </span></button>
                    <h4 class="modal-title" id="myModalLabel"><i class="fas fa-arrow-circle-up"></i> DADOS</h4>
                </div>

                <div class="modal-body">
                    <div class="tab-pane">
                        <div class="box-content">                                
                            <?php
                                $current_client_socio_id = $this->session->userdata('client_id');                                                                            
                                $client_socio_info	=	$this->prolabore_model->get_client_socio_info($current_client_socio_id);
                            foreach ($client_socio_info as $row): ?>
                                <div class="padded">
                                    <div class="formulario-modal">

                                        <div class="row">
                                            <div  class="col-md-6">                                        
                                                <td><?php echo 'Documento (CNPJ / CPF)';?></td>
                                                <td><b><?php echo $row['cnpj_cpf'];?></b></td>
                                            </div>
                                        </div>

                                        <div class="row">
                                             <div  class="col-md-12">
                                             <p style="color:red">Por Favor solicitar ticket referente a alteração do valor do  ProLabore.</p>
                                             <a href="https://contsimples.com.br/contsimples/sistemaw/fale_conosco/index.php"><p>(Clique aqui)</p></a>
                                             </div> 
                                        </div>
                                        <hr>          
                                         
                                         <div class="row">
                                            <div class="col-md-4"><p>Contato/Apelido:</p>                                        
                                                <input type="text" value="<?php echo $row['contact'] ?>" name="contact" class="form-control" readonly/>
                                            </div>
                                            
                                            <div class="col-md-3"><p>Nº Pis:</p>                                        
                                                <input type="text" value="<?php echo $row['pis'] ?>" name="pis" class="form-control" readonly/>
                                            </div>
                                              
                                            <div class="col-md-3">
                                                <p>Valor Pro Labore:</p>
                                                <input type="text" class=" form-control valreal" name="pl_valor" min="800" value="<?php echo'R$ ' . $row['pl_valor']?>" readonly />
                                            </div>                                     
 
                                        </div><!--Final da Row-->
                                        <hr>
                                           <p><h4>Informações de Contato:</h4></p>
                                        <br>   
                                        <div class="row">
                                            <div class="col-md-2"><p>DDD:</p>                                        
                                                <input type="text" value="<?php echo '('. $row['ddd_phone'] .')' ?>" class="form-control" name="ddd_phone" readonly/>
                                            </div>

                                            <div class="col-md-4"><p>Telefone:</p>                                        
                                                <input type="text" value="<?php echo $row['phone'] ?>" class="form-control" name="phone" readonly/>
                                            </div>

                                            <div class="col-md-6"><p>E-mail:</p>                                        
                                                <input type="email" value="<?php echo $row['email'] ?>" name="email" class="form-control" readonly/>
                                            </div>
                                        </div><!-- /row -->
                                        <hr>     

                                    </div><!-- /formulario-modal -->
                                </div><!-- /padded -->
    

                            <?php endforeach; ?>                
                        </div>
                    </div>
                </div>
            </div>
        </div> 
    </div> <!-- /fim-modal -->    


    </div>                                
</div>
<!-- /Default box -->
</section>

<script type="text/javascript">
$(document).ready(function() {
  <?php if($this->session->flashdata('flash_message')){ ?>
    alert("<?php echo $this->session->flashdata('flash_message'); ?>");
  <?php } ?>
});
</script>

<script type="text/javascript" src="<?php echo base_url('public/js/tabela.js');?>"></script>

<script type="text/javascript" src="<?php echo base_url('public/js/datamask.js');?>"></script>