$(document).ready( function () {

    /* Confirmar antes de apagar um registro */
    $('.btn-apagar-registro').on('click', function() {
        if(confirm("Tem certeza?")) {
            return true;
        } else {
            return false;
        }
    });

    /* Script plugin mask */
    $('.input_data').mask('00/00/0000');
    $('.input_cpf').mask('000.000.000-00', {reverse: false});
    $('.input_cnpj').mask('00.000.000/0000-00', {reverse: false});
    
    // Mask for CPF and CNPJ in the same input
    $(".cpfcnpj").keydown(function(){
        try {
            $(".cpfcnpj").unmask();
        } catch (e) {}
    
        var tamanho = $(".cpfcnpj").val().length;
    
        if(tamanho < 11){
            $(".cpfcnpj").mask("000.000.000-00", {reverse: false});
        } else {
            $(".cpfcnpj").mask("00.000.000/0000-00", {reverse: false});
        }
    
        // ajustando foco
        var elem = this;
        setTimeout(function(){
            // mudo a posição do seletor
            elem.selectionStart = elem.selectionEnd = 10000;
        }, 0);
        // reaplico o valor para mudar o foco
        var currentValue = $(this).val();
        $(this).val('');
        $(this).val(currentValue);
    });
    
    $('.input_cep').mask('00000-000');
    $('.input_valor').mask('000.000.000.000.000,00', {reverse: true});
    var SPMaskBehavior = function (val) {
        return val.replace(/\D/g, '').length === 11 ? '(00) 00000-0000' : '(00) 0000-00009';
      },
      spOptions = {
        onKeyPress: function(val, e, field, options) {
            field.mask(SPMaskBehavior.apply({}, arguments), options);
          }
      };
    
    $('.input_telefone').mask(SPMaskBehavior, spOptions);

    /* Script plugin data-table */
    $('.sidebar-menu').tree();
    $('.table-listar-data-table').DataTable({
        "language": {
            "sEmptyTable": "Nenhum registro encontrado",
            "sInfo": "Mostrando de _START_ até _END_ de _TOTAL_ registros",
            "sInfoEmpty": "Mostrando 0 até 0 de 0 registros",
            "sInfoFiltered": "(Filtrados de _MAX_ registros)",
            "sInfoPostFix": "",
            "sInfoThousands": ".",
            "sLengthMenu": "_MENU_ resultados por página",
            "sLoadingRecords": "Carregando...",
            "sProcessing": "Processando...",
            "sZeroRecords": "Nenhum registro encontrado",
            "sSearch": "Pesquisar",
            "oPaginate": {
                "sNext": "Próximo",
                "sPrevious": "Anterior",
                "sFirst": "Primeiro",
                "sLast": "Último"
            },
            "oAria": {
                "sSortAscending": ": Ordenar colunas de forma ascendente",
                "sSortDescending": ": Ordenar colunas de forma descendente"
            }
        }
    });

    // GRAFICOS
    $(function() {
    
        //INITIALIZE SPARKLINE CHARTS
        $(".sparkline").each(function () {
            var $this = $(this);
            $this.sparkline('html', $this.data());
        });
    });

    /* The todo list plugin */
    $('.todo-list').todoList({
        onCheck  : function () {
        window.console.log($(this), 'The element has been checked');
        },
        onUnCheck: function () {
        window.console.log($(this), 'The element has been unchecked');
        }
    });

    /* Função para Abrir Modal Movimentações */
    $(document).on('click', '.btn-mudar-status-pedido', function() {

        var id = $(this).attr('data-id');

        $.ajax({
            type: "GET",
            url: "http://localhost/contsimples_new/sistema/notafiscal/pegainfodest/"+id,
            dataType: "json",
            success: function(resposta){

        $('.modal_dinamico').append('<div class="modal fade" id="modal_pedido'+id+'" tabindex="-1" role="dialog">'+
            '<div class="modal-dialog" role="document">'+
                '<div class="modal-content">'+
                '<div class="modal-header">'+
                    '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+
                    '<h4 class="modal-title">Informar '+id+'</h4>'+
                '</div>'+
                '<div class="modal-body">'+
                    '<form class="form-horizontal" method="post" action="http://localhost/contsimples_new/movimentacoes/mov_lancar/create">'+
                        '<div class="form-group">'+
                            '<label class="col-sm-1 control-label" for="">status</label>'+
                            '<div class="col-sm-5">'+
                                '<select name="status" id="status" class="form-control">'+
                                    '<option value="1">Aguardando Pagamento</option>'+
                                    '<option value="2">Pagamento Confirmado</option>'+
                                    '<option value="3">Enviado</option>'+
                                    '<option value="4">Cancelado</option>'+
                                '</select>'+
                            '</div>'+
                        '</div>'+
                    '</form>'+
                '</div>'+
                '<div class="modal-footer">'+
                    '<button type="button" class="btn btn-default" data-dismiss="modal">Fechar</button>'+
                    '<button type="button" class="btn btn-primary btn-atualizar-status-pedido">Salvar</button>'+
                '</div>'+
                '</div>'+
            '</div>'+
        '</div>');

        $('#modal_pedido'+id).modal('show');

        $('#modal_pedido'+id).on('hidden.bs.modal', function(e) {
            $(this).remove();
        });

        },
        error: function(){
            alert('Erro na requisição');
        }

        });
 
    });


    /* Função para Abrir Modal Editar Destinatario do cliente */
    $(document).on('click', '.btn-edit-dest-client', function() {

        var id_dest = $(this).attr('data-id-dest');

        $.ajax({
            type: "GET",
            url: "http://localhost/contsimples_new/sistema/notafiscal/pegainfodest/"+id_dest,
            dataType: "json",
            success: function(resposta){

        $('.modal_dinamico').append('<div class="modal fade" id="modal_edit_dest_client'+id_dest+'" tabindex="-1" role="dialog">'+
            '<div class="modal-dialog" role="document">'+
                '<div class="modal-content">'+
                '<div class="modal-header">'+
                    '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+
                    '<h4 class="modal-title">Cliente '+resposta.dest_client.dest_cliente+'</h4>'+
                '</div>'+
                '<div class="modal-body">'+
                    '<form class="form" method="post" action="http://localhost/contsimples_new/sistema/notafiscal/meus_clientes/do_update/'+resposta.dest_client.dest_cliente_id+'">'+
                        '<input type="hidden" name="dest_data" value="'+resposta.dest_client.dest_data+'">'+
                        '<input type="hidden" name="cliente" value="'+resposta.dest_client.cliente+'">'+
                        '<div class="form-group">'+
                            '<label class="" for="">Nome</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_cliente+'" name="dest_cliente" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">CPF/CNPJ</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_cnpj_cpf+'" name="dest_cnpj_cpf" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Inscrição Estadual</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_ie+'" name="dest_ie" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Inscrição Municipal</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_cmc+'" name="dest_cmc" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Data de Cadastro</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_data+'" name="" readonly="readonly" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Email</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_email+'" name="dest_email" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">DDD</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_ddd+'" name="dest_ddd" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Telefone</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_tel+'" name="dest_tel" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Informações Complementares</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_desc+'" name="dest_desc" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Endereço</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_end+'" name="dest_end" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Número</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_n+'" name="dest_n" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Complemento</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_comp+'" name="dest_comp" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Bairro</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_bairro+'" name="dest_bairro" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Cidade</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_cidade+'" name="dest_cidade" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">UF</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_uf+'" name="dest_uf" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">País</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_pais+'" name="dest_pais" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">CEP</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_cep+'" name="dest_cep" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Status</label>'+
                            '<input type="text" value="'+resposta.dest_client.dest_status+'" name="dest_status" class="form-control">'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<button type="button" class="btn btn-default form-control" data-dismiss="modal">Fechar</button>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<button type="submit" class="btn btn-primary form-control">Salvar</button>'+
                        '</div>'+
                    '</form>'+
                '</div>'+
                '<div class="modal-footer">'+                  
                '</div>'+
                '</div>'+
            '</div>'+
        '</div>');

        $('#modal_edit_dest_client'+id_dest).modal('show');

        $('#modal_edit_dest_client'+id_dest).on('hidden.bs.modal', function(e) {
            $(this).remove();
        });

        },
        error: function(){
            alert('Erro na requisição');
        }

        });
 
    });


    /* Função para Abrir Modal Info de dest cliente */
    $(document).on('click', '.btn-info-dest-client', function() {

        var id = $(this).attr('data-id-dest');

        $.ajax({
            type: "GET",
            url: "http://localhost/contsimples_new/sistema/notafiscal/pegainfodest/"+id,
            dataType: "json",
            success: function(resposta){

            console.log(resposta);

        $('.modal_dinamico').append('<div class="modal fade" id="modal_dest_info'+id+'" tabindex="-1" role="dialog">'+
            '<div class="modal-dialog" role="document">'+
                '<div class="modal-content">'+
                '<div class="modal-header">'+
                    '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>'+
                    '<h4 class="modal-title">Cliente '+resposta.dest_client.dest_cliente+'</h4>'+
                '</div>'+
                '<div class="modal-body">'+
                    '<form class="form">'+
                        '<div class="form-group">'+
                            '<label class="" for="">Nome</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_cliente+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">CNPJ/CPF</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_cnpj_cpf+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Inscrição Estadual</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_ie+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Inscrição Municipal</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_cmc+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Email</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_email+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">DDD</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_ddd+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Telefone</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_tel+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Desc</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_desc+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Endereço</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_end+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Complemento</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_comp+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Bairro</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_bairro+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Cidade</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_cidade+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">UF</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_uf+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">País</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_pais+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">CEP</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_cep+'</p>'+
                        '</div>'+
                        '<div class="form-group">'+
                            '<label class="" for="">Status</label>'+
                            '<p class="form-control">'+resposta.dest_client.dest_status+'</p>'+
                        '</div>'+
                    '</form>'+
                '</div>'+
                '<div class="modal-footer">'+
                    '<button type="button" class="btn btn-default" data-dismiss="modal">Fechar</button>'+
                '</div>'+
                '</div>'+
            '</div>'+
        '</div>');

        $('#modal_dest_info'+id).modal('show');

        $('#modal_dest_info'+id).on('hidden.bs.modal', function(e) {
            $(this).remove();
        });

        },
        error: function(){
            alert('Erro na requisição');
        }

        });
 
    });

    var today = new Date(); //Get today's date
    
    if(today.getDate() <= 15) {
        var previousDate = new Date(today.getFullYear(), today.getMonth() -1, 1); //To get the previous date of today's month*/
    } else {
        var previousDate = new Date(today.getFullYear(), today.getMonth()); //To get the previous date of today's month*/
    }
    
    var lastDate = new Date(today.getFullYear(), today.getMonth() + 1, 0); //To get the last date of today's month

    $('.datepicker').datepicker({
        format: 'dd/mm/yyyy',
        language: 'pt-BR',
        todayHighlight: 'true',
        startDate: previousDate,
        endDate: lastDate,
        autoclose: 'false'
    });

    /* Propriedades do datepicker */
    var today2 = new Date(); //Get today's date
    //var previousDate2 = new Date(today2.getFullYear(), today2.getMonth() - 18, 1); //To get the previous date of today's month*/
    var lastDate2 = new Date(today2.getFullYear(), today2.getMonth() + 1, 0); //To get the last date of today's month

    $('.datepicker_retro').datepicker({
        format: 'dd/mm/yyyy',
        language: 'pt-BR',
        todayHighlight: 'true',
        //startDate: previousDate2,
        endDate: lastDate2,
        autoclose: 'true'
    });

});
